##Namelist file online MOPEX, updated January 2, 2007 by HIT, SFA'
have_uncertainties = 1
compute_uncertainties_internally = 0
run_fiducial_image_frame = 0
run_mosaic_interp = 1
run_mosaic_outlier = 1
run_mosaic_rmask = 1
run_mosaic_reinterp = 1
run_mosaic_coadder = 1
run_mosaic_combiner = 1
##do not use weighted errors
sigma_weighted_coadd = 0
create_unc_mosaic = 1
create_std_mosaic = 0
##Do point source extraction
run_mosaic_medfilter = 1
run_gaussnoise = 1
run_pointsourceprob = 1
run_detect = 1
run_fit_radius = 0
run_sourcestimate = 1
run_aperture = 1
run_select = 1
select_conditions = "SNR > 10 and deblend ! NO and deblend ! PO and deblend ! AO"

##bits,1,7,8,12,13,14==>29058
##If igoring extrapolated stim solutions set bit-4 (add 16)
##If ignoring data near stim set bit-5 (add 32)
DCE_Status_Mask_Fatal_BitPattern = 29058
RMask_Fatal_BitPattern =  2
PMask_Fatal_BitPattern =  16648
USE_REFINED_POINTING = 0
NICE = 0
COMBINER_DIR = ./


&MEDFILTER
  Window_X = 21, 
  Window_Y = 21,
  N_Outliers_Per_Window = 50,
&END

&GAUSSNOISE
  Window_X = 21,
  Window_Y = 21,
  N_Outliers_Per_Window = 50,
&END

&POINTSOURCEPROB
# the Resample Factors are the ratios of the image pixel size to the PRF sampling size,
# the same as for SOURCESTIMATE,
  PRF_ResampleX_Factor      = 4,
  PRF_ResampleY_Factor      = 4,
# the size of the input image to be matched by the PRF,
# in input image pixels, want to cover central peak,
  PRF_Xsize        = 3,
  PRF_Ysize        = 3,
&END

&PSP_GAUSSNOISE
# block used for Input_Type =snr_input in DETECT,
  N_Outliers_Per_Window = 50,
  Window_X = 21,
  Window_Y = 21,
&END

&FIT_RADIUS
&END

&DETECT
# the maximum number of pixels in a cluster to be declared a detection,
# for bigger clusters the program raises the detection threshold, 
# and either splits the cluster into 2 or shrinks it to required size,
  Detection_Max_Area         = 50,
# the minimum number of pixels in a cluster to be declared a detection,
# smaller clusters are ignored,
  Detection_Min_Area         = 3.,
  Detection_Threshold        = 5.,
#  The options for Input_Type  are 'image_input' and  'snr_input',
  Input_Type  = 'image_input',
# the options for Threshold_Type are 'simple', 'combo' and 'peak',
  Threshold_Type = 'peak',
  Extended_Object_Area = 10000,
  Min_Coverage = 1,
  Peaks_Radius = 1,
&END

&SOURCESTIMATE
# 3 options, 'image_list' is the only option acceptable here,
  InputType = 'image_list',
# the size of the area in the input image to be fitted with PRF, in input image pixels,
# Using run_fit_radius one has to comment the two following keywords,
  Fitting_Area_X = 5,
  Fitting_Area_Y = 5,
# maximum number of point sources to use in an attempt to deblend a detection,
  Max_Number_PS = 1,
# the maximum acceptable value of chi^2/degree_of_freedom,
  Chi_Threshold = 3.,
# positive number excludes point sources in the edge around the input image, 
# N_Edge pixels wide from fitting, negative number appends an edge around,
# the input images N_Edge pixels wide to include the point sources into fitting,
# default 0,
  N_Edge = 1,
# the Resample Factors are the ratios of the image pixel size to the PRF sampling size,
  PRF_ResampleX_Factor      = 4,
  PRF_ResampleY_Factor      = 4,
#the number of fitting iterations to perform after Chi_Threshold has been reached, default = 0,
  Max_N_Success_Iteration = 1000,
#the relative change in chi2/dof to achive after Chi_Threshold has been reached, default = 0.001,
  MinimizeFtolSuccess = 0.0001,
   DitherPixelFraction = 0.1,
   DitherFluxFraction = 1.0,
  Background_Fit = 0,
&END

&APERTURE
  N_Apertures = 2,
  Aperture_Radius_1 = 5.0,
  Aperture_Radius_2 = 10.0,
&END

&MOSAICINTIN
&END

&MOSAICOUTLIERIN
THRESH_OPTION = 2,
#modify thresholds (in sigma) for more/less aggressive outlier,
   BOTTOM_THRESHOLD = 3.5, 
   TOP_THRESHOLD = 4.5, 
   MIN_PIX_NUM = 3, 
  TILE_XSIZ = 512,
  TILE_YSIZ = 512, 
&END

&MOSAICRMASKIN
 RM_THRESH = 0.5,
 MIN_COVERAGE = 3,
 MAX_COVERAGE = 100,
&END

&MOSAICREINTIN
&END

&MOSAICCOADDIN
  TILEMAX_X = 512, 
  TILEMAX_Y = 512, 
&END
  



