&EXTRACT

   # ========== Parameters for the EXTRACT module ==========
   # Updates:
   # 2008/03/14 Minor edit remove wrap-around extra line in word height (SFA)
   # 2005/08/23 Changed fatal bmask value SFA
   # 2006/10/25 Added nanDrop and height1 (for SPICE with S14 cal files) Bob
   # S17 2007/09/10 Added bit 8 (256) to fatal bits (Bob)
   # S19 2008/12/16 Divide by wavsamp height SFA

    E_height1 = 0                        USE ACTUAL WAVSAMP height (default)
    E_nanDrop = 1                        drop row if value is NaN (vs. -9999)
    E_i    = coadd2d.fits,               INPUT_ECHELLE_FITS
    E_e    = coadd2d_unc.fits,           UNCERTAINTY_FITS
    E_r    = ridge.tbl,                  INPUT_RIDGE_TBL
    E_b    = bmask.fits,                 BMASK_FITS
    E_p    = cal/b2_psf_fov.tbl,         PSF_TABLE
    E_o    = extract.tbl,                OUTPUT_TBL_FILE
    E_f    = 29056,                      BMASKFATAL
#   E_v    = 1,                          VERBOSE_LEVEL
#   E_w    = 1.5000,                     APERTURE_WIDTH
#   E_l    = 27.000,                     WAVELENGTH__OF_WIDTH
    E_norm = 1,                          NORMALIZE 2=divide by area 1=divide by height


&END

&OPTIMUM

  # Chan 2 namelist for OPTIMUM module
  # 2006/9/27 Update for C13.0.C (Bob)
  # S17 2007/09/10 Added bit 8 (256) to fatal bits (Bob)

    O_pixel_scale   5.1          # chan 2 (for rec_offsets file)
    O_clip_width    7.172        # chan 2
    O_clip_lambda0 27.0          # chan 2

    O_height1 0                  # Force wavsamp height=1.0 (0=no, 1=yes)
    O_fatal 29056                # Bmask fatal
    O_area_width 1001            # Width of rectified image
    O_keepnans 1                 # Propagate Nans into rectified image
    O_nanDrop 1                  # drop output row if value is NaN (vs. -9999)
    O_resamp 2                   # Interpolation from BCD to rectified image
    O_v 2                        # Verbose level

    O_i infile.fits              # dummy input file (required)
    O_w wavsamp.tbl              # dummy input file (required)
    O_o extract.tbl              # dummy output file (required)

&END
