&IRS_FLATFIELD
   # THIS FILE MODIFIED BY P. N. APPLETON 17 Mar 2003 for LL (b2) use
   # Parameters for the IRS FLATFIELD module
   
   #================= APPLICABLE PROGRAMS ================   
    PROG1 = 1                            ff_orig_spectrum
    PROG2 = 1                            ff_gen_BB
    PROG3 = 1                            ff_gen_spectcorr
    PROG4 = 1                            ff_calc_ffimage 
    PROG5 = 1                            ff_corr_ffimage

   #======= INPUT & OUTPUT FILES ===============
     # input spectrum either provided by IST created by ff_gen_BB
    FF_a1 = ff_orig_spectrum.tbl,            FF_ORIG_TBL
     # input image that will eventually be flattened
    FF_a2 = droopres.fits,                    FF_ORIG_IMG
     # input spectrum table created in ff_gen_BB 
    FF_b1 = ff_gen_BB.tbl,                   SC_TBL
     # 2-d fits version of input spectrum tbl by ff_gen_spectcorr
    FF_b2 = ff_gen_spectcorr.fits,           SC_IMG

     #  Final flattened image and table before interpolation  
     # Note that if no use of spectral interpolation--this would be final data
    FF_c2 = ff_calc_ffimage.fits,            FF_PRE_IMG
    FF_c1 = ff_calc_ffimage.tbl,             FF_PRE_TBL
     # If linear interpolation required across spectral features
     # then the final table and fits images follows
    FF_d1 = flatfield.tbl,                   FF_TBL
    FF_d2 = flatfield.fits,                  FF_IMG
     # interpolation is made across the following input table regions
    FF_i1 = cdf/b2_linecorr.tbl,                LC_TBL

    #=====================WAVSAMP TABLE INPUT===========================
    FF_w1 = cdf/b2_wavsamp.tbl,                 WS_TBL
    #======ordermasks created by FF--may not be same as omask.fits
    #=====Note that these masks only defined the NaNed area of final flat 
   # FF_w2 = b2_mask_ff.fits                  WS_MASK_IMG
   # FF_w3 = b2_omask_ff.fits                 WS_ORD_IMG
   #================= GENERAL SWITCHES Input BB temp ===================
    FF_tk = 300.0,                           TEMP_K

   #=========SOME SWITCHES THAT ARE IMPORTANT==P. N. Appleton 19 Mar 2003
    FF_px = 10.,                             PP_XD
    FF_py = 10.,                             PP_DS
    FF_e  = 0.5                              EDGE_FRAC
    FF_ky = 55                               YMAG_ODD
   #=========widen parameter==used for low-res only (PNA 19 Mar 2003)======
   #=========widens wavsamp by specified number of pixels===========
    FF_rw = 2                                WS_WIDEN
   #================= MASK AND ERROR FILES ===============
    FF_mp = cal/pmask.fits,                  PMASK
   # FF_md = dmask.fits,                      DMASK
    FF_mb = bmask.fits,                      BMASK
   # FF_mc = flatfield_cmask.fits,            CMASK
   # FF_si = droopres_unc.fits,               ERR_IN
   # FF_so = flatfield_unc.fits,              ERR_OUT
   
   #================= HELP AND DEBUGGING =================
   # FF_V  = 1                                VERBOSE
   # FF_D  = 1                                DEBUG
       
&END
