&EXTRACT

   # ========== Parameters for the EXTRACT module ==========
   # Updates:
   # S17 2008/02/22 Changed E_norm to 1 to divide out wavsamp height
   # S17 2007/09/10 Added bit 8 (256) to fatal bits (Bob)
   # 2006/10/25 Added nanDrop - Bob
   # 2005/08/23 Changed fatal bmask value SFA
   # 2004/09/02 added E_full; should work for both S10 and S11 - Bob

    E_nanDrop = 1                        drop row if value is NaN (vs. -9999)
    E_i    = coadd2d.fits,               INPUT_ECHELLE_FITS
    E_e    = coadd2d_unc.fits,           UNCERTAINTY_FITS
    E_r    = ridge.tbl,                  INPUT_RIDGE_TBL
    E_b    = bmask.fits,                 BMASK_FITS
    E_o    = extract.tbl,                OUTPUT_TBL_FILE
    E_f    = 29056,                      BMASKFATAL
    E_full = 1,                          FULL_WIDTH_EXTRACTION
    E_norm = 1,                          NORMALIZE 2=divide by area 1=divide by height
#   E_v    = 1,                          VERBOSE_LEVEL

&END

&OPTIMUM

  # =====  namelist for OPTIMUM module
  # Updates:
  # S17 2007/09/10 Added bit 8 (256) to fatal bits (Bob)
  # 2006/9/27 Update for C13.0.C (Bob)

    O_pixel_scale 4.5            # chan 3 (for rec_offsets file)

    O_fatal 29056                # Bmask fatal
    O_area_width 1001            # Width of rectified image
    O_keepnans 1                 # Propagate Nans into rectified image
    O_nanDrop 1                  # drop output row if value is NaN (vs. -9999)
    O_resamp 2                   # Interpolation from BCD to rectified image
    O_v 2                        # Verbose level

    O_i infile.fits              # dummy input file (required)
    O_w wavsamp.tbl              # dummy input file (required)
    O_o extract.tbl              # dummy output file (required)

&END
