# FPG template file for IRS BCD science products
#
# Last update:  09/05/03 per AI 269
#               09/25/03 per AI 328
#               10/05/03 per AI 365
#               10/10/03 per AI 540
#               01/09/04 per AI 692
#               01/20/04 per AI 712
#               02/27/04   (added pasthru of CD matrix)
#               05/25/04 Corrected comments to RA_HMS, DEC_HMS, RA_RQST, DEC_RQST
#               08/23/04 Corrected comments to RA_HMS, DEC_HMS, RA_RQST, DEC_RQST again
#               09/17/04 Deleted comments  of TELESCOP and INSTRUME , and uncommented CTYPE1, CTYPE2, EQUINOX, RADESYS
#               04/08/05 Added CAL_SET (Bob)
#               06/08/30 Added VHELCORR and VLSRCORR CR-7343 (Bob)
#               07/04/16 Added Helocentric coords SPTZR_*, etc. AI-2281 (Bob)
#		06/19/08 Erased CDELT1/2 and CROTA2; 
#
#
# KEYIN   TYPE         ACTION     KEYOUT      COMMENT
SIMPLE    TLOGICAL     PASSTHRU   SIMPLE      Fits standard
BITPIX    TINT         PASSTHRU   BITPIX      FOUR-BYTE SINGLE PRECISION FLOATING POINT
NAXIS     TINT         PASSTHRU   NAXIS       STANDARD FITS FORMAT
NAXIS1    TINT         PASSTHRU   NAXIS1             
NAXIS2    TINT         PASSTHRU   NAXIS2             
NAXIS3    TINT         PASSTHRU   NAXIS3
TELESCOP  TSTRING      PASSTHRU   TELESCOP    
INSTRUME  TSTRING      PASSTHRU   INSTRUME    
CAL_SET   TSTRING      PASSTHRU   CAL_SET     ID for the set of CAL files used
CHNLNUM   TINT         PASSTHRU   CHNLNUM     0=SL, 1=SH, 2=LL, 3=LH
FILENAME  TSTRING      PASSTHRU   FILENAME    File name
FILETYPE  TSTRING      PASSTHRU   FILETYPE    
EXPTYPE   TSTRING      PASSTHRU   EXPTYPE     Exposure Type
          TSTRING      DATABASE   REQTYPE     Request type (AOR,IER, or SER)
          TSTRING      DATABASE   AOT_TYPE    Observation Template Type
          TSTRING      DATABASE   AORLABEL    AOR Label
APERTURE  TINT         RENAME     FOVID       Field of View ID
APERNAME  TSTRING      RENAME     FOVNAME     Field of View Name
RDOUTMOD  TSTRING      RENAME     READMODE    Readout Mode

          / PROPOSAL INFORMATION

OBSRVR    TSTRING      PASSTHRU   OBSRVR      Observer Name
OBSRVRID  TINT         PASSTHRU   OBSRVRID    Observer ID of Principal Investigator
PROCYCL   TINT         PASSTHRU   PROCYCL     Proposal Cycle
PROPOSID  TINT         RENAME     PROGID      Program ID
          TSTRING      DATABASE   PROTITLE    Program Title
          TINT         DATABASE   PROGCAT     Program Category

          / TIME AND EXPOSURE INFORMATION

DATE_OBS  TSTRING      PASSTHRU   DATE_OBS    Date & time (UTC) at DCE start
MJD_OBS   TDOUBLE      PASSTHRU   MJD_OBS     [days] MJD in UTC at DCE start (JD-2400000.5)
UTCS_OBS  TDOUBLE      PASSTHRU   UTCS_OBS    [sec] DCE start time from noon Jan 1, 2000 UTC
SCLK_OBS  TDOUBLE      PASSTHRU   SCLK_OBS    [sec] SCLK time (since 1/1/1980) at DCE start
SAMPTIME  TFLOAT       PASSTHRU   SAMPTIME    [sec] Sample integration time
REQMODE   TINT         PASSTHRU   REQMODE     ID for mode or type of request
EXPSTRTC  TINT         PASSTHRU   EXPSTRTC    Exposure Start Timestamp Coarse
EXPSTRTF  TINT         PASSTHRU   EXPSTRTF    Exposure Start Timestamp Fine
GRPARVTC  TINT         PASSTHRU   GRPARVTC    [sec] Coarse Spacecraft Group Time
GRPARVTF  TINT         PASSTHRU   GRPARVTF    [sec] Fine Spacecraft Group Time
AIRSCMDN  TINT         PASSTHRU   AIRSCMDN    Commanded number of DCEs for IRS
AIRS_DET  TINT         PASSTHRU   AIRS_DET    Selected IRS detector for exposure command
AIRSEXPM  TINT         PASSTHRU   AIRSEXPM    Current Mode of the IRS Exp Manager
GRPTIME   TFLOAT       PASSTHRU   GRPTIME     [sec] Group (w/ spin) integration time
DEADTIME  TFLOAT       PASSTHRU   DEADTIME    [sec] Reset + boost(s) time
RAMPTIME  TFLOAT       PASSTHRU   RAMPTIME    [sec] Ramp (total DCE) integration time
EXPTOT_T  TFLOAT       PASSTHRU   EXPTOT_T    [sec] Integr. time for all DCEs in exposure
AIRSERCT  TINT         PASSTHRU   AIRSERCT    Number of IRS exposure errors

          / TARGET AND POINTING INFORMATION

TARGETNA  TSTRING      RENAME     OBJECT      Target Name
          TSTRING      DATABASE   OBJTYPE     Target Type
CRVAL1    TDOUBLE      PASSTHRU   CRVAL1      [deg] RA at CRPIX1,CRPIX2 averaged over DCE
CRVAL2    TDOUBLE      PASSTHRU   CRVAL2      [deg] DEC at CRPIX1,CRPIX2 averaged over DCE
RA_HMS    TSTRING      PASSTHRU   RA_HMS      [hh:mm:ss.s] RA_SLT or CRVAL1 in sexagesimal
DEC_DMS   TSTRING      PASSTHRU   DEC_DMS     [dd:mm:ss] DEC_SLT or CRVAL2 in sexagesimal
RADESYS   TSTRING      PASSTHRU   RADESYS     International Celestial Reference System
EQUINOX   TFLOAT       PASSTHRU   EQUINOX     Equinox for ICRF celestial coord. system
CTYPE1    TSTRING      PASSTHRU   CTYPE1      RA---TAN with distortion in pixel space
CTYPE2    TSTRING      PASSTHRU   CTYPE2      DEC--TAN with distortion in pixel space
CRPIX1    TFLOAT       PASSTHRU   CRPIX1      Reference pixel along axis 1
CRPIX2    TFLOAT       PASSTHRU   CRPIX2      Reference pixel along axis 2
PA        TDOUBLE      PASSTHRU   PA          [deg] Position angle of axis 2 (E of N,+=CCW)
RA_RQST   TDOUBLE      PASSTHRU   RA_RQST     [deg] Commanded RA referenced to commanded FOV
DEC_RQST  TDOUBLE      PASSTHRU   DEC_RQST    [deg] Commanded Dec referenced to commanded FOV
PA_RQST   TDOUBLE      PASSTHRU   PA_RQST     [deg] Requested pos. angle of axis 2 (E of N)
          TFLOAT       DATABASE   PM_RA       [arcsec/yr] Proper Motion in RA (J2000)
          TFLOAT       DATABASE   PM_DEC      [arcsec/yr] Proper Motion in Dec (J2000)
CRDER1    TDOUBLE      PASSTHRU   CRDER1      [deg] Uncertainty in RA of SI boresight
CRDER2    TDOUBLE      PASSTHRU   CRDER2      [deg] Uncertainty in DEC of SI boresight
SIGRA     TDOUBLE      PASSTHRU   SIGRA       [arcsec] RMS dispersion of RA over DCE
SIGDEC    TDOUBLE      PASSTHRU   SIGDEC      [arcsec] RMS dispersion of DEC over DCE
SIGPA     TDOUBLE      PASSTHRU   SIGPA       [arcsec] RMS dispersion of PA over DCE
PTGDIFF   TDOUBLE      PASSTHRU   PTGDIFF     [arcsec] offset btwn actual and rqsted pntng
PTGDIFFX  TDOUBLE      PASSTHRU   PTGDIFFX    [arcsec] requested - actual pntg along axis 1
PTGDIFFY  TDOUBLE      PASSTHRU   PTGDIFFY    [arcsec] requested - actual pntg along axis 2
          TDOUBLE      DATABASE   RA_REF      [deg] Commanded RA (J2000) of ref. position
          TDOUBLE      DATABASE   DEC_REF     [deg] Commanded Dec (J2000) of ref. position
CD1_1     TDOUBLE      PASSTHRU   CD1_1       [deg/pix] CD matrix element 1_1
CD1_2     TDOUBLE      PASSTHRU   CD1_2       [deg/pix] CD matrix element 1_2
CD2_1     TDOUBLE      PASSTHRU   CD2_1       [deg/pix] CD matrix element 2_1
CD2_2     TDOUBLE      PASSTHRU   CD2_2       [deg/pix] CD matrix element 2_2
USEDBPHF  TLOGICAL     PASSTHRU   USEDBPHF    T if Boresight Pointing History File was used.
SIG_JIT   TDOUBLE      RENAME     RMS_JIT     [arcsec] RMS jitter during DCE
SIG_JITY  TDOUBLE      RENAME     RMS_JITY    [arcsec] RMS jitter during DCE along Y
SIG_JITZ  TDOUBLE      RENAME     RMS_JITZ    [arcsec] RMS jitter during DCE along Z
RA_FOV    TDOUBLE      PASSTHRU   RA_FOV      [deg] RA at FOVID averaged over DCE
DEC_FOV   TDOUBLE      PASSTHRU   DEC_FOV     [deg] DEC at FOVID averaged over DCE
PA_FOV    TDOUBLE      PASSTHRU   PA_FOV      [deg] PA at FOVID averaged over DCE
RA_SLT    TDOUBLE      PASSTHRU   RA_SLT      [deg] RA at slit center averaged over DCE
DEC_SLT   TDOUBLE      PASSTHRU   DEC_SLT     [deg] DEC at slit center averaged over DCE
PA_SLT    TDOUBLE      PASSTHRU   PA_SLT      [deg] PA at slit center averaged over DCE
RA_XSLT   TDOUBLE      PASSTHRU   RA_XSLT     [deg] RA at center of non-targeted slit
DEC_XSLT  TDOUBLE      PASSTHRU   DEC_XSLT    [deg] DEC at center of non-targeted slit
PA_XSLT   TDOUBLE      PASSTHRU   PA_XSLT     [deg] PA at center of non-targeted slit
RA_SHMS   TSTRING      PASSTHRU   RA_SHMS     [hh:mm:ss.s] Sexagesimal representation of RA_SLT
DEC_SDMS  TSTRING      PASSTHRU   DEC_SDMS    [dd:mm:ss] Sexagesimal representation of DEC_SLT
PA_SDMS   TSTRING      PASSTHRU   PA_SDMS     [dd:mm:ss] Sexagesimal representation of PA_SLT
RA_BPU    TDOUBLE      PASSTHRU   RA_BPU      [deg] RA at center of blue peakup image
DEC_BPU   TDOUBLE      PASSTHRU   DEC_BPU     [deg] DEC at center of blue peakup image
RA_RPU    TDOUBLE      PASSTHRU   RA_RPU      [deg] RA at center of red peakup image
DEC_RPU   TDOUBLE      PASSTHRU   DEC_RPU     [deg] DEC at center of red peakup image
CSDRADEC  TDOUBLE      PASSTHRU   CSDRADEC    [deg] Costandard deviation in RA and Dec
CSD_JTYZ  TDOUBLE      PASSTHRU   SIG_JTYZ    [arcsec] Costandard deviation of jitter in YZ
UNCRTPA   TDOUBLE      PASSTHRU   UNCRTPA     [deg] Uncertainty in position angle
BPHFNAME  TSTRING      PASSTHRU   BPHFNAME    Boresight Pointing History Filename
BPHFNAM1  TSTRING      PASSTHRU   BPHFNAM1    Boresight Pointing History Filename 1
BPHFNAM2  TSTRING      PASSTHRU   BPHFNAM2    Boresight Pointing History Filename 2
FOVVERSN  TSTRING      PASSTHRU   FOVVERSN    FOV/BodyFrames file version used
PXSCAL1   TDOUBLE      PASSTHRU   PXSCAL1     [arcsec/pix] Scale for axis1 at CRPIX1,CRPIX2
PXSCAL2   TDOUBLE      PASSTHRU   PXSCAL2     [arcsec/pix] Scale for axis2 at CRPIX1,CRPIX2
VHELCORR  TDOUBLE      PASSTHRU   VHELCORR    [km/sec] Correction to heliocentric velocity
VLSRCORR  TDOUBLE      PASSTHRU   VLSRCORR    [km/sec] Correction to local standard of rest
SPTZR_X   TDOUBLE      PASSTHRU   SPTZR_X     [km] Heliocentric x position
SPTZR_Y   TDOUBLE      PASSTHRU   SPTZR_Y     [km] Heliocentric y position
SPTZR_Z   TDOUBLE      PASSTHRU   SPTZR_Z     [km] Heliocentric z position
SPTZR_VX  TDOUBLE      PASSTHRU   SPTZR_VX    [km/sec] Heliocentric x velocity
SPTZR_VY  TDOUBLE      PASSTHRU   SPTZR_VY    [km/sec] Heliocentric y velocity
SPTZR_VZ  TDOUBLE      PASSTHRU   SPTZR_VZ    [km/sec] Heliocentric z velocity
ET_OBS    TDOUBLE      PASSTHRU   ET_OBS      [sec] DCE start time (TDB seconds past J2000)
HMJD_OBS  TDOUBLE      PASSTHRU   HMJD_OBS    Corresponding Heliocen. Mod. Julian Date


          / MOVING TARGET INFORMATION

          TINT         DATABASE   NAIFID      NAIF ID number for target
          TSTRING      DATABASE   NAIFNAME    Solar System Object name
          TDOUBLE      DATABASE   RA_END      [deg] RA of CRPIX1,CRPIX2 at end of DCE
          TDOUBLE      DATABASE   DEC_END     [deg] Dec of CRPIX1,CRPIX2 at end of DCE
          TSTRING      DATABASE   EPHMFILE    Ephemeris file used for moving target
          TSTRING      DATABASE   MTEPOCH     [Julian date] Epoch
          TSTRING      DATABASE   T_PERI      [Julian date] Perihelion date
          TDOUBLE      DATABASE   LITOMEGA    [deg] Argument of perihelion w.r.t. ecliptic
          TDOUBLE      DATABASE   BIGOMEGA    [deg] Long. of ascending node w.r.t. ecliptic
          TFLOAT       DATABASE   ECCENTR     Eccentricity
          TDOUBLE      DATABASE   PERIHELI    [AU] Perihelion distance
          TFLOAT       DATABASE   INCLINAT    [deg] Inclination of orbit

          / POINTING REFINEMENT KEYWORDS

PTGVERSN  TFLOAT       PASSTHRU   PTGVERSN    Version number of pointingrefine program
RARFND    TDOUBLE      PASSTHRU   RARFND      [deg] Refined RA
DECRFND   TDOUBLE      PASSTHRU   DECRFND     [deg] Refined DEC
CT2RFND   TDOUBLE      PASSTHRU   CT2RFND     [deg] Refined CROTA2
ERARFND   TDOUBLE      PASSTHRU   ERARFND     [deg] Error in RARFND value
EDECRFND  TDOUBLE      PASSTHRU   EDECRFND    [deg] Error in DECRFND value
ECT2RFND  TDOUBLE      PASSTHRU   ECT2RFND    [deg] Error in CT2RFND value
NASTROM   TINT         PASSTHRU   NASTROM     Astrometric sources for absolute refinement

          / DISTORTION KEYWORDS (IMAGING MODE)

A_ORDER   TINT         PASSTHRU   A_ORDER     polynomial order, axis 1, detector to sky
A_0_1     TDOUBLE      PASSTHRU   A_0_1       distortion coefficient
A_0_2     TDOUBLE      PASSTHRU   A_0_2       distortion coefficient
A_0_3     TDOUBLE      PASSTHRU   A_0_3       distortion coefficient
A_1_0     TDOUBLE      PASSTHRU   A_1_0       distortion coefficient
A_1_1     TDOUBLE      PASSTHRU   A_1_1       distortion coefficient
A_1_2     TDOUBLE      PASSTHRU   A_1_2       distortion coefficient
A_2_0     TDOUBLE      PASSTHRU   A_2_0       distortion coefficient
A_2_1     TDOUBLE      PASSTHRU   A_2_1       distortion coefficient
A_3_0     TDOUBLE      PASSTHRU   A_3_0       distortion coefficient
A_DMAX    TDOUBLE      PASSTHRU   A_DMAX      [pixel] maximum correction

B_ORDER   TINT         PASSTHRU   B_ORDER     polynomial order, axis 2, detector to sky
B_0_1     TDOUBLE      PASSTHRU   B_0_1       distortion coefficient
B_0_2     TDOUBLE      PASSTHRU   B_0_2       distortion coefficient
B_0_3     TDOUBLE      PASSTHRU   B_0_3       distortion coefficient
B_1_0     TDOUBLE      PASSTHRU   B_1_0       distortion coefficient
B_1_1     TDOUBLE      PASSTHRU   B_1_1       distortion coefficient
B_1_2     TDOUBLE      PASSTHRU   B_1_2       distortion coefficient
B_2_0     TDOUBLE      PASSTHRU   B_2_0       distortion coefficient
B_2_1     TDOUBLE      PASSTHRU   B_2_1       distortion coefficient
B_3_0     TDOUBLE      PASSTHRU   B_3_0       distortion coefficient
B_DMAX    TDOUBLE      PASSTHRU   B_DMAX      [pixel] maximum correction

AP_ORDER  TINT         PASSTHRU   AP_ORDER    polynomial order, axis 1, sky to detector
AP_0_1    TDOUBLE      PASSTHRU   AP_0_1      distortion coefficient
AP_0_2    TDOUBLE      PASSTHRU   AP_0_2      distortion coefficient
AP_0_3    TDOUBLE      PASSTHRU   AP_0_3      distortion coefficient
AP_1_0    TDOUBLE      PASSTHRU   AP_1_0      distortion coefficient
AP_1_1    TDOUBLE      PASSTHRU   AP_1_1      distortion coefficient
AP_1_2    TDOUBLE      PASSTHRU   AP_1_2      distortion coefficient
AP_2_0    TDOUBLE      PASSTHRU   AP_2_0      distortion coefficient
AP_2_1    TDOUBLE      PASSTHRU   AP_2_1      distortion coefficient
AP_3_0    TDOUBLE      PASSTHRU   AP_3_0      distortion coefficient

BP_ORDER  TINT         PASSTHRU   BP_ORDER    polynomial order, axis 2, sky to detector
BP_0_1    TDOUBLE      PASSTHRU   BP_0_1      distortion coefficient
BP_0_2    TDOUBLE      PASSTHRU   BP_0_2      distortion coefficient
BP_0_3    TDOUBLE      PASSTHRU   BP_0_3      distortion coefficient
BP_1_0    TDOUBLE      PASSTHRU   BP_1_0      distortion coefficient
BP_1_1    TDOUBLE      PASSTHRU   BP_1_1      distortion coefficient
BP_1_2    TDOUBLE      PASSTHRU   BP_1_2      distortion coefficient
BP_2_0    TDOUBLE      PASSTHRU   BP_2_0      distortion coefficient
BP_2_1    TDOUBLE      PASSTHRU   BP_2_1      distortion coefficient
BP_3_0    TDOUBLE      PASSTHRU   BP_3_0      distortion coefficient

          / PHOTOMETRY (IRS IMAGING)

BUNIT     TSTRING      PASSTHRU   BUNIT       Units of image data
DNTCNVFA  TFLOAT       RENAME     FLUXCONV    Conversion factor (MJy/Sr/electrons/sec)

          / SPECTROPHOTOMETRY IRS SH, LH (CHNLNUM 1, 3)

FLXCON11  TDOUBLE      PASSTHRU   FLXCON11    [electrons/sec/Jy] Flux conversion Order 11
FLXERR11  TDOUBLE      PASSTHRU   FLXERR11    Flux conversion uncertainties Order 11
FLXCON12  TDOUBLE      PASSTHRU   FLXCON12    [electrons/sec/Jy] Flux conversion Order 12
FLXERR12  TDOUBLE      PASSTHRU   FLXERR12    Flux conversion uncertainties Order 12
FLXCON13  TDOUBLE      PASSTHRU   FLXCON13    [electrons/sec/Jy] Flux conversion Order 13
FLXERR13  TDOUBLE      PASSTHRU   FLXERR13    Flux conversion uncertainties Order 13
FLXCON14  TDOUBLE      PASSTHRU   FLXCON14    [electrons/sec/Jy] Flux conversion Order 14
FLXERR14  TDOUBLE      PASSTHRU   FLXERR14    Flux conversion uncertainties Order 14
FLXCON15  TDOUBLE      PASSTHRU   FLXCON15    [electrons/sec/Jy] Flux conversion Order 15
FLXERR15  TDOUBLE      PASSTHRU   FLXERR15    Flux conversion uncertainties Order 15
FLXCON16  TDOUBLE      PASSTHRU   FLXCON16    [electrons/sec/Jy] Flux conversion Order 16
FLXERR16  TDOUBLE      PASSTHRU   FLXERR16    Flux conversion uncertainties Order 16
FLXCON17  TDOUBLE      PASSTHRU   FLXCON17    [electrons/sec/Jy] Flux conversion Order 17
FLXERR17  TDOUBLE      PASSTHRU   FLXERR17    Flux conversion uncertainties Order 17
FLXCON18  TDOUBLE      PASSTHRU   FLXCON18    [electrons/sec/Jy] Flux conversion Order 18
FLXERR18  TDOUBLE      PASSTHRU   FLXERR18    Flux conversion uncertainties Order 18
FLXCON19  TDOUBLE      PASSTHRU   FLXCON19    [electrons/sec/Jy] Flux conversion Order 19
FLXERR19  TDOUBLE      PASSTHRU   FLXERR19    Flux conversion uncertainties Order 19
FLXCON20  TDOUBLE      PASSTHRU   FLXCON20    [electrons/sec/Jy] Flux conversion Order 20
FLXERR20  TDOUBLE      PASSTHRU   FLXERR20    Flux conversion uncertainties Order 20

          / SPECTROPHOTOMETRY IRS SL, LL (CHNLNUM 0, 2)

FLXCON01  TDOUBLE      PASSTHRU   FLXCON01    [electrons/sec/Jy] Flux conversion Order 1
FLXERR01  TDOUBLE      PASSTHRU   FLXERR01    Flux conversion uncertainties Order 1
FLXCON02  TDOUBLE      PASSTHRU   FLXCON02    [electrons/sec/Jy] Flux conversion Order 2
FLXERR02  TDOUBLE      PASSTHRU   FLXERR02    Flux conversion uncertainties Order 2
FLXCON03  TDOUBLE      PASSTHRU   FLXCON03    [electrons/sec/Jy] Flux conversion Bonus Order
FLXERR03  TDOUBLE      PASSTHRU   FLXERR03    Flux conversion uncertainties Order 3

          / GENERAL MAPPING KEYWORDS

          TINT         DATABASE   DBEXPOID    Current Exposure ID
          TINT         DATABASE   CYCLENUM    Current cycle number
          TINT         DATABASE   COLUMN      Current column number
          TINT         DATABASE   ROW         Current row number
          TINT         DATABASE   MAPNUM      Current map cycle number
          TINT         DATABASE   DITHPOS     Current dither position
          TINT         DATABASE   CLUSTPOS    Current cluster position

          / IRS SPECTRAL MAPPING KEYWORDS

          TINT         DATABASE   NCYCLES     Number of cycles
          TINT         DATABASE   STEPSPAR    Number of steps parallel to slit
          TINT         DATABASE   STEPSPER    Number of steps perpendicular to slit
          TFLOAT       DATABASE   SIZEPAR     [arcsec] Step size parallel to slit
          TFLOAT       DATABASE   SIZEPER     [arcsec] Step size perpendicular to slit

          / IRS PEAKUP KEYWORDS

          TLOGICAL     DATABASE   PKUPONLY    T = Peakup only
          TSTRING      DATABASE   PKUPMODE    Peakup mode (none, IRS, or PCRS)
          TSTRING      DATABASE   PKUPACCU    Peakup Accuracy (high, moderate,low)
          TSTRING      DATABASE   PKUPFILT    Peakup filter (blue or red)
          TFLOAT       DATABASE   PKUPFLUX    Flux density of peakup target for IRS [mJy] or PCRS [Jy]
          TLOGICAL     DATABASE   PKUPXTND    Extended source (T/F)
          TLOGICAL     DATABASE   ISPUPOS     PU target given in absolute positions (T) or relative offsets (F)
# Note: either offsets OR absolute positions will be listed for the peakup target
          TDOUBLE      DATABASE   PKUPRA      [deg] RA peakup position
          TDOUBLE      DATABASE   PKUPDEC     [deg] Dec peakup position
          TFLOAT       DATABASE   PM_PKRA     [''/yr]Proper motion for RA peakup position
          TFLOAT       DATABASE   PM_PKDEC    [''/yr]Proper motion for Dec peakup position
HP_CENQ   TINT         PASSTHRU   HP_CENQ     Peakup centroid quality code
APKUPCEN  TINT         PASSTHRU   APKUPCEN    Status of the peakup centroid
AXCNTRD1  TINT         PASSTHRU   AXCNTRD1    [centipixels] X value of the brightest centroid
AYCNTRD1  TINT         PASSTHRU   AYCNTRD1    [centipixels] Y value of the brightest centroid
AXCNTRD2  TINT         PASSTHRU   AXCNTRD2    [centipixels] X value of the second brightest centroid
AYCNTRD2  TINT         PASSTHRU   AYCNTRD2    [centipixels] Y value of the second brightest centroid
AINTENS1  TINT         PASSTHRU   AINTENS1    [counts] Intensity value of the brightest centroid
AINTENS2  TINT         PASSTHRU   AINTENS2    [counts] Intensity value of the second brightest centroid
APKUPXCE  TINT         PASSTHRU   APKUPXCE    [centipixels] X value of the centroid to be returned
APKUPYCE  TINT         PASSTHRU   APKUPYCE    [centipixels] Y value of the centroid to be returned


          / DATA FLOW KEYWORDS

DATE      TSTRING      PASSTHRU   DATE        [YYYY-MM-DDThh:mm:ss UTC] file creation date
AORKEY    TSTRING      PASSTHRU   AORKEY      AOR or EIR key. Astrnmy Obs Req/Instr Eng Req
EXPID     TINT         PASSTHRU   EXPID       Exposure ID (0-9999)
DCENUM    TINT         PASSTHRU   DCENUM      DCE number (0-9999)
TLMGRPS   TINT         PASSTHRU   TLMGRPS     Number of expected telemetry groups
FILE_VER  TINT         PASSTHRU   FILE_VER    Version of the raw file made by SIS
FILEDATE  TSTRING      RENAME     RAWDATE     DCE file creation date (PDT)
FILENAME  TSTRING      RENAME     RAWNAME     Raw data file name
SIS_SVER  TSTRING      PASSTHRU   SIS_SVER    SIS SW VERsion
CPT_VER   TSTRING      PASSTHRU   CPT_VER     Channel Param Table FOS version
CTD_VER   TSTRING      PASSTHRU   CTD_VER     Cmded telemetry data version
EXPDFLAG  TLOGICAL     PASSTHRU   EXPDFLAG    (T/F) expedited DCE
MISS_LCT  TINT         PASSTHRU   MISS_LCT    Total Missed Line Cnt in this FITS
MANCPKT   TLOGICAL     PASSTHRU   MANCPKT     T if this FITS is Missing Ancillary Data
MISSDATA  TLOGICAL     PASSTHRU   MISSDATA    T if this FITS is Missing Image Data
PAONUM    TINT         PASSTHRU   PAONUM      PAO Number
CAMPAIGN  TSTRING      PASSTHRU   CAMPAIGN    Campaign
DCEID     TINT         PASSTHRU   DCEID       Data-Collection-Event ID
DCEINSID  TINT         PASSTHRU   DCEINSID    DCE Instance ID
DPID      TINT         PASSTHRU   DPID        Data Product Instance ID
PIPENUM   TINT         PASSTHRU   PIPENUM     Pipeline Script Number
PLSCRPID  TINT         PASSTHRU   PLSCRPID    Pipeline Script ID
SOS_VER   TFLOAT       PASSTHRU   SOS_VER     Data-Product Version
PLVID     TINT         PASSTHRU   PLVID       Pipeline Version ID
CALID     TINT         PASSTHRU   CALID       CalTrans Version ID
ORIGIN    TSTRING      RENAME     ORIGIN0     site where RAW FITS files was written
SIS_SVER  TSTRING      RENAME     CREATOR0    SW system that created RAW FITS

SATURDET  TLOGICAL     PASSTHRU   SATURDET    T if saturation detection(s) on array data
RADPIXFR  TFLOAT       PASSTHRU   RADPIXFR    Fraction of ramps affected by cosmic rays
RADHITNU  TINT         PASSTHRU   RADHITNU    Total number of radhits detected in DCE
DDRNBADP  TINT         PASSTHRU   DDRNBADP    Number of bad pixels after darkdrift correction
LZNNOCOR  TINT         PASSTHRU   LZNNOCOR    Number of pixels without linearity correction
SLCHINSQ  TINT         PASSTHRU   SLCHINSQ    Number of rows with poor SL stray light corrrection
SLRUNCOR  TINT         PASSTHRU   SLRUNCOR    Number of rows with no SL stray light corrrection
XTCHINSQ  TINT         PASSTHRU   XTCHINSQ    Number of rows with poor SH/LH optical crosstalk corr
XTKUNCOR  TINT         PASSTHRU   XTKUNCOR    Number of rows with no SH/LH optical crosstalk corr
FLAVGRSG  TFLOAT       PASSTHRU   FLAVGRSG    Mean ratio of flatfielded image stdev / image signal
GAIN1     TFLOAT       PASSTHRU   GAIN1       e/DN conversion (readout channel 1)
GAIN2     TFLOAT       PASSTHRU   GAIN2       e/DN conversion (readout channel 2)
GAIN3     TFLOAT       PASSTHRU   GAIN3       e/DN conversion (readout channel 3)
GAIN4     TFLOAT       PASSTHRU   GAIN4       e/DN conversion (readout channel 4)
BASECH1   TFLOAT       PASSTHRU   BASECH1     Trimmed mean channel 1 signal in reference unilluminated box
BASECH2   TFLOAT       PASSTHRU   BASECH2     Trimmed mean channel 2 signal in reference unilluminated box
BASECH3   TFLOAT       PASSTHRU   BASECH3     Trimmed mean channel 3 signal in reference unilluminated box
BASECH4   TFLOAT       PASSTHRU   BASECH4     Trimmed mean channel 4 signal in reference unilluminated box

DARKEPID  TINT         RENAME     EPIDDARK    Dark ensemble product ID
#          TSTRING                 DATEDARK    Average observing date of dark ensemble
FLATEPID  TINT         RENAME     EPIDFLAT    Flat ensemble product ID
#          TSTRING                 DATEFLAT    Average observing date of flat ensemble
LINCEPID  TINT         RENAME     EPIDLNCR    Non-linearity ensemble product ID
#          TSTRING                 DATELNCR    Average observing date of non-linearity  ensemble
WAVSMPID  TINT         PASSTHRU   WAVSMPID    Wavsamp product ID
#          TSTRING                 FBIDDARK    Fall-back dark ID file
#          TSTRING                 FBIDFLAT    Fall back flat ID file
#          TSTRING                 FBIDLNCR    Fall-back Non-linearity file
