/* $Id: cpkeywords_errcodes.h,v 1.2 2004/06/11 15:51:26 laher Exp $ */


/***********************************************
cpkeywords_errcodes.h

Purpose

Define constant values.

Overview


Definitions of Variables

See *_init_constants and "main" function *_exec, where * is module name.


***********************************************/

/* Must list function codes first.  LOG_WRITER is special. */

#define	LOG_WRITER	        0x0000ffff
#define	EXEC			0x00010000
#define	INIT_CONSTANTS		0x00020000
#define	READ_DATA		0x00140000
#define	OUTPUT_PROBS		0x00150000
#define	STD_KEYWORDS		0x00190000
#define	CONST_KEYWORDS		0x001a0000
#define	FILEN_KEYWORDS		0x001b0000
#define	NAMELIST		0x001c0000
#define	OUTPUT_KEYWORDS		0x001d0000
#define	OUTPUT 		        0x001e0000
#define	READ_KEYWORDS		0x00200000
#define	DATE 		        0x00240000
#define PARSE_ARGS              0x00250000
#define DECODE_ERR_MSSG         0x00260000


/* 
    List error codes here.  All must be equal to zero after 
    right-shifting 16 bits.
*/

#define STATUS_OK               0x00000000   /* Normal termination. */
#define	NOT_A_NUMBER		0x00000003   /* Normal with special info. */
#define	MEM_INSUFF		0x00000021   /* Normal with warning. */
#define	MAT_SINGULAR		0x00000022   
#define TOO_MANY_BAD_PIXELS     0x00000023   
#define TOO_MANY_OUTLIERS       0x00000024
#define MISSING_INPUT           0x00000040   /* Error condition. */
#define	POS_EXPECTED		0x00000041   
#define	DIVIDE_ZERO		0x00000042
#define	NNEG_EXPECTED		0x00000043
#define	LOG_NEG			0x00000044
#define	ROOT_NEG		0x00000045
#define	FOPEN_FAILED		0x00000046
#define	COULD_NOT_READ		0x00000047
#define	DIM_MISMATCH		0x00000048
#define	OUT_OF_RANGE		0x00000049
#define	INTERP_FAILED		0x0000004a
#define	NO_ARGS			0x0000004b
#define	NOT_ODD			0x0000004c
#define UNKNOWN_ERROR           0x0000004d
#define INPUTS_OUT_OF_RANGE     0x0000004e
#define	MALLOC_FAILED		0x0000004f
#define	TIMES_OUT_OF_ORDER	0x00000050
#define	INCONSIST_IMAGE_ATTRIB  0x00000051
#define	INTEGRATION_TIME_ZERO   0x00000052
#define	IMAGE_MEAN_IS_ZERO_OR_LESS      0x00000053
#define MAX_NUMBER_PLANES_EXCEEDED          0x00000054
#define DATADATE_ERROR          0x00000055
#define	TABLE_OPEN_ERROR        0x00000056
#define	TABLE_INFO_ERROR        0x00000057
#define	COLUMN_NOT_FOUND        0x00000058
#define	TABLE_CLOSE_ERROR       0x00000059
#define	TABLE_INCONSISTENCY     0x0000005a
#define	FCLOSE_FAILED		0x0000005b
#define	NO_INPUT_DATA		0x0000005c
#define	MJD_ERROR		0x0000005d
#define MAX_NUM_PLANES_PER_IMAGE_EXCEEDED          0x0000005e
#define	UTCS_ERROR		0x0000005f
#define	WRONG_NUMBER_OF_FILES	0x00000060
#define	BAD_INPUT_DATA		0x00000061
#define	WRONG_NUMBER_OF_PLANES	0x00000062
#define	TOO_MANY_BAD_KEYWORD_VALUES	0x00000063
#define  TOO_MANY_KEYWORDS  0x00000064

#define	FITS_MSG_MASK		0x00001000   /* Special FITS error codes. */
