/* $Id: darksubng.h,v 1.2 2002/09/20 19:31:32 heidi Exp $ */

#include <stdio.h>
#include "fitsio.h"

#define TRUE 1
#define FALSE 0

#define MAX_FNAME_LENGTH 1025
#define MAX_HISTORY_LENGTH 81

#define VERSION 1.0

enum  bunit {dn,dnpersec,electrons,electronspersec};

typedef struct {
  int verbose;
  int debug;
  int errorcode;
  int unsubtracted;          
  char iam[FLEN_FILENAME];

  FILE* logstream;
} state_t;

typedef struct {
  char namelist[FLEN_FILENAME];
  char input[FLEN_FILENAME];
  char insigma[FLEN_FILENAME];
  char output[FLEN_FILENAME];
  char outsigma[FLEN_FILENAME];
  char pmask[FLEN_FILENAME];
  char dmask[FLEN_FILENAME];
  char cmask[FLEN_FILENAME];
  char dark[FLEN_FILENAME];
  char darksigma[FLEN_FILENAME];

  int pmaskfatal;
  int dmaskfatal;
  int cmaskfatal;

  char logfile[FLEN_FILENAME];
  char ancillary[FLEN_FILENAME];

  int  uncertainty;
} param_t;

typedef struct {
  fitsfile *fp;
  
  char  filename[FLEN_FILENAME];
  enum  bunit units;
  float integration;
  float gain[4];
  int   naxes;
  long  naxis[4];
  int   pixels;

  double* data;
} img_t;

typedef struct {
  fitsfile *fp;
  char filename[FLEN_FILENAME];
  int naxes;
  int naxis[4];
  int pixels;
  
  int* data;
} maskimg_t;

