/* $Id: errorcodes.h,v 1.22 2004/02/03 21:29:36 davidm Exp $ */


/***********************************************
errcodes.h

Purpose

Define constant values.

Overview


Definitions of Variables

classes.h

***********************************************/

/* Must list function codes first.  LOG_WRITER is special. */
// library functions take the first two digits
#define	LOG_WRITER	        0x0000ffff
#define EXEC                    0x00010000
#define READ_PSF                0x00020000
#define COVARIANCE              0x00030000
#define SVD_INVERSE             0x00040000
#define PSF_NORMALIZE           0x00050000
#define PSF_RESAMPLE            0x00060000
#define COVMAT                  0x00080000
#define COVMAT_INVERT           0x00090000
#define COVMAT_COMBINE          0x000a0000
#define FILE_OPEN               0x000b0000
#define FILTER                  0x000c0000
#define FILTER_APPLY            0x000d0000
#define IMAGE_COPY              0x000e0000
#define IMAGE_ALLOCATE          0x000f0000
#define COMP_RES                0x00100000
#define HIST_ROC                0x00110000
#define BUILDHISTORGRAM         0x00120000
#define HIST_INIT               0x00130000
#define HIST_ALLOCATE           0x00140000
#define TRUTHTBL_OPEN           0x00150000
#define TRUTHTBL_READ           0x00160000
#define TRUTHTBL_INIT           0x00170000
#define WRITE_OUTPUT            0x00180000
#define	KEYWORDS		0x00190000
#define	NAMELIST		0x001c0000
#define	OUTPUT_MAGS		0x001e0000
#define	READ_IMAGE		0x00200000
#define	DATE 		        0x00240000
#define PARSE_ARGS              0x00250000
#define PROCESS                 0x00260000
#define READ_INPUT              0x00270000 
#define FITS_IMAGE_OPEN         0x00280000
#define FITS_READ_IMAGE         0x00290000
#define FITS_IMAGE_ALLOCATE     0x002a0000
#define TABLEINPUT_OPEN         0x002b0000 
#define TABLE_READ_IMAGE        0x002c0000 
#define TABLE_WRITE_IMAGE       0x002d0000 
#define TABLE_INPUT_LIST        0x002e0000
#define TABLE_READ_DATA         0x002f0000   
#define TABLE_ALLOCATE_DATA     0x00300000   
#define TABLE_OUTPUT_LIST       0x00310000   
#define TABLE_WRITE_ALL         0x00320000   
#define TABLE_WRITE_GENERAL     0x00330000   
#define TABLE_WRITE_LIST        0x00340000   
#define TABLE_WRITE_DATA        0x00350000   
#define OVERLAY_IMAGE           0x00360000      
#define FITS_READ_KEY           0x00370000
#define FITS_WRITE_GENERAL      0x00380000
#define FITS_WRITE_LIST         0x00390000
#define FITS_WRITE_KEY          0x003a0000
#define FITS_UPDATE_KEY         0x003b0000
#define FITS_WRITE_IMAGE        0x003c0000
#define FITS_COPY_HEADER        0x003d0000
#define IMAGE_SET_DATA          0x003e0000
#define IMAGE_COPY_MEMORY       0x003f0000
#define OVERLAY_MASK            0x00400000
#define TABLE_WRITE_KEY         0x00410000
#define COMPUTE                 0x00420000
#define FITTING                 0x00430000
#define FILE_READ_LINE          0x00440000
#define WC_TRANSFORMATION       0x00450000
#define TNXPOS2                 0x00460000
#define TNXPIX2                 0x00470000
#define TABLE_READ_KEY          0x00480000   
#define OPEN_IMAGE              0x00490000 
#define COPY_DATA               0x004a0000
#define MATRIX_INVERSION        0x004b0000
/*   
    List error codes here.  All must be equal to zero after 
    right-shifting 16 bits.
*/
// library errors take the first two digits
#define STATUS_OK               0x00000000   /* Normal termination. */
#define	NOT_A_NUMBER		0x00000003   /* Normal with special info. */
#define	MEM_INSUFF		0x00000021   /* Normal with warning. */
#define	MAT_SINGULAR		0x00000022   
#define TOO_MANY_BAD_PIXELS     0x00000023   
#define TOO_MANY_RAD_HITS       0x00000024   
#define MAXIMUM_EXCEEDED        0x00000025
#define MISSING_INPUT           0x00000040   /* Error condition. */
#define	POS_EXPECTED		0x00000041   
#define	DIVIDE_ZERO		0x00000042
#define	NNEG_EXPECTED		0x00000043
#define	LOG_NEG			0x00000044
#define	ROOT_NEG		0x00000045
#define	FOPEN_FAILED		0x00000046
#define	COULD_NOT_READ		0x00000047
#define	DIM_MISMATCH		0x00000048
#define	OUT_OF_RANGE		0x00000049
#define	INTERP_FAILED		0x0000004a
#define	NO_ARGS			0x0000004b
#define	NOT_ODD			0x0000004c
#define UNKNOWN_ERROR           0x0000004d
#define INPUTS_OUT_OF_RANGE     0x0000004e
#define	MALLOC_FAILED		0x0000004f
#define	ZERO_EIGENVALUE		0x00000050
#define	UNKNOWN_DATA_TYPE      	0x00000051
#define	COULD_NOT_CLOSE      	0x00000052
#define	READ_CLOSED_FILE      	0x00000053
#define	WRITE_CLOSED_FILE      	0x00000054
#define	WRONG_DATA_TYPE      	0x00000055
#define	MEMORY_NOT_ALLOCATED    0x00000056
#define MISSING_FILENAME        0x00000057
#define UNKNOWN_FILE_TYPE       0x00000058
#define UNKNOWN_FORMAT          0x00000059
#define UNEXPECTED_FORMAT       0x0000005a
#define LOST_STUFF              0x0000005b
#define UNKNOWN_TRASFORMATON    0x0000005c
#define	SIZE_NOT_ODD		0x0000005d   
#define	NOT_ENOUGH_DATA		0x0000005e 
#define PROCESS_UNKNOWN         0x0000005f   

#define	FITS_MSG_MASK		0x00001000   /* Special FITS error codes. */


