/* $Id: ffcorr_errors.h,v 1.1 2002/09/22 22:40:37 heidi Exp $ */

/* ffcorr_errors.h
 * 23 July 2002
 * h. brandenburg (heidi@ipac.caltech.edu)
 *
 * This file contains exit code definitions for the program ffcorr
 * (first frame correction for IRAC)
 */

#define STATUS_OK            0x00000000   /* Normal termination. */

#define UNKNOWN_BUNIT        0x00000040   /* Error conditions */
#define DIM_MISMATCH         0x00000041   
#define DIRECTORY_TREE       0x00000042
#define DCE_COPY             0x00000043
#define MISSING_ARGUMENT     0x00000044
#define MALFORMED_ARGUMENTS  0x00000045
#define DIR_DEFS             0x00000046
#define FOPEN                0x00000047
#define ENVVAR_NOT_SET       0x00000048
#define HELP_ONLY            0x0000004a
#define STDOUT_REDIRECT      0x0000004b
#define STDERR_REDIRECT      0x0000004c
#define UNKNOWN_ARGUMENT     0x0000004d
#define COULD_NOT_ALLOC      0x0000004f
#define NO_INPUT_FILE        0x00000050
#define NO_OUTPUT_FILE       0x00000051
#define NO_PREVIOUS_DCE      0x00000052
#define MASK_FATAL_OUT_OF_RANGE 0x00000053
#define COULD_NOT_PARSE_ARGS 0x00000054
#define UNKNOWN_UNITS        0x00000057
#define UNIT_MISMATCH        0x00000058
#define DELAY_OUT_OF_RANGE   0x00000059
#define DISABLED_UNCERTAINTY 0x0000005a
#define NO_CORRECTION_FOR_DELAY 0x0000005b
#define FITS_MASK            0x00001000   /* Special FITS error codes. */


