C Common block data for image construction
      Integer   MaxIm0,Nlevels,ReNim,MaxSibs
      Parameter (MaxIm0=4095,Nlevels=8,ReNim=500)
      Parameter (MaxSibs=ReNim)
      Integer   Impix(MaxCols0),Nxtpix(MaxCols0),Im(MaxCols0),
     $         Npix(0:8,MaxIm0),X0(MaxIm0),Y0(MaxIm0),DoCols,ACol,
     $         MaskList(100000),FirstPix(MaxIm0),LastPix(MaxIm0),
     $         NMask,Fcol,Lcol,MinArea,Level(128),Imnum,Flags,Nxtim,Col,Line,
     $         Context(4,MaxIm0),MaxPixX(MaxIm0),MaxPixY(MaxIm0),MaxIm,
     $         ImFlag(MaxCols0),Pick(100000),NPick,Nim,NGhost
      Pointer   (PickPtr,Pick)
      Pointer   (MaskListPtr,MaskList)
      Include 'sources.inc'
      Record /SrcInfo/ Sources(MaxIm0)
      Pointer   (SourcePtr,Sources)
      Integer*2 Ghost(NMax0)
      Pointer   (GhostPtr,Ghost)
      Real      Sum(6,MaxIm0),Inten(MaxIm0),MaxPix(MaxIm0),Trsh,PixOver,
     $         Noise,Back
      Logical  Weightc,Connect8c
      Common    /Images/X0,Y0,Impix,Nxtpix,Npix,Im,Fcol,Lcol,Back,MinArea,
     $         Level,Imnum,Flags,Nxtim,Sum,Inten,Trsh,PixOver,
     $         Weightc,Col,Line,Noise,Connect8c,Context,MaxPixX,MaxPixY,
     $         MaxPix,MaxIm,DoCols,ACol,NMask,ImFlag,PickPtr,
     $         NPick,MaskListPtr,Nim,SourcePtr,GhostPtr,NGhost,FirstPix,LastPix
C
C MaxIm0         = Maximum # image to be considered at once
C Nim            = Maximum # sources expected in image
C X0,Y0          = First pixel of source encoutered
C Impix(Col)     = Image # shadowing 'Col'
C Nxtpix(Col)    = Next column shadowed by same image shadowing 'Column'
C Npix(Thrsh,Im) = Number of pixels above various threshold
C Im(Im#/Col)    = Allocation table of image #'s / leftmost column of shadow
C Fcol,Lcol      = First and last columns to search
C Back           = Current background estimate
C MinArea        = Minimum pixels needed to form a valid source from an image
C Level(Thrsh)   = Thresholds to use in "BinIt" for counts in "Npix"
C Imnum          = Sequential image number output
C Flags          = Processing flags (not yet used)
C Nxtim          = Next image number to allocate
C Sum(1-6,Im)    = First and second moments of each image
C Inten(Im)      = Sum of pixel values in each source
C Trsh           = Threshold pixel value to use searching for images
C PixOver        = Amount of pixel value over threshold
C Weight         = Should moments be intensity weighted
C Connect8       = Consider diagonal pixels as connected to the image
C Col            = Current column #
C ACol           = Col - Fcol + 1
C Line           = Current line #
C Noise          = Current estimate of the noise
C Context(4,Im)  = Min X,Y, Max X,Y of image
C MaxPixX/Y(Im)  = X,Y of maximum pixel
C MaxPix(Im)     = Value of maximum pixel
C MaxIm          = Max. # images allowed to shadow a line (parameter)
C DoCols         = Maximum # columns used
C ImFlag         = Per image flags
C
