/***********************************************
mipscal.h

Purpose

Define constant values to be used in all modules.

Overview


Definitions of Variables

See *_init_constants and "main" function *_exec, where * is module name.


***********************************************/


#define	MAX_FILENAME_LENGTH	161
#define	I_FCNNAME_LENGTH	256
#define	I_MESSAGE_LENGTH	256

#define	INV_SQRT_2PI		0.398942280401

#define	LEFT_MASK		0xffff0000
#define	RIGHT_MASK		0x0000ffff

#define	FITS_MSG_MASK		0x00001000
#define	EXEC			0x00010000
#define	INIT_CONSTANTS		0x00020000
#define	INIT			0x00030000
#define	MKBASIS			0x00040000
#define	TRANSPMULT		0x00050000
#define	DETCOMP			0x00060000
#define	PSEUDOCOMP		0x00070000
#define	LOG_LIKELYHOOD		0x00080000
#define	VEC_MULT		0x00090000
#define	INNER_PROD		0x000a0000
#define	LL_COMP			0x000b0000
#define	MAX_LLIKELYHOOD		0x000c0000
#define	MAXLL_FINDMAX		0x000d0000
#define	SSORTP			0x000e0000
#define	CHARGE_ADDITION		0x000f0000
#define	ENDPOINTS		0x00100000
#define	ENDPOINT_FAR		0x00110000
#define	ENDPOINT_NEAR		0x00120000
#define	PROB_RADHIT		0x00130000
#define	READ_DATA		0x00140000
#define	OUTPUT_PROBS		0x00150000
#define	INIT_ALLOCATE		0x00160000
#define	MAT_INVERT		0x00170000
#define	KEYWORDS		0x00180000
#define	STD_KEYWORDS		0x00190000
#define	CONST_KEYWORDS		0x001a0000
#define	FILEN_KEYWORDS		0x001b0000
#define	NAMELIST		0x001c0000
#define	OUTPUT_FLUXES		0x001d0000
#define	OUTPUT_MAGS		0x001e0000
#define	OUTPUT_SAMPS		0x001f0000
#define	READ_IMAGE		0x00200000
#define	READ_SLOPES		0x00210000
#define	READ_INTERPS		0x00220000
#define	COMPUTE_RES		0x00230000
#define	PARSEARGS		0x00240000
#define	LD_OUT_KEYWORDS		0x00250000
#define	LD_STD_KEYWORDS		0x00260000
#define	LD_KEYWORD		0x00270000



#define	NOT_A_NUMBER		0x00000003
#define	MEM_INSUFF		0x00000004
#define	MAT_SINGULAR		0x00000005
#define	POS_EXPECTED		0x00000006
#define	DIVIDE_ZERO		0x00000007
#define	NNEG_EXPECTED		0x00000008
#define	LOG_NEG			0x00000009
#define	ROOT_NEG		0x00000010
#define	FOPEN_FAILED		0x00000011
#define	COULDNOTREAD		0x00000012
#define	DIMMISMATCH		0x00000013
#define	OUTOFRANGE		0x00000014
#define	INTERP_FAILED		0x00000015
#define	NO_ARGS			0x00000016
#define	SYNTAXERR		0x00000017

#define	MODULE_FAILED		        66
#define	MALLOC_FAILED		0x00000071



#define FNANMASK   0x7F80 /* mask bits 1 - 8; all set on NaNs */
#define DNANMASK   0x7FF0 /* mask bits 1 - 11; all set on NaNs */
#define fnan(L) ((L & FNANMASK)==FNANMASK ? 1 : (L & FNANMASK) == 0 ? 2 : 0)
#define dnan(L) ((L & DNANMASK)==DNANMASK ? 1 : (L & DNANMASK) == 0 ? 2 : 0)
