#ifndef _RETURNVALS_

#define _RETURNVALS_

extern int errno;
extern char *sys_errlist[];

#define     PERRN(msg) do {\
			     fprintf(stderr,\
				     "\n%s(%d): %s\n",\
				     __FILE__,__LINE__,msg);\
			     if(errno)\
			       fprintf(stderr,"I/O error # %d: %s\n",\
				       errno,sys_errlist[errno]);\
			     errno = 0;\
			   } while(0)

#if __STDC__ == 1 || __GNUC__ == 1

#define     PERRV(msg,f,key) do {\
			       fprintf(stderr,\
				       "\n%s(%d): %s " f "\n",\
				       __FILE__,__LINE__,msg,(key));\
			       if(errno)\
				 fprintf(stderr,"I/O error # %d: %s\n",\
					 errno,sys_errlist[errno]);\
			       errno = 0;\
			     } while(0)
#else

static char __tmpstr[256];
#define     PERRV(msg,f,key) do {\
			       strcpy(__tmpstr,"\n%s(%d): %s ");\
			       strcat(strcat(__tmpstr,f),"\n");\
			       fprintf(stderr,__tmpstr,\
				       __FILE__,__LINE__,msg,(key));\
			       if(errno)\
				 fprintf(stderr,"I/O error # %d: %s\n",\
					 errno,sys_errlist[errno]);\
			       errno = 0;\
			     } while(0)
#endif  /* __STDC__ .. */

#define     PERR(msg,key)    PERRV(msg,"%d",key)
#define     PERRS(msg,str)     PERRV(msg,"%s",str)
#define     PERRF(msg,flt)     PERRV(msg,"%f",flt)

#define     RTNVALV(msg,f,key,val)  do {\
					  PERRV(msg,f,key);\
					  if(1) return val;\
				    } while(0)

#define     RTNV(msg,val)  do {\
				 PERRN(msg);\
				 if(1) return val;\
			      } while(0)

#define     RTNE(msg)      do {\
				 PERRN(msg);\
				 if(1) return ERR;\
			      } while(0)

#define     RTNVOID(msg)   do {\
				 PERRN(msg);\
				 if(1) return;\
			      } while(0)

#define     RTNERR(msg,key)  RTNVALV(msg,"%d",key,ERR)
#define     RTNVAL(msg,key,val) RTNVALV(msg,"%d",key,val)
#define     RTNVALS(msg,str,val) RTNVALV(msg,"%s",str,val)
#define     RTNVALF(msg,flt,val) RTNVALV(msg,"%f",flt,val)


#endif
