/*********************************************** 
dlutl_decode_fcnname.c

Purpose

Given an function name code, write the appropriate
function name into a string.

Overview
Use a switch statement on the function name code.

Definitions of Variables

Input:
I_root = Code for function name.

Output:
CP_Function = Name of function.

Internal:


***********************************************/

#include <stdio.h>
#include "mipscal.h"


dlutl_decode_fcnname(	int	I_root,
			char	*CP_Function)
{

switch(I_root)	{
	case 0:
	sprintf(CP_Function, "%s", "No function"); break;
	case (LEFT_MASK&EXEC)>>16:
	sprintf(CP_Function, "%s", "EXEC"); break;
	case (LEFT_MASK&INIT_CONSTANTS)>>16:
	sprintf(CP_Function, "%s", "INIT_CONSTANTS"); break;
	case (LEFT_MASK&INIT)>>16:
	sprintf(CP_Function, "%s", "INIT"); break;
	case (LEFT_MASK&MKBASIS)>>16:
	sprintf(CP_Function, "%s", "MKBASIS"); break;
	case (LEFT_MASK&TRANSPMULT)>>16:
	sprintf(CP_Function, "%s", "TRANSPMULT"); break;
	case (LEFT_MASK&DETCOMP)>>16:
	sprintf(CP_Function, "%s", "DETCOMP"); break;
	case (LEFT_MASK&PSEUDOCOMP)>>16:
	sprintf(CP_Function, "%s", "PSEUDOCOMP"); break;
	case (LEFT_MASK&LOG_LIKELYHOOD)>>16:
	sprintf(CP_Function, "%s", "VEC_MULT"); break;
	case (LEFT_MASK&INNER_PROD)>>16:
	sprintf(CP_Function, "%s", "INNER_PROD"); break;
	case (LEFT_MASK&LL_COMP)>>16:
	sprintf(CP_Function, "%s", "LL_COMP"); break;
	case (LEFT_MASK&MAX_LLIKELYHOOD)>>16:
	sprintf(CP_Function, "%s", "MAX_LLIKELYHOOD"); break;
	case (LEFT_MASK&MAXLL_FINDMAX)>>16:
	sprintf(CP_Function, "%s", "MAXLL_FINDMAX"); break;
	case (LEFT_MASK&SSORTP)>>16:
	sprintf(CP_Function, "%s", "SSORTP"); break;
	case (LEFT_MASK&CHARGE_ADDITION)>>16:
	sprintf(CP_Function, "%s", "CHARGE_ADDITION"); break;
	case (LEFT_MASK&ENDPOINTS)>>16:
	sprintf(CP_Function, "%s", "ENDPOINTS"); break;
	case (LEFT_MASK&ENDPOINT_FAR)>>16:
	sprintf(CP_Function, "%s", "ENDPOINT_FAR"); break;
	case (LEFT_MASK&ENDPOINT_NEAR)>>16:
	sprintf(CP_Function, "%s", "ENDPOINT_NEAR"); break;
	case (LEFT_MASK&PROB_RADHIT)>>16:
	sprintf(CP_Function, "%s", "PROB_RADHIT"); break;
	case (LEFT_MASK&READ_DATA)>>16:
	sprintf(CP_Function, "%s", "READ_DATA"); break;
	case (LEFT_MASK&OUTPUT_PROBS)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_PROBS"); break;
	case (LEFT_MASK&INIT_ALLOCATE)>>16:
	sprintf(CP_Function, "%s", "INIT_ALLOCATE"); break;
	case (LEFT_MASK&MAT_INVERT)>>16:
	sprintf(CP_Function, "%s", "MAT_INVERT"); break;
	case (LEFT_MASK&KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "KEYWORDS"); break;
	case (LEFT_MASK&STD_KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "STD_KEYWORDS"); break;
	case (LEFT_MASK&CONST_KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "CONST_KEYWORDS"); break;
	case (LEFT_MASK&FILEN_KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "FILEN_KEYWORDS"); break;
	case (LEFT_MASK&NAMELIST)>>16:
	sprintf(CP_Function, "%s", "NAMELIST"); break;
	case (LEFT_MASK&OUTPUT_FLUXES)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_FLUXES"); break;
	case (LEFT_MASK&OUTPUT_MAGS)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_MAGS"); break;
	case (LEFT_MASK&OUTPUT_SAMPS)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_SAMPS"); break;
	case (LEFT_MASK&READ_IMAGE)>>16:
	sprintf(CP_Function, "%s", "READ_IMAGE"); break;
	case (LEFT_MASK&READ_SLOPES)>>16:
	sprintf(CP_Function, "%s", "READ_SLOPES"); break;
	case (LEFT_MASK&READ_INTERPS)>>16:
	sprintf(CP_Function, "%s", "READ_INTERPS"); break;
	case (LEFT_MASK&COMPUTE_RES)>>16:
	sprintf(CP_Function, "%s", "COMPUTE_RES"); break;
	default: sprintf(CP_Function, "%s", "Unspecified function.");
}

}





