/*********************************************** 
dlutl_decode_message.c

Purpose

Given an error code, write the appropriate error message
into a string.

Overview
Use a switch statement on the error code.

Definitions of Variables

Input:
I_message = Code for error message.


Output:
CP_Message = Error message string.

Internal:


***********************************************/

#include <stdio.h>
#include "mipscal.h"



dlutl_decode_message(	int	I_message,
			char	*CP_Message)
{

switch(I_message)	{
	case 0:
	sprintf(CP_Message, "%s", "None"); break;
	case NOT_A_NUMBER:
	sprintf(CP_Message, "%s", "NOT_A_NUMBER"); break;
	case MEM_INSUFF:
	sprintf(CP_Message, "%s", "MEM_INSUFF"); break;
	case MAT_SINGULAR:
	sprintf(CP_Message, "%s", "MAT_SINGULAR"); break;
	case POS_EXPECTED:
	sprintf(CP_Message, "%s", "POS_EXPECTED"); break;
	case DIVIDE_ZERO:
	sprintf(CP_Message, "%s", "DIVIDE_ZERO"); break;
	case NNEG_EXPECTED:
	sprintf(CP_Message, "%s", "NNEG_EXPECTED"); break;
	case LOG_NEG:
	sprintf(CP_Message, "%s", "LOG_NEG"); break;
	case ROOT_NEG:
	sprintf(CP_Message, "%s", "ROOT_NEG"); break;
	case FOPEN_FAILED:
	sprintf(CP_Message, "%s", "FOPEN_FAILED"); break;
	case COULDNOTREAD:
	sprintf(CP_Message, "%s", "COULDNOTREAD"); break;
	case DIMMISMATCH:
	sprintf(CP_Message, "%s", "DIMMISMATCH"); break;
	case OUTOFRANGE:
	sprintf(CP_Message, "%s", "OUTOFRANGE"); break;
	case NO_ARGS:
	sprintf(CP_Message, "%s", "NO_ARGS"); break;
	case MALLOC_FAILED:
	sprintf(CP_Message, "%s", "MALLOC_FAILED"); break;
	default:
	sprintf(CP_Message, "%s", "Unknown error");
}	

}





