/*********************************************** 
dlutl_transp.c

Purpose

Compute transpose of matrix.

Overview
Set each element of output matrix to correct input element.

Definitions of Variables

Input:
DP_Matrix_in = Matrix to be transposed.
I_Num_Rows = Number of Rows of matrix.
I_Num_Columns = Number of Columns of matrix.

Output:
DP_MatrixTrans = Transpose of matrix.

Internal:


***********************************************/

#include <stdio.h>
#include "dlutl.h"


dlutl_transp(	double	*DP_Matrix_in,
			int	I_Num_Rows,
			int	I_Num_Columns,
			double	*DP_MatrixTrans,
			int	*IP_Status)
{
int	k, l;

if(*IP_Status) return;

for(k=0;k<I_Num_Columns;k++)
for(l=0;l<I_Num_Rows;l++)
DP_MatrixTrans[k*I_Num_Rows+l] = DP_Matrix_in[l*I_Num_Columns+k];

}





