/*********************************************** 
dlutl_vecmult.c

Purpose

Multlply a vector by a matrix.

Overview
Compute inner product of each row of matrix with vector.

Definitions of Variables

Input:
I_Num_Rows  = Number of Rows of Matrix.
I_Num_Columns  = Number of Columns of Matrix.
DP_Mat_In = Input Matrix.
DP_Vec_In = Input Vector.


Output:
DP_Vec_Out = Output Vector.

Internal:
I_vecsize = Size of Output Vector in memory.

***********************************************/

#include <stdio.h>
#include "dlutl.h"



dlutl_vecmult(	int	I_Num_Rows,
		int	I_Num_Columns,
		double	*DP_Mat_In,
		double	*DP_Vec_In,
		double	*DP_Vec_Out,
		int	*IP_Status)
{
int	k, m, I_vecsize;

if(*IP_Status) return;

I_vecsize = I_Num_Rows*sizeof(double);
memset((void *) DP_Vec_Out, 0, I_vecsize);

for(k=0;k<I_Num_Rows;k++)	
for(m=0;m<I_Num_Columns;m++)
DP_Vec_Out[k] += DP_Mat_In[k*I_Num_Columns+m]*DP_Vec_In[m];

}





