/****************************************************************************
**                                                                         **
** Routine Name:                tbl_setkey_d.c                             **
**                                                                         **
**  NOTE: new version to handle double values on non-Solaris - TYB 9/19/09 **
**                                                                         **
**                                                                         **
** Description:                 This routine defines a new key             **
**                                                                         **
** Input Parameters:            					   **
** 				ofile   ____ output file number            **
**                              keyname ____ Name of the keyword           **
**                              datatype ___ character data type           **
**                              keyval  ____ void ptr of data value        **
**                                                                         **
** Output Parameters:                                                      **
**                                                                         **
** Function Return Values:      stat = TBL_OK    ( 0), success             **
**                              stat = TBL_ERROR (-1), error               **
**                                                                         **
**									   **
** Revision History:                                                       **
**									   **
**   2004-02    Iffat Khan      first written	                           **
**   2005-10    Iffat Khan      check for data type, case insensitive      **
**   2007-02    Iffat Khan      corrected a bug                            **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                     **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/

/***********************
* define Include Files *
************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

int tbl_setkey_d(file_no,  keyname, datatype,
                 keyvald)
int file_no;
char *keyname;
char *datatype;
double keyvald;

{
 int ofile;
 int  kth;
 int *iptr;

 double *dptr;

 float  *fptr;

 char   *type, ktype;
 char   *cptr;

 char key[TBL_KEYLEN];
 char kstr[TBL_KEYLEN];
 char kval[TBL_KEYLEN];

 ofile = tbl_finfo[file_no]->file_handle;
 type = datatype;
 skipwhite(type);
 ktype = tolower(type[0]);
 strcpy(key, keyname);
 if (ktype == 'd') {
   sprintf(kstr, "%f",keyvald);
  }
 strcpy(kval, kstr);

 tbl_finfo[file_no]->nkeywords++;
 kth = tbl_finfo[file_no]->nkeywords-1;
 if (ktype == 'f' || ktype == 'r' || ktype == 'd') 
     tbl[ofile]->keyinfo[kth]->ktype = TBL_DOUBLE;
 else if (ktype == 'i') 
     tbl[ofile]->keyinfo[kth]->ktype = TBL_INTEGER;
 else if (ktype == 'c') 
     tbl[ofile]->keyinfo[kth]->ktype = TBL_CHARACTER;

 strcpy(tbl[ofile]->keyinfo[kth]->key,key);
 strcpy(tbl[ofile]->keyinfo[kth]->kval,kval);

}
