      Subroutine GenMod(Cube,Sigmas,PMask,DMask,Base,UncBase,
     +                  Absc,T,NCols,NRows,NPlanes,Used,NFail,
     +                  Unc,UseUnc,UseUnc2,GotBN,VarFill,Qmin,Ncomp,
     +                  Ninfl8,Infl8,DMBRad,DMB2pt)
c-----------------------------------------------------------------------
c
      Integer*4 NCols, NRows, NPlanes, NFail(6), I, J, N, Num,
     +          PassNo, Ncomp, Ninfl8, NN, DMBRad, DMB2pt
      Integer*2 PMask(NCols,NRows), DMask(NCols,NRows,NPlanes)
      Logical*1 Used(NPlanes), TossIt, Debug
      Logical   UseUnc, UseUnc2, GotBN, DoWgt, Do2pt, BitSet, RSS
      Real*4    Cube(NCols,NRows,NPlanes), D(2), A(2),
     +          Absc(NPlanes), Sigmas(NCols,NRows,2), Infl8,
     +          T(NPlanes), AbscMax, Sigma, DNMin, DNMax,
     +          VarFill, Base(NCols,NRows), UncBase(NCols,NRows),
     +          R4Blank, Unc(NCols,NRows,NPlanes), VarA0, Slope,
     +          Qmin, ChiSq, DegFrdm, DevSq, GammQ
      Real*8    FNum, SigSq, Determ, K1, K2, K3, K4, K5, K6, K7, K8,
     +          A0, A1, A2, DCube, DAbsc, Wgt
c
c- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      Character*11  Vsn
      Character*8   CDate, CTime
      Common / VDT / CDate, CTime, Vsn
c
c- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      Integer*4 NSigMax, NSkip, DBI, DBJ
      Integer*2 MaskD, MaskP
      Real*4    ZSig, MaxDN, MinDN, MinMax, SigMax
c
      Common / Contrl / ZSig, MaxDN, SigMax, NSigMax, NSkip, DBI, DBJ,
     +                  MinDN, MinMax, MaskD, MaskP, DoWgt, RSS
c
c-----------------------------------------------------------------------
c
      NFail(1) = 0
      NFail(2) = 0
      NFail(3) = 0
      NFail(4) = 0
      NFail(5) = 0
      NFail(6) = 0
      NSigMax  = 0
      Do2pt    = (DMB2pt .ge. 0) .and. (DMB2pt .lt. 15)
      Call ImBlank(R4Blank)
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      Do 1200 J = 1, NRows             ! Loop over all pixels
        Do 1100 I = 1, NCols
c                                      ! Init aux images
          Do 36 N = 1, 2
            Sigmas(I,J,N) = 0.0
36        Continue
          DNMax   = MinMax
          DNMin   = 9.9e9
          AbscMax = 9.9e9
          Base(I,J)               = R4Blank ! Initialize in case baseline
          If (GotBN) UncBase(I,J) = R4Blank !  can't be computed
          PassNo = 1
          Debug = (DBI .eq. I) .and. (DBJ .eq. J)
          If (Debug) print *,'DEBUG information for pixel ',I,' ',J,':'
c  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
          N = 0
45        N = N + 1                    ! Set up abscissa values
          NN = N + NSkip
          Absc(N) = NN                 ! Zero crossing at plane #0
          If (Debug) then
            print *,'Absc(',N,') = ', NN
            print *,'Sample = ',Cube(I,J,NN)
          End If
c  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
          TossIt = .False.
          If (And(PMask(I,J),MaskP) .ne. 0) then    ! check PMask
            NFail(4) = NFail(4) + 1
            TossIt = .True.
            If (Debug .and. N .eq. 1)
     +          print *,'Pixel rejected due to pmask'
          End If
          If (BitSet(DMask(I,J,NN),DMBrad)) then    ! check for radhit
            If (Debug) print *,'Radhit detected in this plane'
            Go to 120                ! No higher samples usable
          End If
          If (And(DMask(I,J,NN),MaskD) .ne. 0) then ! check DMask
            NFail(5) = NFail(5) + 1
            TossIt = .True.
            If (Debug) print *,'Sample rejected due to dmask'
          End If
          If (TossIt) Go to 60
c  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
          If (Cube(I,J,NN) .gt. DNMax) then  ! find max & min DNobs
            DNMax = Cube(I,J,NN)
            AbscMax = Absc(N)
          End If
          If (Cube(I,J,NN) .lt. DNMin) DNMin = Cube(I,J,NN)
          If (N .le. 2) then          ! set up possible 2-point
            D(N) = Cube(I,J,NN)       !  extrapolation
            A(N) = Absc(N)
          End If
c
60        If (NN .lt. NPlanes) go to 45
c
c  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
c
120       If (Debug) print *,'Max & Min: ',DNMax,' & ',DNMin
          Num = 0
          K1 = 0.0d0
          K2 = 0.0d0
          K3 = 0.0d0
          K4 = 0.0d0
          K5 = 0.0d0
          K6 = 0.0d0
          K7 = 0.0d0
          K8 = 0.0d0
          Do 140 N = 1, NPlanes-NSkip
            Used(N) = .False.
140       Continue
c
          Do 500 N = 1, NPlanes-NSkip
c
            NN = N + NSkip
            If ((And(PMask(I,J),   MaskP) .ne. 0)  .or.
     +          (And(DMask(I,J,NN),MaskD) .ne. 0)) Go to 500
            If (BitSet(DMask(I,J,NN),DMBrad)) Go to 501
            If ((Cube(I,J,NN) .lt. MinDN) .or.
     +          (Cube(I,J,NN) .gt. MaxDN)) then
              NFail(1) = NFail(1) + 1
              Go to 500
            End If
            If (Absc(N) .gt. AbscMax) Go to 500    ! reject nonmonotonic
            If (PassNo .gt. 1) then                       ! multi-pass
              If (Abs(Cube(I,J,NN) - (A2*Absc(N)**2 + A1*Absc(N) + A0))
     +            .gt. ZSig*Sigma) then
                If (Debug) then
                  print *,'2nd-pass rejection of point ',N
                  print *,'Sample = ',Cube(I,J,NN)
                  print *,'Fit    = ',A2*Absc(N)**2 + A1*Absc(N) + A0
                  print *,'ZSig   = ',ZSig
                  print *,'Sigma  = ',Sigma
                End If
                Go to 500
              End If
            End If
            Used(N) = .True.
c
            DCube = Dble(Cube(I,J,NN))
            DAbsc = Dble(Absc(N))
            If (UseUnc .and. DoWgt) then
              Wgt = 1.0d0/Dble(Unc(I,J,NN))**2
            Else
              Wgt = 1.0d0/Dble(VarFill)
            End If
            If (Debug) print *,'Using Sample, Absc, Wgt: ',DCube,', ',
     +          DAbsc,', ',Wgt
c
            K1   = K1 + Wgt*DCube
            K2   = K2 + Wgt*DAbsc**2
            K3   = K3 + Wgt*DAbsc
            K4   = K4 + Wgt
            K5   = K5 + Wgt*DCube*DAbsc
            K6   = K6 + Wgt*DAbsc**3
            K7   = K7 + Wgt*DCube*DAbsc**2
            K8   = K8 + Wgt*DAbsc**4
            Num  = Num  + 1
            If (Debug) then
              print *,'K1-K4: ',K1,' ',K2,' ',K3,' ',K4
              print *,'K5-K8: ',K5,' ',K6,' ',K7,' ',K8
              print *,'Num:   ',Num
            End If
c
500       Continue
c
501       FNum = Num
          Determ = K2**3 - 2.0d0*K2*K3*K6 - K2*K4*K8
     +           + K8*K3**2 + K4*K6**2
          If (Debug) print *,'Determ: ',Determ
          If (Num .lt. 3) then
            If (And(PMask(I,J),MaskP) .eq. 0)  ! PMask failures already
     +          NFail(2) = NFail(2) + 1        !  counted in NFail(4)
            Do 515 NN = NSkip+1, NPlanes
              Call SetBit(DMask(I,J,NN),10)
515         Continue
            If ((Num .lt. 2) .or. .not.Do2pt) Go to 1100
          End If
          If (Num .eq. 2) then
            If (A(1) .eq. A(2)) Go to 1100
            Slope = (D(2) - D(1))/(A(2) - A(1))
            A0 = D(2)- Slope*A(2)
            VarA0 = 0.01*A0**2        ! assume 10% 1-sigma
            If (VarA0 .lt. VarFill) VarA0 = VarFill
            Do 520 NN = NSkip+1, NPlanes

            If (Debug) print *,'TYB: DMask bef clear:', DMask(I,J,NN)

              Call ClrBit(DMask(I,J,NN),10)

            If (Debug) print *,'TYB: DMask aft clear:', DMask(I,J,NN)

              Call SetBit(DMask(I,J,NN),DMB2pt)

            If (Debug) print *,'TYB: DMask aft set:', DMask(I,J,NN)

520         Continue
            NFail(6) = NFail(6) + 1
            If (Debug) print *,'2-point extrapolation used'
            Go to 535
          End If
          If (Determ .eq. 0.0d0) then
            NFail(3) = NFail(3) + 1
            Do 525 NN = NSkip+1, NPlanes
              Call SetBit(DMask(I,J,NN),10)
525         Continue
            Go to 1100
          End If
c
          A0 = (K7*K2**2 - K2*K5*K6 - K1*K2*K8
     +       +  K3*K5*K8 - K3*K6*K7 + K1*K6**2)/Determ
          A1 = (K5*K2**2 - K2*K3*K7 - K4*K5*K8
     +       -  K1*K2*K6 + K1*K3*K8 + K4*K6*K7)/Determ
          A2 = (K7*K3**2 - K2*K3*K5 - K1*K3*K6
     +       -  K2*K4*K7 + K4*K5*K6 + K1*K2**2)/Determ
          VarA0 = (K6**2 - K2*K8)/Determ
          If (Debug) then
            print *,'A0,A1: ',A0,', ',A1
            print *,'A2,VarA0: ',A2,', ',VarA0
          End If
c
          SigSq   = 0.0d0
          ChiSq   = 0.0
          DegFrdm = -3.0
c
          Do 530 N = 1, NPlanes-NSkip
            NN = N + NSkip
            If (Used(N)) then
              DevSq = (Cube(I,J,NN)
     +                 - (A2*Absc(N)**2 + A1*Absc(N) + A0))**2
              If (Debug) print *,'Deviation from fit for point ',N,
     +            ': ',sqrt(DevSq)
              SigSq = SigSq + dble(DevSq)
              DegFrdm = DegFrdm + 1.0
              If (UseUnc .and. DoWgt) then
                ChiSq = ChiSq + DevSq/Unc(I,J,NN)**2
              Else
                ChiSq = ChiSq + DevSq/VarFill
              End If
            End If
530       Continue
          Sigma = DSqrt(SigSq/FNum)
          If (Debug) then
            print *,'Pass ',PassNo,'; Sigma = ',Sigma
          End If
          If (PassNo .eq. 1) then
            PassNo = 2
            Go to 120
          End If
          If (DegFrdm .gt. 0.0) then
            If (Debug) then
              print *,'ChiSq = ',ChiSq,', DegFrdm = ',DegFrdm
            End If
            If (Gammq(0.5*DegFrdm,0.5*ChiSq) .lt. Qmin) then
              VarA0  = VarA0*ChiSq/DegFrdm
              If (Debug) print *,'Inflating VarA0 to ',VarA0
              Ncomp = Ncomp + 1
            End If
          Else
            VarA0 = Infl8*VarA0
            Ninfl8 = Ninfl8 + 1
          End If
c
c  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
c
          If (Sigma .gt. SigMax) NSigMax = NSigMax + 1
535       Base(I,J) = A0
          If (GotBN) UncBase(I,J) = sqrt(VarA0)
          Do 540 NN = NSkip+1, NPlanes
            Cube(I,J,NN) = Cube(I,J,NN) - A0
            If (UseUnc2) then
              If (.not.RSS) VarA0 = 0.0
              If (UseUnc) then
                Unc(I,J,NN) = Sqrt(Unc(I,J,NN)**2 + VarA0)
              Else
                Unc(I,J,NN) = Sqrt(VarFill + VarA0)
              End If
            End If
540       Continue
          Sigmas(I,J,1)  = Sigma
          Sigmas(I,J,2)  = FNum
c
1100    Continue
1200  Continue
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      Return
c
      End
c
C=======================================================================
c
      Subroutine SetBit(I2Var,NBit)
C-----------------------------------------------------------------------
C     Set Bit no. "NBit" in "I2Var"
C     LSB = bit no. 0, MSB = bit no. 14, Sign Bit = bit no. 15
C-----------------------------------------------------------------------
      Integer*4 NBit,NWarns
      Integer*2 Power(16),I2Var
      Data NWarns/0/
C
C  Make this change - TYB 4/15/09
C
      Parameter (hexbit15 = Z'8000')
C
      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     + 16384,hexbit15/
C      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
C     + 16384,Z8000/
C-----------------------------------------------------------------------
C
      If ((NBit .lt. 0) .or. (NBit .gt. 15)) Then
        NWarns = NWarns + 1
        If (NWarns .le. 10) Write(6, 6000) NBit
        If (NWarns .eq. 10) Write(6, 6001)
        Return
      End If
C
C  Make this change - TYB 4/15/09
C
      I2Var = ior(I2Var, Power(NBit+1))
C      I2Var = I2Var .or. Power(NBit+1)
C
      Return
C-----------------------------------------------------------------------
6000  Format(' SetBit: Warning! bit number outside range (0 - 15), ',
     + I21)
6001  Format('         This is the last warning that will be printed')
C-----------------------------------------------------------------------
      End
c
c=======================================================================
c
      FUNCTION gammq(a,x)
C
C  Switch to double internally - TYB 6/1/09
C
      REAL*4   a,gammq,x
CU    USES gcf,gser
      REAL*8 gammcf,gamser,gln,ad,xd
C
      ad = dble(a)
      xd = dble(x)
      if((xd .lt. 0.0) .or. (ad .le. 0.0)) then
        print *,'ERROR: bad arguments in gammq'
        print *,'       x = ',xd
        print *,'       a = ',ad
        call exit(64)
      end if
      if(xd.lt.ad+1.)then
        call gser(gamser,ad,xd,gln)
c        call gser(gamser,a,x,gln)
        gammq=sngl(1.-gamser)
      else
        call gcf(gammcf,ad,xd,gln)
c        call gcf(gammcf,a,x,gln)
        gammq=sngl(gammcf)
      endif
      return
      END
c-----------------------------------------------------------------------
      SUBROUTINE gser(gamser,a,x,gln)
C
C  Switch to double internally - TYB 6/1/09
C
      INTEGER ITMAX
      REAL*8 a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.d-7)
CU    USES gammln
      INTEGER n
      REAL*8 ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
c       if(x.lt.0.)pause 'x < 0 in gser'
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(dabs(del).lt.dabs(sum)*EPS)goto 1
11    continue
      print *,'WARNING: a too large, ITMAX too small in gser'
      print *,'         a = ',a
      print *,'     ITMAX = ',ITMAX
1     gamser=sum*dexp(-x+a*dlog(x)-gln)
      return
      END
c-----------------------------------------------------------------------
      SUBROUTINE gcf(gammcf,a,x,gln)
C
C  Switch to double internally - TYB 6/1/09
C
      INTEGER ITMAX
      REAL*8 a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.d-7,FPMIN=1.d-30)
CU    USES gammln
      INTEGER i
      REAL*8 an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(dabs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(dabs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(dabs(del-1.).lt.EPS)goto 1
11    continue
      print *,'WARNING: a too large, ITMAX too small in gcf'
      print *,'         a = ',a
      print *,'     ITMAX = ',ITMAX
1     gammcf=dexp(-x+a*dlog(x)-gln)*h
      return
      END
c-----------------------------------------------------------------------
      FUNCTION gammln(xx)
      REAL*8 gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*dlog(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+dlog(stp*ser/x)
      return
      END
c
c=======================================================================
c
      Logical Function BitSet(I2Var,NBit)
C-----------------------------------------------------------------------
C     Returns .TRUE. iff Bit no. "NBit" in "I2Var" is set (turned on)
C     LSB = bit no. 0, MSB = bit no. 14, Sign Bit = bit no. 15
C-----------------------------------------------------------------------
      Integer*4 NBit,NWarns
      Integer*2 I2Var,Power(16)
      Data NWarns/0/
C
C  Make this change - TYB 4/15/09
C
      Parameter (hexbit15 = Z'8000')
C
      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     + 16384,hexbit15/
C      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
C     + 16384,Z8000/
C-----------------------------------------------------------------------
C
      If ((NBit .lt. 0) .or. (NBit .gt. 15)) Then
        NWarns = NWarns + 1
        If (NWarns .le. 10) Write(6, 6000) NBit
        If (NWarns .eq. 10) Write(6, 6001)
        BitSet = .False.
        Return
      End If
C
C  Make this change - TYB 4/15/09
      BitSet = ( iand(I2Var, Power(NBit+1)) .ne. 0 )
C      BitSet = (I2Var .and. Power(NBit+1)) .ne. 0
C
      Return
C-----------------------------------------------------------------------
6000  Format(' BitSet: Warning! bit number outside range (0 - 15), ',
     + I21)
6001  Format('         This is the last warning that will be printed')
C-----------------------------------------------------------------------
      End
c=======================================================================
c
      Subroutine ClrBit(I2Var,NBit)
C-----------------------------------------------------------------------
C     Clear Bit no. "NBit" in "I2Var"
C     LSB = bit no. 0, MSB = bit no. 14, Sign Bit = bit no. 15
C-----------------------------------------------------------------------
      Integer*4 NBit,NWarns,IBit
      Integer*2 I2Var,Power(16),I2New
      Data NWarns/0/
C
C  Make this change - TYB 4/15/09
C
      Parameter (hexbit15 = Z'8000')
C
      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     + 16384,hexbit15/
C
C      Data Power/ZFFFE,ZFFFD,ZFFFB,ZFFF7,
C     +           ZFFEF,ZFFDF,ZFFBF,ZFF7F,
C     +           ZFEFF,ZFDFF,ZFBFF,ZF7FF,
C     +           ZEFFF,ZDFFF,ZBFFF,Z7FFF/
C-----------------------------------------------------------------------
C
      If ((NBit .lt. 0) .or. (NBit .gt. 15)) Then
        NWarns = NWarns + 1
        If (NWarns .le. 10) Write(6, 6000) NBit
        If (NWarns .eq. 10) Write(6, 6001)
        Return
      End If
C
C  A clumsy way around this bit-clearing - TYB
C
      If ( IAnd(I2Var,Power(NBit+1)) .eq. Power(NBit+1) ) Then
C
C  The bit is there, all other bits = T will knock it out
C
        I2New = I2Var * 0
        Do 600 IBit = 0, 15
          If (NBit .eq. IBit) Then
            Go To 600
          End If
          I2New = Ior(IAnd(I2Var,Power(IBit+1)),I2New)
600     Continue
        I2Var = I2New
      End If
C
C      I2Var = IAnd(I2Var,Power(NBit+1))
C
      Return
C-----------------------------------------------------------------------
6000  Format(' ClrBit: Warning! bit number outside range (0 - 15), ',
     + I21)
6001  Format('         This is the last warning that will be printed')
C-----------------------------------------------------------------------
      End
