/* $Id: cropfits_exit.c,v 1.3 2007/11/12 18:12:17 laher Exp $ */


/******************************************************* 
 *  cropfits_exit.c
 *******************************************************

 Purpose:
 Cleanly exit the program.

 Overview:
 Deallocate memory 

 Definitions of Variables:
 See cropfits_defs.h and cropfits_exec.c

 *******************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "cropfits.h"
#include "cropfits_defs.h"


void cropfits_exit( CPF_ImageInfo   *CPFP_Image,
	            CPF_State       *CPFP_Stat)
{

  /* Allocated in cropfits_read_data or its subfunctions */

  free(CPFP_Image->Image);
  free(CPFP_Image->Map);
  
  if(CPFP_Stat->Verbose)
    printf("cropfits_exit: Memory Deallocated.\n");
  
}










