/* $Id: cropfits_init.c,v 1.3 2007/11/12 18:12:17 laher Exp $ */


/****************************************************************** 
 *  cropfits_init.c
 ******************************************************************

 Purpose
 Initialize the structs defined in the header file 
 cropfits_defs.h

 Definitions of Variables
 See "main" function cropfits_exec.c and cropfits_defs.h
 
 ******************************************************************/

#include <stdio.h>
#include "cropfits.h"
#include "cropfits_defs.h"

void cropfits_init( CPF_Filenames     *CPFP_Fnames,
	            CPF_Pathnames     *CPFP_Paths,
	            CPF_ImageInfo     *CPFP_Image,
	            CPF_Computation   *CPFP_Comp,
	            CPF_State	      *CPFP_Stat)
{

  /* Put in stdio defaults in case filenames are not given later */
  sprintf(CPFP_Fnames->Filename_Namelist, "%s", "");
  sprintf(CPFP_Fnames->Filename_Input, "%s", "");
  sprintf(CPFP_Fnames->Filename_Output, "%s", "");
  sprintf(CPFP_Fnames->Filename_Table, "%s", "");
  sprintf(CPFP_Fnames->Filename_Map, "%s", "");
  sprintf(CPFP_Fnames->Filename_Log, "%s", "stdout");

  /* Put in stdio defaults in case pathnames are not given later */
  sprintf(CPFP_Paths->CP_Ancillary_File_Path, "%s", ".");

  /* Initialize all status flags */
  CPFP_Stat->Status = FALSE;
  CPFP_Stat->Debug = FALSE;
  CPFP_Stat->Verbose = FALSE;
  CPFP_Stat->SuperVerbose = FALSE;

  /* Initialize the data tables to be empty */
  CPFP_Image->LengthX = 0;
  CPFP_Image->LengthY = 0;
  CPFP_Image->LengthZ = 0;
  CPFP_Image->Image = NULL;
  CPFP_Image->Map = NULL;
  CPFP_Image->Plane = 1;   /* all */
  CPFP_Image->CroppedImage = NULL;

  /* Initialize the computational parameters */
  CPFP_Comp->istart = 1;
  CPFP_Comp->jstart = 1;
  CPFP_Comp->height = 20;
  CPFP_Comp->width = 20;

  return;

}





