#include <time.h>
#include <stdio.h>
/* #include <malloc.h> */
#include <math.h>
/* #include <ieeefp.h> */
#include <stdlib.h>
#include <string.h>
/* #include <ieeefp.h> */
/* Added - TYB 6/1/09 */
#include "fitsio.h"
#include "nanvalue.h"

#define PROGRAM      "Crosstalk"
#define VERSION      "1.2"
#define NPIXELS      128
#define MA           22
#define PERC         0.15
#define NORDERS      10
#define NL_START     "&CROSSTALK"
#define NL_END       "&END"
#define MAXFILENAMESIZE       256

extern int chnlnum=1;
extern float alpha_fit, w0_fit;

main(int argc, char *argv[])
{
   char input_image_file[MAXFILENAMESIZE]; 
   char input_unc_file[MAXFILENAMESIZE];
   char order_mask_file[MAXFILENAMESIZE];
   char namelistFilename[MAXFILENAMESIZE];
   char output_image_file[MAXFILENAMESIZE];
   char corrected_file[MAXFILENAMESIZE];
   char residual_file[MAXFILENAMESIZE];
   char output_unc_file[MAXFILENAMESIZE];
   char in_bmask[MAXFILENAMESIZE];
   char card[82];
   int i, j, k, l, m, n, l1, m1, m2, n1, status; 
   int nx, ny;
   int box_x0[3], box_x1[3], box_y0[3], box_y1[3];
   int fi1, fi2, fi3, fo1, fo2, fo3, fo4, fb;
   int oldfd[2];
   int imstat, pixels, lines;
   int I_Time;
   int ia[MA+1], iter,itst;
   int NPT, fitflag[NORDERS], lowrow[NPIXELS];
   int xtchinsq = 0, xtkuncor = 0, xtmode=1;
   int row, strongsigrow[NPIXELS], weaksigrow[NPIXELS];
   int startorder=0;
   int debug = 0;
   int fatal_bmask;
   short mask[NPIXELS][NPIXELS];
   float threshold = 2.;
   float alamda,chisq,ochisq,
         sig[NPIXELS+1],tmpsig[30], **covar,**alpha;   
   float x[NPIXELS+1], tmpx[30], y[NPIXELS+1], tmpy[30], tmpz[5], 
         xcenters[NORDERS]={0.}, 
         z[NPIXELS][NPIXELS], z_in[NPIXELS][NPIXELS],
         z_out[NPIXELS][NPIXELS], unc[NPIXELS][NPIXELS],
         medarray[NPIXELS][NPIXELS], model[NPIXELS][NPIXELS], 
	   Om[NORDERS][NPIXELS][NPIXELS],c[NPIXELS][NPIXELS];

   short bmask[NPIXELS][NPIXELS];

   float bscale=1., bzero=0.;
   static float a_first[5], a[MA+1];
   float alpha0_fav, w0_fav;
   float P0, x0, w0, alpha0, flux=0;
   float alpha0_weak=0., w0_weak=0.;
   float box_mean[3], box_sigma, tmp_box_sigma, bgvalue, box_mean_all=0.;
   float median(float *, int);
   double cdelt2 = 0.;

   time_t currenttime;
   char *datetime;
   int mrqmin();
   void getcenters(), lfunct(), harmony();

   /* Switch to CFITSIO routines - TYB 5/1/09 */

   int  I_fits_return_status=0;
   int morekeys = 0;
   int ikeyval = 0;
   int numofkeys;
   int first_history;
   fitsfile *ffp_FITS;
   fitsfile *ffp_FITS_In;
   char mycard[82];
   char mycardout[82] = "";
   char str_end[1] = "";
   char myoutfile1[MAXFILENAMESIZE] = "";
   char myoutfile2[MAXFILENAMESIZE] = "";
   char myoutfile3[MAXFILENAMESIZE] = "";
   char myoutfile4[MAXFILENAMESIZE] = "";
   float z_mine[NPIXELS];

   time(&currenttime);
   datetime = ctime(&currenttime);
   
   /**PARAMS **/
   param(input_image_file,  "-i1 INFILE name of input image",  "infile droopres.fits");

   param(input_unc_file,    "-i2 UNCERTAINTY_FILE name of error file",   "infile error.fits");

   param(order_mask_file,   "-i3 ORDER_MASK name of omask file",   "infile ordermask.fits");

   param(output_image_file, "-o1 UNCORRECTED_IMAGE name of uncorrected_image",     "outfile unremovstraycross.fits");

   param(corrected_file,     "-o2 CORRECTED_IMAGE name of corrected_image",      "outfile removstraycross.fits");

   param(residual_file,     "-o3 RESIDUAL_IMAGE name of residual_image",        "outfile residual.fits");

   param(output_unc_file,   "-o4 OUTPUT_UNC_FILE name of output_unc_file",      "outfile out_unc.fits ");

   param(&threshold,        "-t threshold determinator of modes",        "float: - 2. ");

   param(&w0_fav,           "-w0 w0_FAVORED value of initial guess for w0", "float - 2.4958");

   param(&alpha0_fav,      "-a0 ALPHA0_FAVORED value of initial guess for alpha0", "float - 4.1703");

   param(in_bmask,          "-b BMASKFILE name of bmask file", "infile bmask.fits");

   param(&fatal_bmask,      "-fb BMASKFILE_FATAL value of fatal", "int - 16384");

   param(&debug,          "-v VERBOSE level of printed messages",   "int - 0");

   param(namelistFilename,  "-n NAMELIST_FILE name of Namelist file", "infile - namelist.nl");

   /**ENDPARAMS **/


   status = nl_process(argc, argv, PROGRAM, VERSION, NL_START, NL_END);
   if (status != 0) param_exit(status);

   status = param_begin(argc, argv, PROGRAM, VERSION);
   if (status != 0) param_exit(status);
  
   param_print();   /* Print the parameter settings to stdout. */

   /* Read in input image A */
   fi1 = im_open(input_image_file, "r");
   if (fi1 < 0)
   {
      printf("crosstalk: %s -- Error opening or reading file.\n", input_image_file);
      exit(64);
   }
   cdelt2 = 0.0;
   imstat = im_rkey_i(fi1, &pixels,    "NAXIS1");
   imstat = im_rkey_i(fi1, &lines,     "NAXIS2");
   imstat = im_rkey_i(fi1, &chnlnum,   "CHNLNUM");
   imstat = im_rkey_d(fi1, &cdelt2,    "CDELT2");
   imstat = im_rkey_r(fi1, &bzero,     "BZERO");
   imstat = im_rkey_r(fi1, &bscale,    "BSCALE");

   nx = pixels;
   ny = lines;
   if (cdelt2 >= 0)
      for(j=0; j<ny; ++j)
         im_rpix_r(fi1, z_in[j], nx);
   else
      for(j=0; j<ny; ++j)
         im_rpix_r(fi1, z_in[ny-1-j], nx);

   for (j=0; j<ny; j++)
      for (i=0; i<nx; i++)
         z[j][i] = z_in[j][i];
   
   /* Switch to CFITSIO routines - TYB 6/1/09 */
   /* Close infile first - TYB 6/1/09 */

   im_close(fi1);

   strcat(myoutfile1, "!");
   strcat(myoutfile1, output_image_file);
   fits_create_file(&ffp_FITS, myoutfile1, &I_fits_return_status);
   fits_open_file(&ffp_FITS_In, input_image_file, READONLY, &I_fits_return_status);

   /* Copy the non-HISTORY headers */

   fits_get_hdrspace(ffp_FITS_In, &numofkeys, &morekeys, &I_fits_return_status);
   for(i=0; i<numofkeys; i++){
     fits_read_record(ffp_FITS_In, i+1, mycard, &I_fits_return_status);
     if(strncmp(mycard,"HISTORY ", 8) != 0) {
       fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
     }
   }
   /* Copy the HISTORY headers to the end */

   first_history = 1;
   for(i=0; i<numofkeys; i++){
     fits_read_record(ffp_FITS_In, i+1, mycard, &I_fits_return_status);
     if(strncmp(mycard,"HISTORY ", 8) == 0) {
       if (first_history && mycard[8] != '*'){
	 fits_write_record(ffp_FITS, "HISTORY *0 (imported)", &I_fits_return_status);
       }   
       fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
       first_history = 0;
     }
   }
   if (first_history){
     fits_write_record(ffp_FITS, "HISTORY *0 (imported)", &I_fits_return_status);
   }    

   //    fits_copy_hdu (ffp_FITS_In, ffp_FITS, morekeys, &I_fits_return_status);
   fits_close_file(ffp_FITS_In, &I_fits_return_status);
   ikeyval = 0;
   fits_write_key(ffp_FITS, TINT, "XTCORRED", &ikeyval, " ", &I_fits_return_status);
   sprintf(mycard, "HISTORY CROSSTALK                   v     %s, ran %s ", VERSION, datetime);
   /* Drop trailing characters - TYB 6/1/09 */
   for(i=strlen(mycard)-1; i>=0; i--){
     strcpy(str_end, &mycard[i]);
     if( (strncmp(str_end,"0",1)==0) || (strncmp(str_end,"1",1)==0) || (strncmp(str_end,"2",1)==0) ||
         (strncmp(str_end,"3",1)==0) || (strncmp(str_end,"4",1)==0) || (strncmp(str_end,"5",1)==0) ||
         (strncmp(str_end,"6",1)==0) || (strncmp(str_end,"7",1)==0) || (strncmp(str_end,"8",1)==0) ||
         (strncmp(str_end,"9",1)==0) ) {
       strncpy(mycardout, mycard, i+1);
       break;
     }
   }  
   fits_write_record(ffp_FITS, mycardout, &I_fits_return_status);

   //   /* Output the same input image*/
   //   fo1 = im_open(output_image_file, "w");

   //   if (fo1 < 0)
   //   {
   //      printf("crosstalk: %s -- Error opening to write file.\n", output_image_file);
   //      exit(64);
   //   }

   //   oldfd[0] = fi1;
   //   /*oldfd[1] = -1;*/
   //   im_hdr(fo1, oldfd, 0);
   //   im_wkey_i(fo1, 0,        "XTCORRED");
   //   sprintf(card,"HISTORY CROSSTALK                   v     %s, ran %s", VERSION, datetime);
   //   im_wkey_t(fo1, card,"end");

   for (j=0; j<ny; j++)
     for (i=0; i<nx; i++)
         z_out[j][i] = z[j][i];

   for(j=0; j<ny; ++j) {
     for (i=0; i<nx; i++) {
       z_mine[i] = z_out[j][i];
     }
     fits_write_img(ffp_FITS, TFLOAT, 1+j*nx, nx, z_mine, &I_fits_return_status);               
     //      if ((imstat = im_wpix_r(fo1, z_out[j], nx)) < nx) {
     //         printf("crosstalk: Error writing the data to fo1, imstat = %d\n", imstat);
     //         exit(64);
     //      }
   }
   fits_flush_file(ffp_FITS, &I_fits_return_status);
   fits_close_file(ffp_FITS, &I_fits_return_status);

   /* Read in the Bmask File */
   fb = im_open(in_bmask, "r");
   if (fb == -1)
   {
      printf("ERROR: %s -- not a proper Bmask file.\n", in_bmask);
      exit(64);
   }
   if (fb < 0)
   {
      printf("%s -- ERROR opening or reading file.\n", in_bmask);
      exit(64);
   }

   for(j=0; j<ny; ++j)
      im_rpix_s(fb, bmask[j], nx);

   im_close(fb);

   /* Set the detected fatal data in the image to be NAN */
   for (j=0; j<ny; ++j) 
      for (i=0; i<nx; ++i) {
         if ((bmask[j][i] & fatal_bmask) != 0 ) 

	   /* Changed TYB 6/1/09 */
           z[j][i] = NANVALUE;
	   //            z[j][i] = atof("NaN");

      }
 
   /* Create a median array from the input data */
   x[0] = 0.;
   y[0] = 0.;
   sig[0] = 1.;
   for (i=0; i<NPIXELS; i++) {
      x[i+1] =   i+1;
      sig[i+1] = 1.;
      for (j=0; j<NPIXELS; j++) {
	 medarray[j][i] = 0.;
	 if (j<2) {
	    m1=0; 
            m2=4;
	 }
         else if (j>125) {
	    m1=123;     
            m2=127;
	 }
         else {
	    m1=j-2;
	    m2=j+2;
	 }
         m=0;
         for (k=m1;k<=m2;k++)
	   if (!iznand((double) z[k][i])) {  
	      tmpz[m] = z[k][i];
	      m++;
	 }

         medarray[j][i]= median(tmpz, m);
      }
   }

   /* Read in input uncertainty */
   fi2 = im_open(input_unc_file, "r");
   if (fi2 < 0)
   {
      printf("crosstalk: %s -- Error opening or reading file.\n", input_unc_file);
      exit(64);
   }

   imstat = im_rkey_d(fi2, &cdelt2,    "CDELT2");
   if (cdelt2 >= 0)
      for(j=0; j<ny; ++j)
         im_rpix_r(fi2, unc[j], nx);
   else
      for(j=0; j<ny; ++j)
         im_rpix_r(fi2, unc[ny-1-j], nx);

   /*
   for(j=0; j<ny; ++j)
      for (i=0; i<nx; i++)
	unc[j][i] = sqrt(NPIXELS-22);
   */

   /* Read in the order mask file */

   fi3 = im_open(order_mask_file, "r");
   if (fi3 < 0)
   {
      printf("crosstalk: %s -- Error opening or reading file.\n", order_mask_file);
      exit(64);
   }

   for(j=0; j<ny; ++j)
      im_rpix_s(fi3, mask[j], nx);


   /* Allocate memory for fitting */
   alpha = (float **) malloc((unsigned)((MA+1) * sizeof(float*)));
   if (alpha == NULL)
   {
      printf("Can't allocate required memory\n");
      exit(64);
   }
   
   for(j=0; j<MA+1; ++j)
   {
     *(alpha+j) = (float *) malloc((unsigned)((MA+1) * sizeof(float)));
     if (alpha+j == NULL)
     {
	fprintf(stderr, "Can't allocate required memory\n");
	exit(64);
     }
   }

   covar = (float **) malloc((unsigned)((MA+1) * sizeof(float*)));
   if (covar == NULL)
   {
      printf("Can't allocate required memory\n");
      exit(64);
   }
   
   for(j=0; j<MA+1; ++j)
   {
     *(covar+j) = (float *) malloc((unsigned)((MA+1) * sizeof(float)));
     if (covar+j == NULL)
     {
	fprintf(stderr, "Can't allocate required memory\n");
	exit(64);
     }
   }

   for (k=0; k<3; k++)
      box_mean[k] = 0.;

   /* Short Hi */
   if (chnlnum == 1 )
   {
      startorder = 0;
      box_x0[0]=21;    box_x1[0]=25;
      box_y0[0]=111;   box_y1[0]=126;
      box_x0[1]=19;    box_x1[1]=22;
      box_y0[1]=64;    box_y1[1]=74;
      box_x0[2]=14;    box_x1[2]=21;
      box_y0[2]=2;     box_y1[2]=12;
   }
   /* Long Hi */
   else if (chnlnum == 3) {
      startorder = NORDERS-1; 
      box_x0[0]=109;   box_x1[0]=118;
      box_y0[0]=113;   box_y1[0]=125;
      box_x0[1]=107;   box_x1[1]=112;
      box_y0[1]=52;    box_y1[1]=69;
      box_x0[2]=103;   box_x1[2]=109;
      box_y0[2]=2;     box_y1[2]=15;
   }

   box_mean_all = 0.;
   for (k=0; k<3; k++) {
      n=0;
      for (j=box_y0[k]; j<=box_y1[k]; j++)
	for (i=box_x0[k];i<=box_x1[k];i++) {
           box_mean[k] += medarray[j][i];
	   n++;
	}
      if (n!= 0)
         box_mean[k] /= n;
      box_mean_all += box_mean[k];
   } 
 
   box_mean_all /= 3;
   
   box_sigma = 0;
   for (k=0; k<3; k++) {
      n=0;
      tmp_box_sigma = 0.;
      for (j=box_y0[k]; j<=box_y1[k]; j++)
	 for (i=box_x0[k];i<=box_x1[k];i++) {
            tmp_box_sigma += (medarray[j][i]-box_mean[k])*(medarray[j][i]-box_mean[k]);
	    n++;
	}
      tmp_box_sigma /= n;
      box_sigma += sqrt(tmp_box_sigma);
   }  
   box_sigma /= 3;
   if (box_mean_all < 0) box_mean_all = 0.;


   /* Decide the mode */
   m1=0; m2=0;
   for (j=ny-1; j>=0; j--) {
      for(k=0;k<NORDERS; k++) xcenters[k] = 0.;
      getcenters(mask[j], medarray[j], NPIXELS, xcenters, 0.); 
      if (medarray[j][(int)(xcenters[startorder])] > 
	  threshold*box_sigma + box_mean_all) {
	 strongsigrow[m1] = j;
 	 m1 ++;
      }
      else {
	 weaksigrow[m2] = j;
	 m2++;
      }
   }

   /* Estimate the background value */
   bgvalue = 0.;
   n = 0;
   for (j=0; j<=14; j++)
     for (i=108; i<nx; i++) {
       bgvalue += medarray[j][i];
       n++;
     }
   bgvalue /= n;

   if (m1 == ny) xtmode = 1;
   else if (m1 > 0.3 * (double)ny) xtmode = 2;
   else if (m1 == 0) xtmode = 3;
   else xtmode = 4;

   if (debug)
      printf("m1 = %d, xtmode = %d\n", m1, xtmode);

   if (xtmode != 3)
   {
   /* Fit for the strong signal rows */
   for (row=0; row<m1; row++) {
      j=strongsigrow[row];
      if (debug)
	 printf("Going to fit the strong row %d\n", j);
      for(k=0;k<NORDERS; k++) xcenters[k] = 0.;

      getcenters(mask[j], medarray[j], NPIXELS, xcenters, 0.);

      /* Fit uncontaminated starting order m = 11 (SH) with function 
            f(x) = a0/(1+z^a[3]) where z = (x-a1)/a2 */ 

      for (k=0;k<NORDERS;k++) {
         if (medarray[j][(int)(xcenters[k])] > 
             threshold*box_sigma + box_mean_all) 
	    fitflag[k] = 1;
         else 
	    fitflag[k] = 0;
      }

      a_first[1] = medarray[j][(int)(xcenters[startorder])];
      a_first[2] = xcenters[startorder]-1;
      a_first[3] = w0_fav;
      a_first[4] = alpha0_fav;   
 
      ia[1] = 0;  ia[2] = 1;  ia[3] = 1;  ia[4] = 0;

      if (chnlnum == 1) {
	 NPT = 20;
         for (l=1; l<=NPT; l++) {
	    tmpy[l] = medarray[j][l-1]; 
            tmpx[l] = x[l];
	    tmpsig[l] = (float) sqrt(NPIXELS-4);
         }
      }
      else if  (chnlnum == 3) {
	 NPT = 18;
         for (l=1; l<=NPT; l++) {
	    tmpy[l] = medarray[j][l+110-1]/*-0.7*box_sigma*/; 
	    tmpx[l] = x[l+110-1];
	    tmpsig[l] = (float) sqrt(NPIXELS-4);            
         }
      }

      if (debug) {
         printf("Initial guesses for first order fitting:\n");
         printf("%-g %-g %-g %-g\n", 
               a_first[1], a_first[2], a_first[3], a_first[4]);
      }
      alamda = -1;

      if (mrqmin(tmpx,tmpy,tmpsig,NPT,a_first,ia,4,covar,alpha,&chisq,lfunct,&alamda))
      {
	 if (debug)
             printf("row %d cannot be fitted for the initial try of the first orderfitting.\n");
         alamda=0.0;
         a_first[1] = medarray[j][(int)(xcenters[startorder])];
         a_first[2] = xcenters[startorder]+1;
         a_first[3] = w0_fav;
         a_first[4] = alpha0_fav;   	 
      }

      else {
         itst=0;
         for (;;) {
	    ochisq=chisq;
	    if (mrqmin(tmpx,tmpy,tmpsig,NPT,a_first,ia,4,covar,alpha,&chisq,lfunct,&alamda)!=0)    {
	       if (debug) 
	          printf("row %d cannot be fitted for the first order.\n", j);
	       break;
	    }
	    if (fabs(chisq) < 1e-2 || itst == 6) 
	    { 
	       alamda=0.0;
	       mrqmin(tmpx,tmpy,tmpsig,NPT,a_first,ia,4,covar,alpha,&chisq,lfunct,&alamda);
	       break;
	    }         
	    else
	       itst++;
         }
      }
      a_first[2] -= 1;

      if (debug) {
	 printf("First order fitting results:\n");
         printf("%-g, %-g, %-g, %-g\n", 
                 a_first[1], a_first[2], a_first[3], a_first[4]);
      }
      /* Fit all orders */

      w0_fit = a_first[3];
      alpha_fit = a_first[4];

      for (m=0; m<NORDERS; m++) {
         a[2*m+1] = medarray[j][(int)xcenters[m]];
	 a[2*m+2] = xcenters[m];
      }

      if (chnlnum == 1) {
         a[1] = a_first[1];
         a[2] = a_first[2];
      }
      else if (chnlnum == 3) {
	 a[2*(NORDERS-1)+1] =  a_first[1];
         a[2*(NORDERS-1)+2] =  a_first[2];
      }

      a[2*NORDERS+1] = 0.;
      a[2*NORDERS+2] = 0.;

      NPT = NPIXELS;

      for (i=0; i<NORDERS; i++) {
	  ia[2*i+1] = 0;
          if (fitflag[i] == 1)
	     ia[2*i+2] = 1;
          else 
	     ia[2*i+2] = 0;
      }

      ia[2*NORDERS+1] = 1;
      ia[2*NORDERS+2] = 1;

      if (debug) {
	 printf("Initial parameters for all orders are:\n");
         for (m=0; m<NORDERS; m++)
            printf("%-g, %-g, ", a[2*m+1], a[2*m+2]);
         printf("\n");
      }
      
      for (l=1; l<=NPT; l++) {
	  y[l] = medarray[j][l-1]; 
	  sig[l] = (float) sqrt(NPIXELS-22);
      }

      alamda = -1;      
      if (mrqmin(x,y,sig,NPT,a,ia,MA,covar,alpha,&chisq,harmony,&alamda)!=0)
      {
	 if (debug) 
	     printf("row %d cannot be fitted for the initial try of all orders fitting.\n",j);

      }
 
      else 
      {
         itst=1;
         for (;;) 
         {
	    if (debug) {
	       printf("%s %2d %17s %-g %10s %9.2e\n","Iteration #",itst,
				"chi-squared:",chisq,"alamda:",alamda);

	       for (i=1;i<=MA;i++) printf("%9.4f ",a[i]);
	       printf("\n");
	    }
	    ochisq=chisq;

	    if (mrqmin(x,y,sig,NPT,a,ia,MA,covar,alpha,&chisq,harmony,&alamda)!=0 || iznand((double) chisq))  
            {
	       if (debug) 
	          printf("row %d cannot be fitted for all orders fitting.\n\n",j);
	       break;	       
	    }

            if (/*chisq > ochisq ||*/ /*(ochisq-chisq)/*/fabs(chisq) < 0.01 || itst == 6)
            {
	       alamda=0.0;
	       mrqmin(x,y,sig,NPT,a,ia,MA,covar,alpha,&chisq,harmony,&alamda);
	       break;
	    }
            else
	       itst++;
         }	       
      }

      for (m=0;m<NORDERS;m++)
	 a[2*m+2] -= 1;

      if (debug) {
	  printf("Fitting parameters:\n");
	  for (i=1;i<=MA;i++) printf("%9.4f ",a[i]);
     
	  printf("\nw0 are:\n");
          for (m=0; m<NORDERS; m++) {
	     if (chnlnum == 1) 
                w0 = w0_fit - ((float)m)/9.* 0.15 * w0_fit;
             else if (chnlnum == 3)
                w0 = w0_fit-(startorder-m)/9.*0.15 * w0_fit; 
             printf("%-g ", w0);
	  }
	  printf("\n");
      }

      /* Create a model row from best-fit order parameters,
         and 10 order-images Om form individual order fits */
      if ( (sqrt(chisq)/(NPIXELS-2)) > 5.00) {
	  xtchinsq ++;
      }

      for (i=0; i<NPIXELS; i++) {
	  flux = 0.;
          for (m=0; m<NORDERS; m++) {
	     if (chnlnum == 1)
                w0 = w0_fit-m/9.* 0.15 * w0_fit;
             else if (chnlnum == 3)
                w0 = w0_fit-(startorder-m)/9.*0.15 * w0_fit;
 
	     if (fitflag[m] == 1) 
	        Om[m][j][i]=a[2*m+1]/(1+pow(fabs(x[i]-a[2*m+2])/w0,alpha_fit));
	     else
		Om[m][j][i] = 0.;
	        /* Om[m][j][i]=a[2*m+1]/(1+pow(fabs(x[i]-a[2*m+2])/w0,alpha_fit)); */
             flux += Om[m][j][i];
	  }
	  model[j][i] = flux/*+a[2*NORDERS+1]*x[i]+a[2*NORDERS+2]*/;
      }
      alpha0_weak += alpha_fit ;
      w0_weak += w0_fit;
   }

   if (xtmode == 2)
   {
      alpha0_weak /= m1;
      w0_weak /= m1;
   }
   else if (xtmode == 4)
   {
      alpha0_weak = alpha0_fav;
      w0_weak = w0_fav;
   }

   for (row=0; row<m2; row++) {
      j=weaksigrow[row];
      if (debug)
         printf("Going to fit the weak row %d\n", j);
      for(k=0;k<NORDERS; k++)  xcenters[k] = 0.;
      getcenters(mask[j], medarray[j], NPIXELS, xcenters, 0.);
      for (k=0;k<NORDERS;k++) {
         if (medarray[j][(int)(xcenters[k])] > 
             threshold*box_sigma + box_mean_all) 
	    fitflag[k] = 1;
         else 
	    fitflag[k] = 0;
      }

      for (m=0; m<NORDERS; m++) {
          a[2*m+1] = medarray[j][(int)(xcenters[m])];
	  a[2*m+2] = xcenters[m];
      }

      a[2*NORDERS+1] = 0.;
      a[2*NORDERS+2] = 0.;

      /* Fit all orders */

      w0_fit = w0_weak;
      alpha_fit = alpha0_weak;

      NPT = NPIXELS;

      for (i=0; i<NORDERS; i++) {
	  ia[2*i+1] = 0;
          if (fitflag[i] == 1)
	     ia[2*i+2] = 1;
          else
	     ia[2*i+2] = 0;
      }

      ia[2*NORDERS+1] = 0;
      ia[2*NORDERS+2] = 0;
      
      for (l=1; l<=NPT; l++) {
	  y[l] = medarray[j][l-1]; 
	  sig[l] = (float) sqrt(NPIXELS-22);
      }

      alamda = -1;      
      if (mrqmin(x,y,sig,NPT,a,ia,MA,covar,alpha,&chisq,harmony,&alamda)!=0)
      {
	 if (debug)
	    printf("row %d cannot be fitted for the initial try of all orders fitting.\n",j);

      }
 
      else 
      {
         itst=1;
         for (;;) 
         {
	    if (debug) {
	       printf("%s %2d %17s %-g %10s %9.2e\n","Iteration #",itst,
				"chi-squared:",chisq,"alamda:",alamda);

	       for (i=1;i<=MA;i++) printf("%9.4f ",a[i]);
	       printf("\n");
	    }
	    ochisq=chisq;

	    if (mrqmin(x,y,sig,NPT,a,ia,MA,covar,alpha,&chisq,harmony,&alamda)!=0 || iznand((double) chisq))  
            {
	       if (debug) 
	          printf("row %d cannot be fitted for all orders fitting.\n\n",j);
	       break;	       
	    }
	   
            if (fabs(chisq) < 0.01 || itst == 6) {
	       alamda=0.0;
	       mrqmin(x,y,sig,NPT,a,ia,MA,covar,alpha,&chisq,harmony,&alamda);
	       break;
	    }
            else
	       itst++;
         }	       
      }

      for (m=0;m<NORDERS;m++) 
	  a[2*m+2] -= 1;

      if (debug) {
	  printf("Fitting parameters:\n");
	  for (i=1;i<=MA;i++) printf("%9.4f ",a[i]);
     
	  printf("\nw0 are:\n");
          for (m=0; m<NORDERS; m++) {
	     if (chnlnum == 1)
                w0 = w0_fit - ((float)m)/9.* 0.15 * w0_fit;
             else if (chnlnum == 3)
                w0 = w0_fit - (startorder-m)/9.* 0.15 * w0_fit;
             printf("%-g ", w0);
	  }
	  printf("\n");
	  printf("alpha_fit = %-g\n", alpha_fit);
      }

      for (i=0; i<NPIXELS; i++) {
	  flux = 0.;
          for (m=0; m<NORDERS; m++) {
	     if (chnlnum == 1)
                w0 = w0_fit-m/9.* 0.15 * w0_fit;
             else if (chnlnum == 3)
                w0 = w0_fit-(startorder-m)/9.* 0.15 * w0_fit;
	     if (fitflag[m] == 1)
	        Om[m][j][i] = a[2*m+1]/(1+pow(fabs(x[i]-a[2*m+2])/w0, alpha_fit));
	     else
		Om[m][j][i] = 0;
                /* Om[m][j][i] = a[2*m+1]/(1+pow(fabs(x[i]-a[2*m+2])/w0, alpha_fit)); */

             flux += Om[m][j][i];
          }
	  model[j][i] = flux/*+a[2*NORDERS+1]*x[i]+a[2*NORDERS+2]*/;
      }
   }

   /* Subtract Om from B to determine the cross-talk contribution to 
      order m from all other orders. Result is then multiplied by
      an order mask (for order n) to determine the cross-talk in that
      order. Repeat for each order in turn */

   for (j=0; j<NPIXELS; j++)
      for (i=0; i<NPIXELS; i++) 
	 c[j][i] = 0.;

   /* Sum the masked cross-talk contributions to form the (total) 
      cross-talk image C */

   for (m=0; m<NORDERS; m++) {
      for (j=0;j<NPIXELS;j++)
         for (i=0; i<NPIXELS;i++) {
	    if (chnlnum == 1 ) {
	       if (mask[j][i] == m+11)
		  if (Om[m][j][i] == 0.)
		     c[j][i] = 0.;
                  else
	             c[j][i] += (model[j][i]-Om[m][j][i]);
	    }
            else if (chnlnum == 3 ) {
	       if (mask[j][i] == 20-m)
		 if (Om[m][j][i] == 0.)
		    c[j][i] = 0.;
                 else
	            c[j][i] += (model[j][i]-Om[m][j][i]);
	    }
	}
   }
   }

   for (j=0;j<NPIXELS;j++)
      for (i=0; i<NPIXELS;i++) {
	if (c[j][i] < 0. || xtmode == 3 || c[j][i] >=  z[j][i]*bscale+bzero) 
	  c[j][i] = 0.;
      }

   for (j=0; j<NPIXELS; j++) {
      getcenters(mask[j], medarray[j], NPIXELS, xcenters, 0.);
      for (k=0; k<NORDERS; k++) {
	 if (xcenters[k] == 0. ) {
            for (i=0; i<NPIXELS; i++)
	       c[j][i] = 0.;
	    break;
         }
      }
   }

   /* Corrected image A' = A - C */
   for (j=0; j<NPIXELS; j++)
      for (i=0; i<NPIXELS; i++) {
	 z[j][i] = z_in[j][i] - c[j][i];
         z[j][i] = z[j][i]*bscale+bzero;
      }

   time(&currenttime);
   datetime = ctime(&currenttime);

   /* Switch to CFITSIO routines - TYB 6/1/09 */

   strcat(myoutfile2, "!");
   strcat(myoutfile2, corrected_file);
   fits_create_file(&ffp_FITS, myoutfile2, &I_fits_return_status);
   fits_open_file(&ffp_FITS_In, input_image_file, READONLY, &I_fits_return_status);

   /* Copy the non-HISTORY headers */

   fits_get_hdrspace(ffp_FITS_In, &numofkeys, &morekeys, &I_fits_return_status);
   for(i=0; i<numofkeys; i++){
     fits_read_record(ffp_FITS_In, i+1, mycard, &I_fits_return_status);
     if(strncmp(mycard,"HISTORY ", 8) != 0) {
       fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
     }
   }

   /* Copy the HISTORY headers to the end */

   first_history = 1;
   for(i=0; i<numofkeys; i++){
     fits_read_record(ffp_FITS_In, i+1, mycard, &I_fits_return_status);
     if(strncmp(mycard,"HISTORY ", 8) == 0) {
       if (first_history && mycard[8] != '*'){
         fits_write_record(ffp_FITS, "HISTORY *0 (imported)", &I_fits_return_status);
       }   
       fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
       first_history = 0;
     }
   }
   if (first_history){
     fits_write_record(ffp_FITS, "HISTORY *0 (imported)", &I_fits_return_status);
   }    

   //    fits_copy_hdu (ffp_FITS_In, ffp_FITS, morekeys, &I_fits_return_status);
   fits_close_file(ffp_FITS_In, &I_fits_return_status);
   ikeyval = 1;
   fits_write_key(ffp_FITS, TINT, "XTCORRED", &ikeyval, " ", &I_fits_return_status);
   fits_write_key(ffp_FITS, TINT, "XTCHINSQ", &xtchinsq, " ", &I_fits_return_status);
   fits_write_key(ffp_FITS, TINT, "XTKUNCOR", &xtkuncor, " ", &I_fits_return_status);
   fits_write_key(ffp_FITS, TINT, "XTMODE", &xtmode, " ", &I_fits_return_status);
   sprintf(mycard, "HISTORY CROSSTALK                   v     %s, ran %s ", VERSION, datetime);
   /* Drop trailing characters - TYB 6/1/09 */
   for(i=strlen(mycard)-1; i>=0; i--){
     strcpy(str_end, &mycard[i]);
     if( (strncmp(str_end,"0",1)==0) || (strncmp(str_end,"1",1)==0) || (strncmp(str_end,"2",1)==0) ||
         (strncmp(str_end,"3",1)==0) || (strncmp(str_end,"4",1)==0) || (strncmp(str_end,"5",1)==0) ||
         (strncmp(str_end,"6",1)==0) || (strncmp(str_end,"7",1)==0) || (strncmp(str_end,"8",1)==0) ||
         (strncmp(str_end,"9",1)==0) ) {
       strncpy(mycardout, mycard, i+1);
       break;
     }
   }  
   fits_write_record(ffp_FITS, mycardout, &I_fits_return_status);
    
   //   fo2 = im_open(corrected_file, "w");

   //   if (fo2 < 0)
   //   {
   //      printf("crosstalk: %s -- Error opening to write  file.\n", corrected_file);
   //      exit(64);
   //   }

   //   /*oldfd[0] = fi1;*/
   //   im_hdr(fo2, oldfd, 0);
   //   im_wkey_i(fo2, 1,        "XTCORRED");
   //   im_wkey_i(fo2, xtchinsq, "XTCHINSQ");
   //   im_wkey_i(fo2, xtkuncor, "XTKUNCOR");
   //   im_wkey_i(fo2, xtmode,   "XTMODE");
   //   sprintf(card,"HISTORY CROSSTALK                   v     %s, ran %s", VERSION, datetime);
   //   im_wkey_t(fo2, card,"end");

   for(j=0; j<ny; ++j) {
     for (i=0; i<nx; i++) {
       z_mine[i] = z[j][i];
     }
     fits_write_img(ffp_FITS, TFLOAT, 1+j*nx, nx, z_mine, &I_fits_return_status);               
     //      if ((imstat = im_wpix_r(fo2, z[j], nx)) < nx) {
     //         printf("crosstalk: Error writing the data to fo2, imstat = %d\n", imstat);
     //	 exit(64);
     //      }
   }
   fits_flush_file(ffp_FITS, &I_fits_return_status);
   fits_close_file(ffp_FITS, &I_fits_return_status);

   /* Switch to CFITSIO routines - TYB 6/1/09 */

   strcat(myoutfile3, "!");
   strcat(myoutfile3, residual_file);
   fits_create_file(&ffp_FITS, myoutfile3, &I_fits_return_status);
   fits_open_file(&ffp_FITS_In, input_image_file, READONLY, &I_fits_return_status);

   /* Copy the non-HISTORY headers */

   fits_get_hdrspace(ffp_FITS_In, &numofkeys, &morekeys, &I_fits_return_status);
   for(i=0; i<numofkeys; i++){
     fits_read_record(ffp_FITS_In, i+1, mycard, &I_fits_return_status);
     if(strncmp(mycard,"HISTORY ", 8) != 0) {
       fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
     }
   }
   /* Copy the HISTORY headers to the end */

   first_history = 1;
   for(i=0; i<numofkeys; i++){
     fits_read_record(ffp_FITS_In, i+1, mycard, &I_fits_return_status);
     if(strncmp(mycard,"HISTORY ", 8) == 0) {
       if (first_history && mycard[8] != '*'){
         fits_write_record(ffp_FITS, "HISTORY *0 (imported)", &I_fits_return_status);
       }   
       fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
       first_history = 0;
     }
   }
   if (first_history){
     fits_write_record(ffp_FITS, "HISTORY *0 (imported)", &I_fits_return_status);
   }    

   //    fits_copy_hdu (ffp_FITS_In, ffp_FITS, morekeys, &I_fits_return_status);
   fits_close_file(ffp_FITS_In, &I_fits_return_status);
   sprintf(mycard, "HISTORY CROSSTALK                   v     %s, ran %s ", VERSION, datetime);
   /* Drop trailing characters - TYB 6/1/09 */
   for(i=strlen(mycard)-1; i>=0; i--){
     strcpy(str_end, &mycard[i]);
     if( (strncmp(str_end,"0",1)==0) || (strncmp(str_end,"1",1)==0) || (strncmp(str_end,"2",1)==0) ||
	 (strncmp(str_end,"3",1)==0) || (strncmp(str_end,"4",1)==0) || (strncmp(str_end,"5",1)==0) ||
	 (strncmp(str_end,"6",1)==0) || (strncmp(str_end,"7",1)==0) || (strncmp(str_end,"8",1)==0) ||
	 (strncmp(str_end,"9",1)==0) ) {
       strncpy(mycardout, mycard, i+1);
       break;
     }
   }  
   fits_write_record(ffp_FITS, mycardout, &I_fits_return_status);
  
   //   /* residual image  C */
   //   fo3 = im_open(residual_file, "w");

   //   if (fo3 < 0)
   //   {
   //      printf("crosstalk: %s -- Error opening to write file.\n", corrected_file);
   //      exit(64);
   //   }

   //   im_hdr(fo3, oldfd, 0);
   //   sprintf(card,"HISTORY CROSSTALK                   v     %s, ran %s", VERSION, datetime);
   //   im_wkey_t(fo3, card, "end");

  for(j=0; j<ny; ++j) {
    for (i=0; i<nx; i++) {
      z_mine[i] = c[j][i];
    }
    fits_write_img(ffp_FITS, TFLOAT, 1+j*nx, nx, z_mine, &I_fits_return_status);               
     //      if ((imstat = im_wpix_r(fo3, c[j], nx)) < nx) {
     //         printf("crosstalk: Error writing the data to fo3, imstat = %d\n", imstat);
     //	 exit(64);
     //      }
  }
  fits_flush_file(ffp_FITS, &I_fits_return_status);
  fits_close_file(ffp_FITS, &I_fits_return_status);

   /* Switch to CFITSIO routines - TYB 6/1/09 */
  /* Simplified header for this one */

   strcat(myoutfile4, "!");
   strcat(myoutfile4, output_unc_file);
   fits_create_file(&ffp_FITS, myoutfile4, &I_fits_return_status);

   //    fits_copy_hdu (ffp_FITS_In, ffp_FITS, morekeys, &I_fits_return_status);
   ikeyval = 1;
   fits_write_key(ffp_FITS, TLOGICAL, "SIMPLE", &ikeyval, " ", &I_fits_return_status);
   ikeyval = -32;
   fits_write_key(ffp_FITS, TINT, "BITPIX", &ikeyval, " ", &I_fits_return_status);
   ikeyval = 2;
   fits_write_key(ffp_FITS, TINT, "NAXIS", &ikeyval, " ", &I_fits_return_status);
   fits_write_key(ffp_FITS, TINT, "NAXIS1", &nx, " ", &I_fits_return_status);
   fits_write_key(ffp_FITS, TINT, "NAXIS2", &ny, " ", &I_fits_return_status);
   sprintf(mycard, "EXTEND  =                    T / TAPE MAY HAVE STANDARD FITS EXTENSIONS");
   fits_write_record(ffp_FITS, mycard, &I_fits_return_status);
   sprintf(mycard, "HISTORY CROSSTALK                   v     %s, ran %s ", VERSION, datetime);
   /* Drop trailing characters - TYB 6/1/09 */
   for(i=strlen(mycard)-1; i>=0; i--){
     strcpy(str_end, &mycard[i]);
     if( (strncmp(str_end,"0",1)==0) || (strncmp(str_end,"1",1)==0) || (strncmp(str_end,"2",1)==0) ||
	 (strncmp(str_end,"3",1)==0) || (strncmp(str_end,"4",1)==0) || (strncmp(str_end,"5",1)==0) ||
	 (strncmp(str_end,"6",1)==0) || (strncmp(str_end,"7",1)==0) || (strncmp(str_end,"8",1)==0) ||
	 (strncmp(str_end,"9",1)==0) ) {
       strncpy(mycardout, mycard, i+1);
       break;
     }
   }  
   fits_write_record(ffp_FITS, mycardout, &I_fits_return_status);

  //   /* Output the modified uncertainty */
  //   fo4 = im_open(output_unc_file, "w");
   
  //   if (fo4 < 0)
  //   {
  //      printf("crosstalk: %s -- Error opening to write file.\n", output_unc_file);
  //      exit(64);
  //   }
 
  //   /*
  //   oldfd[0] = fi2;
  //   imstat = im_hdr(fo4, oldfd, 0);
  //   */
  //   im_wkey_i(fo4, -32, "BITPIX");
  //   im_wkey_i(fo4,  2,  "NAXIS");
  //   im_wkey_i(fo4, nx,  "NAXIS1");
  //   im_wkey_i(fo4, ny,  "NAXIS2");
  //   sprintf(card,"HISTORY CROSSTALK                   v     %s, ran %s", VERSION, datetime);
  //  im_wkey_t(fo4, card,"end");

   for(j=0; j<ny; ++j) {
     for (i=0; i<nx; i++) {
       z_mine[i] = unc[j][i];
     }
     fits_write_img(ffp_FITS, TFLOAT, 1+j*nx, nx, z_mine, &I_fits_return_status);               
      //    if ((imstat = im_wpix_r(fo4, unc[j], nx)) < nx) 
     //    /* if ((imstat = im_wpix_r(fo4, model[j], nx)) < nx) */      
     //    {
     //         printf("crosstalk: Error writing the data to fo4, imstat = %d\n", imstat);
     //	 exit(64);
     //      }
   }
   fits_flush_file(ffp_FITS, &I_fits_return_status);
   fits_close_file(ffp_FITS, &I_fits_return_status);

   //   im_close(fi1);
   im_close(fi2);
   im_close(fi3);
   //   im_close(fo1);
   //   im_close(fo2);
   //   im_close(fo3);
   //   im_close(fo4);

   param_exit(0);
   exit(0);    
}

void getcenters(short *mask, float *data, int nd, float *xcenters, int offset)
{

   /* We are dealing with an order mask file which has a number on each order
     to identify the order. (like 11 on order 11, 12 on order 12)
     In some case (not normal), the order might touch */

   int i, j=0, k, oldvalue = 0, ordstart=-1, ordend=-1;
      
   for (i=0; i<nd; i++) {
      if (mask[i] == oldvalue && i==127)
	oldvalue = 0;

      if (mask[i] != oldvalue) {
	 /*normal starting case */
         if (ordstart == -1) {
	    ordstart = i;
	    oldvalue = mask[i];
         }
         else {
	    /* normal ending case */
	    ordend = i;    
	    
	    /*
            if (chnlnum == 1)
               xcenters[j] = (ordstart+ordend)/2.-0.5;
            else if (chnlnum == 3)
	       xcenters[j] = (ordstart+ordend)/2.;
	    */

            xcenters[j] = ordstart;
            for (k=0; k<nd; k++) {
	      if ( k >= ordstart && k <= ordend ) {
		 if (data[k] > data[(int)xcenters[j]]) {
		    xcenters[j] = k + offset; 
		 }  
	      }               
	    }
            ordstart = -1;
	    j++;
            /* order touches each other and 
               higher order has a higher value on it */
            if (oldvalue < mask[i])   
	       ordstart = i;
	    oldvalue = mask[i];      
	 }
      }
   }
}

float median(float *x, int n)
{
    int i, j=0;
    int xmax_index, xmin_index;
    float xmax, xmin, x_median, next_x[11];
	    
    if (n==1 || n == 0)
       return x[0];

    xmax = x[0];
    xmin = x[0];
    xmax_index = 0;
    xmin_index = 0;
    for (i=1; i<n; i++) {
       if (x[i] > xmax) {
           xmax = x[i];
           next_x[j++] = x[xmax_index];
           xmax_index=i;
        }
        else if (x[i] < xmin) {
           xmin = x[i];
           if (xmin_index!=0) 
              next_x[j++] = x[xmin_index];          
           xmin_index=i;
	}
        else next_x[j++] = x[i];
    }
    return median(next_x, j);
} 
