/* $Id: cubesub_decode_message.c,v 1.8 2002/09/04 19:56:45 fan Exp $ */


/*********************************************** 
cubesub_decode_message.c

Purpose

Given an error code, write the appropriate error message
into a string.

Overview
Use a switch statement on the error code.

Definitions of Variables

Input:
I_cubesub_message = Code for error message.


Output:
CP_Message = Error message string.

Internal:


***********************************************/

#include <stdio.h>
#include "cubesub.h"
#include "cubesub_defs.h"


cubesub_decode_message(
            int        I_cubesub_message,
            char       *CP_Message)
{

switch(I_cubesub_message)	{
	case 0:
	sprintf(CP_Message, "%s", "No exceptions"); break;
	case NOT_A_NUMBER:
	sprintf(CP_Message, "%s", "NOT_A_NUMBER"); break;
	case MEM_INSUFF:
	sprintf(CP_Message, "%s", "MEM_INSUFF"); break;
	case MAT_SINGULAR:
	sprintf(CP_Message, "%s", "MAT_SINGULAR"); break;
	case POS_EXPECTED:
	sprintf(CP_Message, "%s", "POS_EXPECTED"); break;
	case DIVIDE_ZERO:
	sprintf(CP_Message, "%s", "DIVIDE_ZERO"); break;
	case NNEG_EXPECTED:
	sprintf(CP_Message, "%s", "NNEG_EXPECTED"); break;
	case LOG_NEG:
	sprintf(CP_Message, "%s", "LOG_NEG"); break;
	case ROOT_NEG:
	sprintf(CP_Message, "%s", "ROOT_NEG"); break;
	case MALLOC_FAILED:
	sprintf(CP_Message, "%s", "MALLOC_FAILED"); break;
	case FOPEN_FAILED:
	sprintf(CP_Message, "%s", "FOPEN_FAILED"); break;
	case COULDNOTREAD:
	sprintf(CP_Message, "%s", "COULDNOTREAD"); break;
        case INCRT_ARRAY_DIM:
        sprintf(CP_Message, "%s", "INCRT_ARRAY_DIM"); break;
        case DIFF_CUBE_PLANE:
        sprintf(CP_Message, "%s", "DIFF_CUBE_PLANE"); break;
	case INCRT_ARRAY_MODE:
	sprintf(CP_Message, "%s", "INCRT_ARRAY_MODE"); break;
	case INCRT_ARRAY:
	sprintf(CP_Message, "%s", "INCRT_ARRAY"); break;
	case CL_ARGS_INCRT:
	sprintf(CP_Message, "%s", "CL_ARGS_INCRT"); break;
	case INCRT_PARAMS:
	sprintf(CP_Message, "%s", "INCRT_PARAMS"); break;
	case NL_INCRT:
	sprintf(CP_Message, "%s", "NL_INCRT"); break;
        case BIT_ERROR:
        sprintf(CP_Message, "%s", "BIT_ERROR"); break;
        case MISSING_KEY:
        sprintf(CP_Message, "%s", "MISSING_KEY"); break;
        case INCONSIS_KEY:
        sprintf(CP_Message, "%s", "INCONSIS_KEY"); break;
	default:
	sprintf(CP_Message, "%s", "Unknown error");
}	

}
