/* $Id: cubesub_exit.c,v 1.8 2002/09/04 19:56:46 fan Exp $ */


/*********************************************** 
cubesub_exit.c

Purpose

Cleanly exit the program.

Overview
Deallocate memory and print any diagnostics.

Definitions of Variables

Input:



Output:


Internal:


***********************************************/

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "cubesub.h"
#include "cubesub_defs.h"


cubesub_exit(	
            float      *FPP_Data_In,
            float      *FPP_Vars_In,
            Dims       *Dim_In,
            Status     *Stat,
            short      *SPP_pmask,
            short      *SPP_dmask,
            short      *SPP_bmask,
            short      *SPP_cmask,
            float      *FPP_Dark,
            float      *FPP_Dark_Vars)
{

/* Allocated in cubesub_read_data */

if (FPP_Data_In != NULL) free(FPP_Data_In);
if (FPP_Vars_In != NULL) free(FPP_Vars_In);
if (FPP_Dark != NULL) free(FPP_Dark);
if (FPP_Dark_Vars != NULL) free(FPP_Dark_Vars);
if (SPP_pmask != NULL) free(SPP_pmask);
if (SPP_dmask != NULL) free(SPP_dmask);
if (SPP_bmask != NULL) free(SPP_bmask);
if (SPP_cmask != NULL) free(SPP_cmask);

/* Set up exit status for Opus pipeline.
   For now any non zero status will be output
   as a failure.  There are no warnings.
*/

if(Stat->I_status)
  {
  Stat->I_status = 64;
  }

if(Stat->I_Verbose)
printf("cubesub_exit: Memory Deallocated.\n");
}
