      Subroutine ChkRO2(RCube,NCols,NRows,Row,LC,NMiss,RIBlank,Offset)
c=======================================================================
c
      Real*4    RCube(NCols,Nrows),RIBlank,Offset
      Integer*4 NCols,NRows,LC,NMiss,I,J
      Logical   Row,GotRow,GotCol
c
c=======================================================================
c
      GotRow = .True.
c
      Do 120 J = LC, LC+NMiss-1
        If ((J .lt. 1) .or. (J .gt. NRows)) then
          print *,'ERROR: Illegal row no. in missing-data spec: ',
     +             J,'; NRows = ', NRows
          print *,'MSLC####, NMSD####:',LC,', ',NMiss
          call exit(64)
        End If
        Do 110 I = 1, NCols
          GotRow = GotRow
     +            .and. (Abs(RCube(I,J)-Offset-RIBlank) .lt. 0.5)
110     Continue
120   Continue
c
      GotCol = .True.
c
      Do 220 I = LC, LC+NMiss-1
        If ((I .lt. 1) .or. (I .gt. NCols)) then
          print *,'ERROR: Illegal column no. in missing-data spec: ',
     +             I,'; NCols = ', NCols
          print *,'MSLC####, NMSD####:',LC,', ',NMiss
          call exit(64)
        End If
        Do 210 J = 1, NRows
          GotCol = GotCol
     +            .and. (Abs(RCube(I,J)-Offset-RIBlank) .lt. 0.5)
210     Continue
220   Continue
c
      If (.not.(GotRow .or. GotCol)) then
        print *,'ERROR: Unable to determine readout order!'
        print *,'Neither rows nor columns are filled with ',RIBlank
        print *,'MSLC####, NMSD####:',LC,', ',NMiss
        call exit(64)
      End If
c
      If (GotRow .and. GotCol) then
        print *,'ERROR: Unable to determine readout order!'
        print *,'Both rows and columns are filled with ',RIBlank
        print *,'MSLC####, NMSD####:',LC,', ',NMiss
        call exit(64)
      End If
c
      Row = GotRow
      If (Row) then
        print *,'Readout is in row order'
      Else
        print *,'Readout is in column order'
      End If
c
      Return
      End
