      Subroutine ChkRO3(RCube,NCols,NRows,NPlanes,Row,LC,NMiss,
     +                  RIBlank,Offset)
c=======================================================================
c
      Real*4    RCube(NCols,Nrows,NPlanes),RIBlank,Offset(100)
      Integer*4 NCols,NRows,NPlanes,LC,NMiss,NP,I,J,II,JJ,NPO
      Logical   Row,GotRow,GotCol,IzNaN
c
c=======================================================================
c
      GotRow = .True.
c
      Do 120 JJ = LC, LC+NMiss-1
        J = mod(JJ-1,NRows) + 1
        NP = (JJ-1)/NRows + 1
        NPO = NP
        If (NPO .gt. 100) NPO = 100
        If ((NP .lt. 1) .or. (NP .gt. NPlanes)) then
          print *,'ERROR: Illegal plane no. in missing-data spec: ',
     +             NP,'; NPlanes = ', NPlanes
          print *,'MSLC####, NMSD####: ',LC,', ',NMiss
          call exit(64)
        End If
        Do 110 I = 1, NCols
          If (IzNaN(RCube(I,J,NP))) then
            GotRow = .False.
          else
            GotRow = GotRow
     +      .and. (Abs(RCube(I,J,NP)-Offset(NPO)-RIBlank) .lt. 0.5)
          end if
110     Continue
120   Continue
c
      GotCol = .True.
c
      Do 220 II = LC, LC+NMiss-1
        I = mod(II-1,NCols) + 1
        NP = (II-1)/NCols + 1
        NPO = NP
        If (NPO .gt. 100) NPO = 100
        If ((NP .lt. 1) .or. (NP .gt. NPlanes)) then
          print *,'ERROR: Illegal plane no. in missing-data spec: ',
     +             NP,'; NPlanes = ', NPlanes
          print *,'MSLC####, NMSD####: ',LC,', ',NMiss
          call exit(64)
        End If
        Do 210 J = 1, NRows
          If (IzNaN(RCube(I,J,NP))) then
            GotCol = .False.
          else
            GotCol = GotCol
     +      .and. (Abs(RCube(I,J,NP)-Offset(NPO)-RIBlank) .lt. 0.5)
          end if
210     Continue
220   Continue
c
      If (.not.(GotRow .or. GotCol)) then
        print *,'ERROR: Unable to determine readout order!'
        print *,'Neither rows nor columns are filled with ',RIBlank
        print *,'MSLC####, NMSD####:',LC,', ',NMiss
        call exit(64)
      End If
c
      If (GotRow .and. GotCol) then
        print *,'ERROR: Unable to determine readout order!'
        print *,'Both rows and columns are filled with ',RIBlank
        print *,'MSLC####, NMSD####:',LC,', ',NMiss
        call exit(64)
      End If
c
      Row = GotRow
      If (Row) then
        print *,'Readout is in row order'
      Else
        print *,'Readout is in column order'
      End If
c
      Return
      End
