c=======================================================================
c
c   Read in a SIRTF I*2 data cube, identify its dimensions, and write
c    it out as a R*4 data cube; correct for I*2 sign wraparound
c   Initial version:  1.0  981016
c
c     $Id: cvti2r4.F,v 1.4 2006/10/26 22:07:29 jwf Exp $
c
c   Update vsn 1.0a 981110: removed BLANK keyword from R*4 file; test
c                           for input blanks & convert to output blanks
c              1.0b - 1.0c: intermediate test versions
c              1.0d 990914: added 3rd cmd-line parameter arithmetic
c                           and missing-data processing; added exit
c                           codes
c              1.01 991011: added dmask processing
c              1.01 991028: changed to standard command-line processing
c              1.02 A00321: moved COMMENT fields to end of dmask header;
c                           added "-b" command-line option
c              1.03 A00424: fixed blank/offset bug in missing-data logic
c              1.04 A00711: added RowSpec option
c              1.05 A00818: added "-t" option & dmask input option
c              1.06 A01106: changed MSLC#### and NMSD#### keywords not
c                           to include leading zeros in the index
c              1.07 A01127: added CHNLNUM, INSTRUME, and AREADMOD to
c                           dmask header
c              1.08 A10206: allow -a option to take a comma-separated
c                           list of offsets for each plane
c              1.09 A10416: copy last offset throughout the rest of the
c                           offset array even if no comma was found
c              1.10 A10501: added -r option and -s & -k options
c              1.11 A10817: made enhancements requested by S. Fajardo-
c                           Acosta
c              1.12 A11109: if row/col spec'd on cmd line (-m), then
c                           don't require blank value in missing-data
c                           pixels but NaN them out in any case
c              1.13 A20510: added -x option
c              1.14 A20628: echo input & output file names
c              1.2  A20830: added special processing for MIPS-Ge
c              1.21 A20918: changed COMMENT to standardized HISTORY line
c                           for vsn ID
c              1.22 A21017: changed stim detection for MIPS-Ge from
c                             stmfl = 1 ===> stim on, else off
c                           to
c                             stmfl = 0 ===> stim off, else on
c                           removed IzStim from NAMELIST
c              1.23 A30401: added -f option
c              1.24 A30404: no Access call for files in shared memory
c              1.25 A30501: delete BSCALE from header if there (BZERO
c                           already deleted iff there)
c              1.26 A30719: fix error message for MIPS keywords
c              1.27 A31127: added IRS PEAKUP processing
c              1.28 A40312: added linux compatibility
c              1.29 A50318: added -q processing
c              1.30 A50506: set exit code (Kode) bit #0 if MIPS-Ge
c                           stim is on
c              1.31 A61025: check StimLo <= NPlanes before using, same
c                           for DataLo and DataHi
c
c=======================================================================
c
      Integer*4     I, FileID1, FileID2, IStat, ImOpen, ImClose, Access,
     +              ImWKeyT, ImWKeyI, IArgC, LNBlnk, ImWPixR, NPix,
     +              NRows, NCols, NPlanes, MAlloc, ImRPixS, ImRKeyI,
     +              Kode, NMiss, LC, IMiss, ImWPixS, NArgs, NArg, ITemp,
     +              IBlank, ImRKeyR, NCDM, NRDM, NPDM, ImWKeyC, ImRKeyC,
     +              JDate(3), JTime(3), NumOff, N1, N2, LNB, NPixP,
     +              KSatVal, NRemove, NPixSkip, DMaskBit, NPDMask,
     +              BadBit, DataHi, DataLo, HiSat, LoSat, SatHi, SatLo,
     +              StimHi, StimLo, StimOn, MisBit, SatBHi, SatBLo,
     +              KMIPS, NStim, BadBitB
      Character*150 InFNam, OutFNam, DMaskNam, NumChr2, NumChr3,
     +              BMaskNam, NLNam
      Character*25  NumChr, shmem, PkUpMd, RdOutMod
      Character*11  Vsn
      Character*8   Instrume, CDate, CTime, StmFl(2)
      Character*7   StmP(2)
      Character*4   Num4
      Character*2   Flag
      Integer*2     Cube(*), DMask(*), BMask(*)
      Real*4        RCube(*), R4Blank, Offset(100), RTemp, RIBlank,
     +              SatVal, KStim, PkUpLim, PkUpOff
      Logical       DoDMask,GotIF,GotOF,RowSpec,Comp2,DMaskIn,DoSat,
     +              DoDmaskSet,BMaskIn,MIPSGe,MIPS160,BMist,AddFITS,
     +              DoPkUp,DoQ,Pln2NaN
      Logical       Row                ! T --> rows missing, not columns
      Pointer       (pC, Cube), (pR, RCube), (pD, DMask), (pB, BMask)
c
      Data Vsn/'1.31 A61025'/, Offset/100*0.0/, Kode/0/, IMiss/0/,
     +     DoDMask/.False./, GotIF/.False./, GotOF/.False./,
     +     IBlank/65535/, RowSpec/.False./, Comp2/.True./,
     +     DMaskIn/.False./, KSatVal/3/, DoSat/.False./, NRemove/0/,
     +     DoDmaskSet/.False./, BadBit/11/, HiSat/3/, LoSat/4/,
     +     StimOn/0/, DataHi/0/, DataLo/0/, StimHi/4/, StimLo/0/,
     +     MIPSGe/.False./, MIPS160/.False./, SatHi/65533/, SatLo/2/,
     +     StmFl/'STMFL_70','STMFL160'/, StmP/'STMP_70','STMP160'/,
     +     MisBit/8/, SatBHi/3/, SatBLo/3/, BMaskIn/.False./,
     +     BadBitB/11/, BMist/.False./, AddFITS/.True./,
     +     shmem/'shmem://h'/, PkUpLim/50000.0/, PkUpOff/65536.0/,
     +     DoPkUp/.False./, PkUpMd/'PEAKUP  '/, DoQ/.False./
c
      NameList / CvtIn / BadBit, BadBitB, DataHi, DataLo, HiSat,
     +                   LoSat, MisBit, PkUpLim, PkUpOff,
     +                   SatBHi, SatBLo, SatHi, SatLo,
     +                   shmem, StimHi, StimLo, StimOn, StmFl, StmP
c
c=======================================================================
c
      print *,'SIRTF I*2-to-R*4 Data Cube Conversion program vsn ',Vsn
      NArgs = IArgC()
1     If ((NArgs .lt. 4) .or. (NArgs .gt. 30) .or.
     +    (mod(NArgs,2) .ne. 0)) then
        print *
        print *,'usage:  cvti2r4 <flags> <specifications>'
        print *
        print *,'where <flags> may be: ',
     +          '-a -b -d -f -g -i -k -m -n -o -r -s -t -x'
        print *,'any one of which, if specified, must be followed ',
     +          'by a blank'
        print *,'and a corresponding specification, as follows.'
        print *
        print *,'    -a offset    (offset to be added to each pixel',
     +                            '; optional;'
        print *,'                  may be comma-separated list per',
     +                            ' plane)'
        print *,'    -b blank     (BLANK value for missing data',
     +                            '; optional)'
        print *,'    -d dmasknam  (name of output dmask-image ',
     +                            'file; optional)'
        print *,'    -f <no|yes>  ("no" disables forcing ".fits"',
     +                            ' onto following FITS file names)'
        print *,'    -g GeBmsknam (name of output Ge bmask-image ',
     +                            'file; optional)'
        print *,'    -i infilnam  (name of input file; required)'
        print *,'    -k satbit    (dmask saturation bit, default 3;',
     +                            ' optional)'
        print *,'    -m <row|col> ("row" or "col" for missing data;',
     +                            ' optional)'
        print *,'    -n nlnam     (name of input namelist ',
     +                            'file; optional)'
        print *,'    -o outfilnam (name of output file; required)'
        print *,'    -q <no|yes>  ("yes" enables MIPS24 0 --> NaN',
     +                            ' processing)'
        print *,'    -r #planes   (no. of bottom planes to remove;',
     +                            ' optional)'
        print *,'    -s satval    (saturation value in input DN;',
     +                            ' optional)'
        print *,'    -t <no|yes>  ("no" disables 2''s-complement',
     +                            ' conversion; optional)'
        print *,'    -x pl#,bit#  (set dmask bit# in planes 1-pl#;',
     +                            ' no blanks at comma; optional)'
        call exit(32)
      end if
c
      NArg = 0
4     NArg = NArg + 1
      call GetArg(NArg,Flag)
      NArg = NArg + 1
c
      If (Flag .eq. '-i') then
        call GetArg(NArg,InFNam)
        if (AddFITS .and. (Index(InFNam,'.fits') .eq. 0))
     +    InFNam = InFNam(1:LNBlnk(InFNam))//'.fits'
c               check that input file exists unless it's shared memory
        if (Index(InFNam,shmem(1:lnblnk(shmem))) .ne. 1) then
          if (Access(InFNam(1:LNBlnk(InFNam)),' ') .ne. 0) then
            print *,'File not found: ',InFNam(1:LNBlnk(InFNam))
            call exit(64)
          end if
        end if
        print *,'Input file:  ',InFNam(1:LNBlnk(InFNam))
        GotIF = .True.
c
      else If (Flag .eq. '-d') then
        call GetArg(NArg,DMaskNam)
        if (AddFITS .and. (Index(DMaskNam,'.fits') .eq. 0))
     +    DMaskNam = DMaskNam(1:LNBlnk(DMaskNam))//'.fits'
        DoDMask = .True.
c
      else If (Flag .eq. '-g') then
        call GetArg(NArg,BMaskNam)
        if (AddFITS .and. (Index(BMaskNam,'.fits') .eq. 0))
     +    BMaskNam = BMaskNam(1:LNBlnk(BMaskNam))//'.fits'
        MIPSGe = .True.
c
      else If (Flag .eq. '-m') then
        call GetArg(NArg,NumChr)
        Row = (NumChr(1:1) .eq. 'r') .or. (NumChr(1:1) .eq. 'R')
        RowSpec = .True.
        if (Row) then
          print *,'Missing-data pattern specified as rows'
        else
          print *,'Missing-data pattern specified as columns'
        end if
c
      else If (Flag .eq. '-n') then
        call GetArg(NArg,NLNam)
        if (Access(NLNam(1:LNBlnk(NLNam)),' ') .ne. 0) then
          print *,'File not found: ',NLNam(1:LNBlnk(NLNam))
          call exit(64)
        end if
        Open (10, File = NLNam)
        Read (10, CvtIn, End = 3003, Err= 3002)
        Write (6, CvtIn)
        Close (10)
c
      else If (Flag .eq. '-t') then
        call GetArg(NArg,NumChr)
        Comp2 = (NumChr(1:1) .ne. 'n') .and. (NumChr(1:1) .ne. 'N')
        if (Comp2) then
          print *,'Two''s-complement conversion specified'
        else
          print *,'Two''s-complement conversion has been turned off'
        end if
c
      else If (Flag .eq. '-f') then
        call GetArg(NArg,NumChr)
        If ((NumChr(1:1) .eq. 'n') .or. (NumChr(1:1) .eq. 'N'))
     +  AddFITS = .False.
c
      else If (Flag .eq. '-q') then
        call GetArg(NArg,NumChr)
        If ((NumChr(1:1) .eq. 'y') .or. (NumChr(1:1) .eq. 'Y'))
     +  DoQ = .True.
c
      else If (Flag .eq. '-o') then
        call GetArg(NArg,OutFNam)
        if (AddFITS .and. (Index(OutFNam,'.fits') .eq. 0))
     +    OutFNam = OutFNam(1:LNBlnk(OutFNam))//'.fits'
c
        If (InFNam .eq. OutFNam) then
          print *,
     +     'The input and output files may not have the same name'
          call exit(64)
        End If
        print *,'Output file: ',OutFNam(1:LNBlnk(OutFNam))
        GotOF = .True.
c
      else if (Flag .eq. '-a') then
        Call GetArg(NArg, NumChr2)
        NumChr3 = NumChr2
        NumOff = 0
5       LNB = LNBlnk(NumChr3)
        N2 = Index(NumChr3,',') - 1
        If (N2 .lt. 0) N2 = LNB
        If (NumOff .lt. 100) then
          NumOff = NumOff + 1
        Else
          print *,'CVTI2R4 - WARNING: Only 100 offset values may be ',
     +            'specified'
          Go to 8
        End If
        Read (NumChr3(1:N2),*,Err=10) RTemp
        Offset(NumOff) = RTemp
        If (N2 .lt. LNB) then
          Do 6 N1 = 1, LNB
            NumChr3(N1:N1) = NumChr3(N1+N2+1:N1+N2+1)
6         Continue
          Do 7 N1 = LNB-N2+1, LNB
            NumChr3(N1:N1) = ' '
7         Continue
          Go to 5
        End If
8       If (NumOff .eq. 1) then
          print *,'Using offset = ',Offset(1)
        Else
          print *,'Using offsets: ',(Offset(N1), N1 = 1, NumOff)
        End If
        If (NumOff .lt. 100) then
          Do 9 N1 = NumOff+1, 100
            Offset(N1) = Offset(NumOff)
9         Continue
        End If
        Go to 20
10      print *,'WARNING: ignored illegal offset specification: ',NumChr2
        Kode = 32
        Go to 20
c
      else if (Flag .eq. '-b') then
        Call GetArg(NArg, NumChr)
        Read (NumChr,*,Err=15) ITemp
        IBlank = ITemp
        print *,'Using BLANK-fill value: ',IBlank
        Go to 20
15      print *,'WARNING: ignored illegal BLANK-fill specification: ',
     +           NumChr
        Kode = 32
        Go to 20
c
      else if (Flag .eq. '-k') then
        Call GetArg(NArg, NumChr)
        Read (NumChr,*,Err=16) ITemp
        KSatVal = ITemp
        print *,'Using dmask saturation bit no.: ',KSatVal
        Go to 20
16      print *,'WARNING: ignored illegal dmask saturation bit ',
     +          'specification: ', NumChr
        Kode = 32
        Go to 20
c
      else if (Flag .eq. '-s') then
        Call GetArg(NArg, NumChr)
        Read (NumChr,*,Err=17) RTemp
        SatVal = RTemp
        print *,'Using saturation value: ',SatVal
        DoSat = .True.
        Go to 20
17      print *,'WARNING: ignored illegal saturation value ',
     +          'specification: ', NumChr
        Kode = 32
        Go to 20
c
      else if (Flag .eq. '-r') then
        Call GetArg(NArg, NumChr)
        Read (NumChr,*,Err=18) ITemp
        NRemove = ITemp
        print *,'Removing bottom ',NRemove,' planes'
        Go to 20
18      print *,'WARNING: ignored illegal specification of ',
     +          'bottom planes to remove: ', NumChr
        Kode = 32
        Go to 20
c
      else If (Flag .eq. '-x') then
        call GetArg(NArg,NumChr)
        N2 = Index(NumChr,',')
        If (N2 .eq. 0) Go to 19
        NumChr2 = NumChr(1:N2-1)
        Read (NumChr2,*,Err=19) ITemp
        If (ITemp .lt. 1) Go to 19
        NPDMask = ITemp
        NumChr2 = NumChr(N2+1:LNBlnk(NumChr))
        Read (NumChr2,*,Err=19) ITemp
        If ((ITemp .lt. 0) .or. (ITemp .gt. 15)) Go to 19
        DMaskBit = ITemp
        DoDMaskSet = .True.
        Go to 20
19      print *,'WARNING: ignored illegal "-x" specification: ',NumChr
        Kode = 32
        Go to 20
c
      Else
        print *,'Unrecognized flag: ',Flag
        NArgs = 0
        Print *
        Go to 1
      End If
c
20    If (NArg .lt. NArgs) Go to 4
      If (.not.(GotIF .and. GotOF)) then
        If (.not.GotIF) print *,'No input file name specified'
        If (.not.GotOF) print *,'No output file name specified'
        Print *
        NArgs = 0
        Go to 1
      End If
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      CDate = '00/00/00'
#ifdef __INTEL_COMPILER
      Call IDate(JDate(1),JDate(2),JDate(3))    ! Linux call
#else
      Call IDate(JDate)                         ! Solaris call
#endif
      JDate(3) = Mod(JDate(3), 100)
      Write(CDate(1:2), '(I2)') JDate(2)
      Write(CDate(4:5), '(I2)') JDate(1)
      Write(CDate(7:8), '(I2)') JDate(3)
c
      CTime = '00:00:00'
      Call ITime(JTime)
      Write(CTime(1:2), '(I2)') JTime(1)
      Write(CTime(4:5), '(I2)') JTime(2)
      Write(CTime(7:8), '(I2)') JTime(3)
c
      If (CDate(4:4) .eq. ' ') CDate(4:4) = '0'
      If (CDate(7:7) .eq. ' ') CDate(7:7) = '0'
      If (CTime(4:4) .eq. ' ') CTime(4:4) = '0'
      If (CTime(7:7) .eq. ' ') CTime(7:7) = '0'
c
      RIBlank = IBlank
      Call ImBlank(R4Blank)
      Call GetNAX(InFNam,NCols,NRows,NPlanes,1,FileID1)
      If (NPlanes .le. NRemove) then
        print *,'ERROR: No. of image planes <= no. of planes',
     +                ' to be removed!'
        print *,'Execution aborted'
        call exit(64)
      End If
      If (DoDMaskSet .and. (NPlanes .lt. NPDMask)) then
        print *,'ERROR: No. of image planes < no. of planes',
     +                ' to be masked in dmask!'
        print *,'Execution aborted'
        call exit(64)
      End If
c
      IStat = ImRKeyI(FileID1,I,'BLANK')
      If (IStat .gt. 0) then
        IStat = ImWKeyT(FileID1,'','D')
        print *,'WARNING: removing BLANK keyword from input image'
      end if
      IStat = ImRKeyR(FileID1,I,'BZERO')
      If (IStat .gt. 0) then
        IStat = ImWKeyT(FileID1,'','D')
        print *,'WARNING: removing BZERO keyword from input image'
      end if
      IStat = ImRKeyR(FileID1,I,'BSCALE')
      If (IStat .gt. 0) then
        IStat = ImWKeyT(FileID1,'','D')
        print *,'WARNING: removing BSCALE keyword from input image'
      end if
      IStat = ImRKeyI(FileID1,I,'DCENUM')
      If ((IStat .gt. 0) .and. (I .eq. 3)) then
        IStat = ImRKeyC(FileID1,RdOutMod,'RDOUTMOD')
        If ((IStat .gt. 0) .and. (RdOutMod .eq. PkUpMd) .and.
     +      (PkUpOff .ne. 0.0)) then
          print *,'IRS PEAKUP-mode processing will be done'
          DoPkUp = .True.
        end if
      end if
c
      NPixP = NRows*NCols
      NPix  = NPixP*NPlanes
      NPixSkip = NRemove*NPixP
      pC = MAlloc(2*NPix)
      If (pC .eq. 0) then
        print *,'Unable to allocate memory for ',
     +           InFNam(1:LNBlnk(InFNam))
        call exit(64)
      End If
c
      pR = MAlloc(4*NPix)
      If (pR .eq. 0) then
        print *,'Unable to allocate memory for ',
     +           OutFNam(1:LNBlnk(OutFNam))
        call exit(64)
      End If
c
      pD = MAlloc(2*NPix)
      If (pD .eq. 0) then
        print *,'Unable to allocate memory for ',
     +           DMaskNam(1:LNBlnk(DMaskNam))
        call exit(64)
      End If
c
      Do 25 I = 1, NPix
        DMask(I) = 0
25    Continue
c
      If ((Index(DMaskNam,shmem(1:lnblnk(shmem))) .ne. 1) .and.
     +    (Access(DMaskNam(1:LNBlnk(DMaskNam)),' ') .eq. 0)) then
        DMaskIn = .True.
        Call GetNAX(DMaskNam,NCDM,NRDM,NPDM,1,FileID2)
        If ((NCDM .ne. NCols) .or. (NRDM .ne. NRows) .or.
     +      (NPDM .ne. NPlanes)) then
          print *,'ERROR: Mismatch in dimensions between',
     +                  ' input DCE and dmask'
          print *,InFNam(1:LNBlnk(InFNam)),' has cols/rows/planes: ',
     +            NCols,'/',NRows,'/',NPlanes
          print *,DMaskNam(1:LNBlnk(DMaskNam)),
     +          ' has cols/rows/planes: ',
     +            NCDM,'/',NRDM,'/',NPDM
          print *,'Execution aborted'
          call exit(64)
        End If
        IStat = ImRPixS(FileID2,DMask,NPix)
        If (IStat .ne. NPix) then
          print *,'ERROR: could not read ',DMaskNam(1:LNBlnk(DMaskNam))
          print *,'Error code: ',IStat
          call exit(64)
        end if
        IStat = ImClose(FileID2)
      End if
c
      If (MIPSGe) then
        pB = MAlloc(2*NPixP)
        If (pB .eq. 0) then
          print *,'Unable to allocate memory for ',
     +             BMaskNam(1:LNBlnk(BMaskNam))
          call exit(64)
        End If
        Do 26 I = 1, NPixP
          BMask(I) = 0
26      Continue
c
        If ((Index(BMaskNam,shmem(1:lnblnk(shmem))) .ne. 1) .and.
     +      (Access(BMaskNam(1:LNBlnk(BMaskNam)),' ') .eq. 0)) then
          BMaskIn = .True.
          Call GetNAX(BMaskNam,NCDM,NRDM,NPDM,1,FileID2)
          If ((NCDM .ne. NCols) .or. (NRDM .ne. NRows)) then
            print *,'ERROR: Mismatch in dimensions between',
     +                    ' input DCE and bmask'
            print *,InFNam(1:LNBlnk(InFNam)),' has cols/rows/planes: ',
     +              NCols,'/',NRows,'/',NPlanes
            print *,BMaskNam(1:LNBlnk(BMaskNam)),
     +            ' has cols/rows/planes: ',
     +              NCDM,'/',NRDM,'/',NPDM
            print *,'Execution aborted'
            call exit(64)
          End If
          If (NPDM .ne. 1) then
            print *,'ERROR: input bmask has more than one plane'
            print *,BMaskNam(1:LNBlnk(BMaskNam)),
     +            ' has cols/rows/planes: ',
     +              NCDM,'/',NRDM,'/',NPDM
            print *,'Execution aborted'
            call exit(64)
          End If
          IStat = ImRPixS(FileID2,BMask,NPixP)
          If (IStat .ne. NPixP) then
            print *,'ERROR: could not read ',
     +               BMaskNam(1:LNBlnk(BMaskNam))
            print *,'Error code: ',IStat
            call exit(64)
          end if
          IStat = ImClose(FileID2)
        End if
c
        If (NCols .eq. 32) then
          If (NRows .ne. 32) then
            print *,
     +       'MIPS-Ge processing invoked, but DCE dimensions wrong'
            print *,'MIPS-70 should have cols/rows = 32/32'
            print *,'Got instead ',NCols,'/',NRows
            print *,'Execution aborted'
            call exit(64)
          End If
          KMIPS = 1
        Else If ((NCols .eq. 20) .and. (NRows .eq. 3)) then
          MIPS160 = .True.
          KMIPS = 2
          Call NoMidl(DMask,BMask,NPlanes,BadBit,BadBitB)
        Else
          print *,'MIPS-Ge processing invoked, but DCE dimensions wrong'
          print *,'MIPS-Ge should have cols/rows = 32/32 or 20/3'
          print *,'Got instead ',NCols,'/',NRows
          print *,'Execution aborted'
          call exit(64)
        End If
        IStat = ImRKeyR(FileID1,KStim,StmFl(KMIPS))
        Call ChkStat(IStat,StmFl(KMIPS))
        If (KStim .ne. 0.0) then             ! Stim is on
          IStat = ImRKeyI(FileID1,NStim,StmP(KMIPS)//' ')
          Call ChkStat(IStat,StmP(KMIPS)//' ')
          if (StimLo .gt. NPlanes) then
            print *,'WARNING: NAMELIST set StimLo to', StimLo
            print *,'         but NPlanes =', NPlanes
            print *,'         StimLo set to NPlanes'
            StimLo = NPlanes
            Kode = 32
          end if
          Call SetStim(DMask,NPixP,NPlanes,StimLo,StimHi,
     +                 NStim,BadBit)
          Do 28 I = 1, NPixP
            Call SetBit(BMask(I),StimOn)
28        Continue
C
C  Try this change - TYB 4/8/09
C
           Kode = ior(Kode,1)                 ! Mark stim in exit code
C          Kode = Kode .or. 1                 ! Mark stim in exit code

        Else                                 ! Stim is off
          if (DataLo .gt. NPlanes) then
            print *,'WARNING: NAMELIST set DataLo to', DataLo
            print *,'         but NPlanes =', NPlanes
            print *,'         DataLo set to NPlanes'
            DataLo = NPlanes
            Kode = 32
          end if
          if (DataHi .gt. NPlanes-1) then
            print *,'WARNING: NAMELIST set DataHi to', DataHi
            print *,'         but NPlanes =', NPlanes
            print *,'         DataHi set to NPlanes-1'
            DataHi = NPlanes-1
            Kode = 32
          end if
          Call NotStim(DMask,NPixP,NPlanes,DataLo,DataHi,BadBit)
        End If
      End If
c
      FileID2 = ImOpen(OutFNam, "W")
      If (FileID2 .lt. 1) Then
        print *,'Unable to open output file ',OutFNam(1:LNBlnk(OutFNam))
        call exit(64)
      End If
c
      IStat = ImRPixS(FileID1,Cube,NPix)
      If (IStat .ne. NPix) then
        print *,'ERROR: could not read ',InFNam(1:LNBlnk(InFNam))
        print *,'Error code: ',IStat
        call exit(64)
      end if
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      Do 30  I = 1, NPix             ! Transfer data & compensate for
        RCube(I) = Cube(I)           !  2's-complement if requested
        If (Comp2 .and. (RCube(I) .lt. 0.0))
     +      RCube(I) = RCube(I) + 65536.0
        N1 = (I-1)/NPixP + 1
        If (N1 .gt. 100) N1 = 100
        Pln2NaN = .False.
        if (DoQ .and. (N1 .eq. 2) .and. (Cube(I) .eq. 0)) then
          Pln2NaN = Cube(I-NPixP) .gt. 0
        end if
        if (Pln2NaN) then
          RCube(I) = R4Blank
        else
          RCube(I) = RCube(I) + Offset(N1) ! Apply offset for plane
        end if                             !  (may be 0)
        If (DoPkUp .and. (RCube(I) .ge. PkUpLim))
     +      RCube(I) = RCube(I) - PkUpOff
30    Continue
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
50    IMiss = IMiss + 1              ! Check for missing data
      Call Ch4(IMiss,Num4)
      IStat = ImRKeyI(FileID1,LC,'MSLC'//Num4)
      If (IStat .lt. 1) go to 100
      IStat = ImRKeyI(FileID1,NMiss,'NMSD'//Num4)
      If (IStat .lt. 1) then
        print *,'ERROR: header contained MSLC' // Num4,
     +          ' with no matching NMSD' // Num4
        call exit(64)
      end if
      If (MIPS160) then
        If (BMist) Go to 60
        BMist = .True.                 ! Mark bmask: data were missing
        Do 55 I = 1, NPixP
          Call SetBit(BMask(I),MisBit)
55      Continue
60      Call MstPln(RCube,DMask,NPixP,NPlanes,LC,NMiss,R4Blank)
      Else If (NPlanes .eq. 1) then
        If (.not.RowSpec .and. (IMiss .eq. 1))
     +  Call ChkRO2(RCube,NCols,NRows,Row,LC,NMiss,RIBlank,Offset(1))
        Call SetBl2(RCube,NCols,NRows,Row,LC,NMiss,RowSpec,
     +              R4Blank,RIBlank,Offset(1),DMask)
      else
        If (.not.RowSpec .and. (IMiss .eq. 1))
     +  Call ChkRO3(RCube,NCols,NRows,NPlanes,Row,LC,NMiss,RIBlank,
     +              Offset)
        Call SetBl3(RCube,NCols,NRows,NPlanes,Row,LC,NMiss,RowSpec,
     +              R4Blank,RIBlank,Offset,DMask)
      end if
      Go to 50
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
100   If (BMist) then
        IStat = ImRKeyI(FileID1,I,'MISS_LCT') ! position header pointer
        IStat = ImWKeyT(FileID1,'COMMENT  **** The missing-data '
     +       //'keywords above apply to the previous ****','A')
        IStat = ImWKeyT(FileID1,'COMMENT  **** 28x2xN form of this '
     +       //'DCE, not its current 20x3xN form  ****','A')
      End If
c
      If (DoSat) Then              ! Test for saturation if requested
        Do 120  I = 1, NPix
          If (RCube(I) .ge. SatVal) Call SetBit(DMask(I),KSatVal)
120     Continue                   ! Note: NaNs should test false
      End If
c
      If (MIPSGe) then             ! Test for MIPS-Ge saturation
        Do 150  I = 1, NPix
          If (RCube(I) .lt. SatLo) Call SetBit(DMask(I),LoSat)
          If (RCube(I) .gt. SatHi) Call SetBit(DMask(I),HiSat)
150     Continue                   ! Note: NaNs should test false
      End If
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      Call CpyHdr(FileID1,FileID2)
      IStat = ImWKeyT(FileID2,'HISTORY cvti2r4           v.  '
     +        //Vsn//', generated '//CDate//' at '//CTime,'A')
      I = LNBlnk(InFNam) - 63
      If (I .lt. 1) then
        I = 1
      Else
        InFnam(I:I+2) = '...'
      End If
      IStat = ImWKeyT(FileID2,'COMMENT  input: '
     +        //InFNam(I:LNBlnk(InFNam)),'A')
      IStat = ImWKeyI(FileID2,-32,'BITPIX')
      IStat = ImRKeyI(FileID2,I,'BLANK')
      If (IStat .gt. 0) IStat = ImWKeyT(FileID2,'','D')
      IStat = ImRKeyR(FileID2,I,'BZERO')
      If (IStat .gt. 0) IStat = ImWKeyT(FileID2,'','D')
      IStat = ImRKeyR(FileID2,I,'BSCALE')
      If (IStat .gt. 0) IStat = ImWKeyT(FileID2,'','D')
      If (NRemove .gt. 0)
     +    IStat = ImWKeyI(FileID2,NPlanes-NRemove,'NAXIS3')
c
      IStat = ImWPixR(FileID2,RCube(1+NPixSkip),NPix-NPixSkip)
      If (IStat .ne. NPix-NPixSkip) then
        print *,'Unable to generate output file ',
     +           OutFNam(1:LNBlnk(OutFNam))
        print *,'Error code: ',IStat
        call exit(64)
      End If
      IStat = ImClose(FileID2)
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      If (.not.DoDMask) Go to 500
c
      If (DoDMaskSet) then
        Do 200 I = 1, NPixP*NPDMask
          Call SetBit(DMask(I),DMaskBit)
200     Continue
      End If
c
      If (DMaskIn) then
        FileID2 = ImOpen(DMaskNam, "U")
      Else
        FileID2 = ImOpen(DMaskNam, "W")
      End If
      If (FileID2 .lt. 1) Then
        print *,'Unable to open output file ',
     +           DMaskNam(1:LNBlnk(DMaskNam))
        call exit(64)
      End If
c
      IStat = ImWKeyI(FileID2,16,'BITPIX')
      If (NPlanes-NRemove .eq. 1) then
        IStat = ImWKeyI(FileID2,2,'NAXIS')
        IStat = ImWKeyI(FileID2,NCols,'NAXIS1')
        IStat = ImWKeyI(FileID2,NRows,'NAXIS2')
      Else
        IStat = ImWKeyI(FileID2,3,'NAXIS')
        IStat = ImWKeyI(FileID2,NCols,'NAXIS1')
        IStat = ImWKeyI(FileID2,NRows,'NAXIS2')
        IStat = ImWKeyI(FileID2,NPlanes-NRemove,'NAXIS3')
      End If
c
      IStat = ImRKeyI(FileID1,I,'CHNLNUM')
      If (IStat .lt. 1) then
        print *,'WARNING: could not read CHNLNUM in ',
     +           InFNam(1:LNBlnk(InFNam))
        print *,'ImRKeyI returned code: ',IStat
      Else
        IStat = ImWKeyI(FileID2,I,'CHNLNUM')
      End If
c
      IStat = ImRKeyC(FileID1,Instrume,'INSTRUME')
      If (IStat .lt. 1) then
        print *,'WARNING: could not read INSTRUME in ',
     +           InFNam(1:LNBlnk(InFNam))
        print *,'ImRKeyC returned code: ',IStat
      Else
        IStat = ImWKeyC(FileID2,Instrume,'INSTRUME')
      End If
c
      IStat = ImRKeyI(FileID1,I,'AREADMOD')
      If (IStat .gt. 0) IStat = ImWKeyI(FileID2,I,'AREADMOD')
c
      If (DMaskIn) then
        IStat = ImWKeyT(FileID2,'HISTORY cvti2r4           v.  '
     +        //Vsn//',  updated  '//CDate//' at '//CTime,'A')
      Else
        IStat = ImWKeyT(FileID2,'HISTORY cvti2r4           v.  '
     +        //Vsn//', generated '//CDate//' at '//CTime,'A')
      End If
      IStat = ImWKeyT(FileID2,'COMMENT  This is a dmask image','A')
      I = LNBlnk(InFNam) - 65
      If (I .lt. 1) then
        I = 1
      Else
        InFnam(I:I+2) = '...'
      End If
      IStat = ImWKeyT(FileID2,'COMMENT  DCE: '
     +        //InFNam(I:LNBlnk(InFNam)),'A')
c
      IStat = ImWPixS(FileID2,DMask(1+NPixSkip),NPix-NPixSkip)
      If (IStat .ne. NPix-NPixSkip) then
        print *,'ERROR: could not write ',DMaskNam(1:LNBlnk(DMaskNam))
        print *,'Error code: ',IStat
        call exit(64)
      end if
      IStat = ImClose(FileID2)
c
500   If (.not.MIPSGe) Go to 1000
c
      If (BMaskIn) then
        FileID2 = ImOpen(BMaskNam, "U")
        If (FileID2 .lt. 1) Then
          print *,'Unable to open output file ',
     +             BMaskNam(1:LNBlnk(BMaskNam))
          call exit(64)
        End If
        IStat = ImWKeyT(FileID2,'HISTORY cvti2r4           v.  '
     +        //Vsn//',  updated  '//CDate//' at '//CTime,'E')
      Else
        FileID2 = ImOpen(BMaskNam, "W")
        If (FileID2 .lt. 1) Then
          print *,'Unable to open output file ',
     +             BMaskNam(1:LNBlnk(BMaskNam))
          call exit(64)
        End If
        IStat = ImWKeyI(FileID2,16,'BITPIX')
        IStat = ImWKeyI(FileID2,2,'NAXIS')
        IStat = ImWKeyI(FileID2,NCols,'NAXIS1')
        IStat = ImWKeyI(FileID2,NRows,'NAXIS2')
        IStat = ImRKeyI(FileID1,I,'CHNLNUM')
        Call ChkStat(IStat,'CHNLNUM')
        IStat = ImWKeyI(FileID2,I,'CHNLNUM')
        IStat = ImRKeyC(FileID1,Instrume,'INSTRUME')
        Call ChkStat(IStat,'INSTRUME')
        IStat = ImWKeyC(FileID2,Instrume,'INSTRUME')
        IStat = ImRKeyI(FileID1,I,'AREADMOD')
        If (IStat .gt. 0) IStat = ImWKeyI(FileID2,I,'AREADMOD')
        IStat = ImWKeyT(FileID2,'HISTORY cvti2r4           v.  '
     +        //Vsn//', generated '//CDate//' at '//CTime,'A')
        IStat = ImWKeyT(FileID2,'COMMENT  This is a bmask image','A')
        I = LNBlnk(InFNam) - 65
        If (I .lt. 1) then
          I = 1
        Else
          InFnam(I:I+2) = '...'
        End If
        IStat = ImWKeyT(FileID2,'COMMENT  DCE: '
     +          //InFNam(I:LNBlnk(InFNam)),'A')
      End If
c
      IStat = ImWPixS(FileID2,BMask,NPixP)
      If (IStat .ne. NPixP) then
        print *,'ERROR: could not write ',BMaskNam(1:LNBlnk(BMaskNam))
        print *,'Error code: ',IStat
        call exit(64)
      end if
      IStat = ImClose(FileID2)
c
1000  call exit(Kode)
      stop
c
3002  print *,'ERROR reading NAMELIST input file: ',
     +         NLNam(1:LNBlnk(NLNam))
      call exit(64)
3003  print *,'EOF reading NAMELIST input file: ',
     +         NLNam(1:LNBlnk(NLNam))
      call exit(64)
      stop
c
      end
c
C=======================================================================
c
      Subroutine Ch4(IntVar,ChVar)
c
      Integer*4   IntVar
      Character*4 ChVar
c
      If (IntVar .le. 9) then
        Write (ChVar,'(I1)') IntVar
      Else If (IntVar .le. 99) then
        Write (ChVar,'(I2)') IntVar
      Else If (IntVar .le. 999) then
        Write (ChVar,'(I3)') IntVar
      Else
        Write (ChVar,'(I4)') IntVar
      End If
c
      Return
      End
c
c=======================================================================
c
      Subroutine NoMidl(DMask,BMask,NPlanes,BadBit,BadBitB)
c
      Integer*4 NPlanes,BadBit,BadBitB,I,N
      Integer*2 DMask(20,3,NPlanes), BMask(20,3)
c
c-----------------------------------------------------------------------
c
      Do 10 I = 1, 20
        Call SetBit(BMask(I,2),BadBitB)
10    Continue
c
      Do 30 N = 1, NPlanes
        Do 20 I = 1, 20
          Call SetBit(DMask(I,2,N),BadBit)
20      Continue
30    Continue
c
      Return
      End
c
c=======================================================================
c
      Subroutine SetStim(DMask,NPixP,NPlanes,StimLo,StimHi,
     +                   NStim,BadBit)
c
      Integer*4 NPixP,NPlanes,StimLo,StimHi,NStim,BadBit,I,N
      Integer*2 DMask(NPixP,NPlanes)
c
c-----------------------------------------------------------------------
c
      If (StimLo .gt. 0) then
        Do 20 N = 1, StimLo
          Do 10 I = 1, NPixP
            Call SetBit(DMask(I,N),BadBit)
10        Continue
20      Continue
      End If
c
      If (NStim-StimHi .lt. NPlanes) then
        Do 40 N = NStim-StimHi+1, NPlanes
          Do 30 I = 1, NPixP
            Call SetBit(DMask(I,N),BadBit)
30        Continue
40      Continue
      End If
c
      Return
      End
c
c=======================================================================
c
      Subroutine NotStim(DMask,NPixP,NPlanes,DataLo,DataHi,BadBit)
c
      Integer*4 NPixP,NPlanes,DataLo,DataHi,BadBit,I,N
      Integer*2 DMask(NPixP,NPlanes)
c
c-----------------------------------------------------------------------
c
      If (DataLo .gt. 0) then
        Do 20 N = 1, DataLo
          Do 10 I = 1, NPixP
            Call SetBit(DMask(I,N),BadBit)
10        Continue
20      Continue
      End If
c
      If (DataHi .gt. 0) then
        Do 40 N = NPlanes-DataHi, NPlanes
          Do 30 I = 1, NPixP
            Call SetBit(DMask(I,N),BadBit)
30        Continue
40      Continue
      End If
c
      Return
      End
c
c=======================================================================
c
      Subroutine MstPln(RCube,DMask,NPixP,NPlanes,LC,NMiss,R4Blank)
c
      Integer*4 NPixP,NPlanes,LC,NMiss,I,N,NP1,NP2
      Real*4    RCube(NPixP,NPlanes),R4Blank
      Integer*2 DMask(NPixP,NPlanes)
c
c-----------------------------------------------------------------------
c
      NP1 = (LC+1)/2                  ! 1st plane with missed data
      NP2 = (LC+NMiss)/2              ! last plane with missed data
      Do 20 N = NP1, NP2              ! note: assumes 2 rows/plane in
        Do 10 I = 1, NPixP            !       original DCE
          RCube(I,N) = R4Blank
          Call SetBit(DMask(I,N),14)
10      Continue
20    Continue
c
      Return
      End
c
c=======================================================================
c
      Subroutine SetBit(I2Var,NBit)
C-----------------------------------------------------------------------
C     Set Bit no. "NBit" in "I2Var"
C     LSB = bit no. 0, MSB = bit no. 14, Sign Bit = bit no. 15
C-----------------------------------------------------------------------
      Integer*4 NBit,NWarns
      Integer*2 Power(16),I2Var
      Data NWarns/0/
C
C  Try these two changes - TYB 4/8/09
      Parameter (hexbit15 = Z'8000')
C
      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     + 16384,hexbit15/
C      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
C     + 16384,Z8000/
C-----------------------------------------------------------------------
C
      If ((NBit .lt. 0) .or. (NBit .gt. 15)) Then
        NWarns = NWarns + 1
        If (NWarns .le. 10) Write(6, 6000) NBit
        If (NWarns .eq. 10) Write(6, 6001)
        Return
      End If
C
C  Try this change - TYB 4/8/09
C
       I2Var = ior(I2Var, Power(NBit+1))
C
C      I2Var = I2Var .or. Power(NBit+1)
C
      Return
C-----------------------------------------------------------------------
6000  Format(' SetBit: Warning! bit number outside range (0 - 15), ',
     + I21)
6001  Format('         This is the last warning that will be printed')
C-----------------------------------------------------------------------
      End
c
c=======================================================================
c
      Subroutine ChkStat(I,S)
      Integer*4   I
      Character*8 S
c
      If (I .lt. 1) then
        print *,'ERROR reading ',S,' in input DCE image'
        print *,'Error code: ',I
        print *,'Execution aborted'
        call exit(64)
      End If
c
      Return
      End
c
c=======================================================================
c
      Function IzNaN(R4)
c
      Logical   IzNaN
      Real*4    R4, R4a
      Integer*4 I4, MaskExp, MaskMant
      Equivalence (I4, R4a)
c
      Data MaskExp/2139095040/, MaskMant/8388607/
c
c-----------------------------------------------------------------------
c
c   01111111100000000000000000000000 = 2139095040 = 7F80000 hex
c   00000000011111111111111111111111 =    8388607 =  7FFFFF hex
c
c-----------------------------------------------------------------------
c
      R4a = R4
      IzNaN = ((And(I4,MaskExp)  .eq. MaskExp) .and.
     +         (And(I4,MaskMant) .ne. 0))
      Return
      End
