/* $Id: darkbase_defs.h,v 1.6 2002/09/05 00:15:16 fan Exp $ */


/***********************************************
darkbase_defs.h

Purpose

Define structures.

Definitions of Variables

Filenames
      contains the various filenames.  Filenames are fairly
      self explanitory.

Status
      contains the flag to run in the verbose mode and
      the status flag used to store error messages


Dims
      contains the X and Y dimensions of the images

***********************************************/

typedef struct {

char	CP_Filename_Namelist[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_In[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_In[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Out[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_Out[MAX_FILENAME_LENGTH];
char	CP_Filename_Pmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Dmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Bmask[MAX_FILENAME_LENGTH];
char    CP_Filename_Cmask[MAX_FILENAME_LENGTH];
char    CP_Filename_Umask[MAX_FILENAME_LENGTH];

} Filenames;


typedef struct {

int	I_status;
int	I_Verbose;

} Status;


typedef struct {

int	I_NX;
int	I_NY;
int	I_NZ;

} Dims;


typedef struct {

/*
short  PmaskFatal;
short  DmaskFatal;
short  CmaskFatal;
*/
int   PmaskFatal;
int   DmaskFatal;
int   CmaskFatal;
int   BmaskFatal;
int   In_Vars;
double Trim_Frac;
double Trim_STD_Frac;
double Baseline_Chan1;
double Baseline_Chan2;
double Baseline_Chan3;
double Baseline_Chan4;
double Baseunc_Chan1;
double Baseunc_Chan2;
double Baseunc_Chan3;
double Baseunc_Chan4;

} Constants;
