/* $Id: darkbase_exec.c,v 1.7 2004/05/13 18:30:11 fan Exp $ */


/*********************************************** 
darkbase_exec.c

Calls the initialization functions and main loop of program. Saves
output to a file.

Definitions of Variables in darkbase_defs.h
 
***********************************************/

#include <time.h>         /* time() may need this */
#include <sys/types.h>    /* time() may need this */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "fitsio.h"
#include "darkbase.h"
#include "darkbase_errcodes.h"
#include "darkbase_defs.h"

int main(int argc, char **argv) {			
float	*FP_Data_In=0;
float   *FP_Vars_In=0;
short   *SP_pmask=0;
short   *SP_dmask=0;
short   *SP_bmask=0;
short   *SP_cmask=0;
short   *SP_umask=0;
int     i,j;

Filenames	Fnames;
Constants       Const;
Status		Stat;
Dims            Dim_In;
struct tm       *tmp_time;
time_t          L_time;

/* null filename pointers */

clock();

printf("Pipeline Module DARKBASE Version %2.1f\n", VERSN);

/* Calculate and print to standard out time
   Keep tmp_time and module time for time
   time stamping all output
*/
L_time = time(NULL);
tmp_time = localtime(&L_time);
printf("Processing time ");
printf(asctime(tmp_time));
printf("\n");

/* Set constant default values */
darkbase_init_const( &Fnames, &Const, &Stat);

/* Parse the namelist file */
darkbase_parse_namelist( argc, argv, &Const, &Fnames, &Stat);

/* Parse the command line, replacing values if specified */
darkbase_parse_args( argc, argv, &Const, &Fnames, &Stat);

/* Get the data and keyword values from the input file */
darkbase_read_data( &Fnames, &Dim_In, &FP_Data_In, &FP_Vars_In,
&Stat, &SP_pmask, &SP_dmask, &SP_bmask, &SP_cmask, &SP_umask);

/* Perform numerical computations on the data */
darkbase_compute( &Fnames, &Const, &Dim_In, FP_Data_In, FP_Vars_In,
&Stat, SP_pmask, SP_dmask, SP_bmask, SP_cmask, SP_umask);

/* Save the results as fits files. */			
darkbase_output( &Fnames, &Dim_In, &Const, &Stat, tmp_time, SP_dmask,
FP_Data_In, FP_Vars_In);

/* Print filename, error message and timing data */
darkbase_error_handler( &Stat, &Fnames);

/* Deallocate memory */			
darkbase_exit( FP_Data_In, FP_Vars_In, &Dim_In, &Stat, SP_pmask,
SP_dmask, SP_bmask, SP_cmask, SP_umask);

printf("exit code %d\n", Stat.I_status);

/* Send return value */
exit(Stat.I_status);

}
