/* $Id: darkbase_exit.c,v 1.6 2002/09/05 00:15:17 fan Exp $ */


/*********************************************** 
darkbase_exit.c

Purpose

Cleanly exit the program.

Overview
Deallocate memory and print any diagnostics.

Definitions of Variables

Input:


Output:


Internal:


***********************************************/

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "darkbase.h"
#include "darkbase_errcodes.h"
#include "darkbase_defs.h"


darkbase_exit(	
            float      *FPP_Data_In,
            float      *FPP_Vars_In,
            Dims       *Dim_In,
            Status     *Stat,
            short      *SPP_pmask,
            short      *SPP_dmask,
            short      *SPP_bmask,
            short      *SPP_cmask,
            short      *SPP_umask) {

/* Allocated in darkbase_read_data */

if (FPP_Data_In != NULL) free(FPP_Data_In);
if (FPP_Vars_In != NULL) free(FPP_Vars_In);
if (SPP_pmask != NULL) free(SPP_pmask);
if (SPP_dmask != NULL) free(SPP_dmask);
if (SPP_bmask != NULL) free(SPP_bmask);
if (SPP_cmask != NULL) free(SPP_cmask);
if (SPP_umask != NULL) free(SPP_umask);

/* Set up exit status for pipeline executive.
   For now any non zero status will be output
   as a failure.  There are no warnings.
*/

if(Stat->I_status)
  {
  Stat->I_status = 64;
  }

if(Stat->I_Verbose)
printf("darkbase_exit: Memory Deallocated.\n");
}
