/* $Id: darkbase_init_const.c,v 1.7 2002/09/05 00:15:17 fan Exp $ */


/*********************************************** 
darkbase_init_const.c

Purpose

Set constant values as defined in the header file darkbase_defs.h.

Overview


Definitions of Variables

See "main" function darkbase_exec.


***********************************************/

#include <stdio.h>
#include "darkbase.h"
#include "darkbase_errcodes.h"
#include "darkbase_defs.h"

darkbase_init_const(	
            Filenames	*Fnames,
            Constants   *Const,
            Status  	*Stat)
{

/* Initialize all status flags */
Stat->I_status = 0;
Stat->I_Verbose = 0;

Const->In_Vars = 0;

Const->PmaskFatal = 32767;
Const->DmaskFatal = 32767;
Const->BmaskFatal = 32767;
Const->CmaskFatal = 32767;

Const->Trim_Frac = 1.0;
Const->Trim_STD_Frac = 1.0;

Const->Baseline_Chan1 = 0.0;
Const->Baseline_Chan2 = 0.0;
Const->Baseline_Chan3 = 0.0;
Const->Baseline_Chan4 = 0.0;
Const->Baseunc_Chan1 = 0.0;
Const->Baseunc_Chan2 = 0.0;
Const->Baseunc_Chan3 = 0.0;
Const->Baseunc_Chan4 = 0.0;

sprintf(Fnames->CP_Filename_Pmask, "%s", "");
sprintf(Fnames->CP_Filename_Dmask, "%s", "");
sprintf(Fnames->CP_Filename_Bmask, "%s", "");
sprintf(Fnames->CP_Filename_Cmask, "%s", "");
sprintf(Fnames->CP_Filename_Umask, "%s", "");
sprintf(Fnames->CP_Filename_FITS_In, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Out, "%s", "");
sprintf(Fnames->CP_Filename_Vars_In, "%s", "");
sprintf(Fnames->CP_Filename_Vars_Out, "%s", "");
sprintf(Fnames->CP_Filename_Namelist, "%s", "");
}
