/* $Id: darkdrift_exec.c,v 1.6 2007/08/08 20:25:28 laher Exp $ */


/*********************************************** 
darkdrift_exec.c

Purpose

Main program.
  
***********************************************/

#include <time.h>
#include <stdio.h>
#include "darkdrift_errcodes.h"
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "fitsio.h"
#include "darkdrift.h"
#include "darkdrift_defs.h"


int main(int argc, char **argv)
{		
double	*DP_Data_Image1=NULL;
double	*DP_Data_Image2=NULL;
double	*DP_Data_Image3=NULL;
double	*DP_Data_Image4=NULL;
double	*DP_Data_In_Unc_Image=NULL;
int     *DP_Data_Image_GMask=NULL;

DRI_Constants		DRI_Const;
DRI_Filenames		DRI_Fnames;
DRI_Pathnames		DRI_Paths;
DRI_FITSinfo		DRI_FITS;
DRI_Computation		DRI_Comp;
DRI_Status		DRI_Stat;

clock();

/* Set constant default values */
darkdrift_init_constants( &DRI_Const, &DRI_Fnames, &DRI_Paths, &DRI_FITS, 
&DRI_Comp, &DRI_Stat);

/* Parse the namelist, replacing default values if specified */
darkdrift_parse_namelist( argc, argv, &DRI_Const, &DRI_Fnames, &DRI_Paths, 
&DRI_FITS, &DRI_Stat);

/* Parse the command line, replacing values if specified */
darkdrift_parse_args( argc, argv, &DRI_Const, &DRI_Fnames, &DRI_Paths, 
&DRI_FITS, &DRI_Stat);

/* Expand any environmental variables passed into filename defintions */
darkdrift_expand_envvar( &DRI_Fnames, &DRI_Stat);

/* Get the data and keyword values from the input and output files */
darkdrift_read_data( &DRI_Fnames, &DRI_FITS, &DP_Data_Image1, 
&DP_Data_Image2, &DP_Data_Image3, &DP_Data_Image4, 
&DP_Data_In_Unc_Image, &DP_Data_Image_GMask, &DRI_Stat);

/* Perform binary operation on the data*/
darkdrift_compute_results( &DRI_Const, &DRI_Fnames, &DRI_FITS, 
DP_Data_Image1, DP_Data_Image2, DP_Data_Image3, DP_Data_Image4, 
DP_Data_In_Unc_Image, DP_Data_Image_GMask, &DRI_Comp, &DRI_Stat);

/* Write results to output file */			
darkdrift_output( &DRI_Const, &DRI_Fnames, &DRI_FITS, &DRI_Comp, &DRI_Stat);

/* Print filename, error message and timing data */
darkdrift_log_writer( &DRI_Const, &DRI_Comp, &DRI_FITS, &DRI_Stat, &DRI_Fnames, 
&DRI_Paths);

/* Deallocate memory */			
darkdrift_exit( &DP_Data_Image1, &DP_Data_Image2, &DP_Data_Image3, 
&DP_Data_Image4, &DP_Data_In_Unc_Image, &DP_Data_Image_GMask, 
&DRI_Comp, &DRI_Fnames, &DRI_FITS, &DRI_Stat);

/* Send return value */
exit(DRI_Stat.I_status);

}




