/* $Id: darkdrift_nan.c,v 1.6 2007/08/08 20:25:29 laher Exp $ */


/*********************************************** 
darkdrift_prob_nan.c

Purpose

If there was an error in the computation, replace the result by
an NaN which has diagnostic information encoded in it. 

Overview
Write ones in the most significant bits to make an NaN. Write the code
for the error in the least significant byte. Write the code for the
function in which the error occured in the second least signigicant
byte.

Definitions of Variables

External:
See darkdrift_defs.h and darkdrift_exec.c


Internal:
CP_Prob_darkdrift = Array to write NaN as consectutive characters.
I_darkdrift_message = Code of error that occurred.
I_darkdrift_root = Code of function in which error occurred.

***********************************************/

#include <stdio.h>
#include "darkdrift_errcodes.h"
#include "darkdrift.h"
#include "darkdrift_defs.h"


void darkdrift_nan(double*	 DP_Result,
		   DRI_Status	*DRIP_Stat)
{
unsigned char	CP_Prob_darkdrift[8];

int	I_darkdrift_message;
int	I_darkdrift_root;

/* For assigning a double NaN value - TYB 5/1/09 */
unsigned long long mynand = 0x7fffffffffffffffLL;

DRIP_Stat->I_NaNFlag = 1;

/* Update the NaN count */
DRIP_Stat->I_NaNCount++;

I_darkdrift_message = RIGHT_MASK&(DRIP_Stat->I_status);
I_darkdrift_root = (LEFT_MASK&(DRIP_Stat->I_status))>>16;

CP_Prob_darkdrift[0] = 0x7f;
CP_Prob_darkdrift[1] = 0xf0;
CP_Prob_darkdrift[2] = I_darkdrift_root;
CP_Prob_darkdrift[3] = I_darkdrift_message;
CP_Prob_darkdrift[4] = 0x0;
CP_Prob_darkdrift[5] = 0x0;
CP_Prob_darkdrift[6] = 0x0;
CP_Prob_darkdrift[7] = 0x0;

/* Assigning a double NaN value - TYB 5/1/09 */
 *DP_Result = *(double *)&mynand;

/* *DP_Result = *((double *) CP_Prob_darkdrift); */


if(DRIP_Stat->I_SuperVerbose)	{
printf("darkdrift_prob_nan: D_Prob_darkdrift[0] 0x%02x",
		((unsigned char *) DP_Result)[0]);
printf("%02x", ((unsigned char *) DP_Result)[1]);
printf("%02x", ((unsigned char *) DP_Result)[2]);
printf("%02x", ((unsigned char *) DP_Result)[3]);
printf("%02x", ((unsigned char *) DP_Result)[4]);
printf("%02x", ((unsigned char *) DP_Result)[5]);
printf("%02x", ((unsigned char *) DP_Result)[6]);
printf("%02x\n", ((unsigned char *) DP_Result)[7]);						
}
}





