/* $Id: darkdrift_output_stdkeywords.c,v 1.7 2007/08/08 20:25:30 laher Exp $ */


/*********************************************** 
darkdrift_output_stdkeywords.c

Purpose

Write the standard keyword values to the open fits output file.

***********************************************/

#include <stdio.h>
#include "darkdrift_errcodes.h"
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "darkdrift.h"
#include "darkdrift_defs.h"


void darkdrift_output_stdkeywords(fitsfile	*ffp_FITS,
				  DRI_Filenames	*DRIP_Fnames,
				  DRI_FITSinfo	*DRIP_FITS,
				  DRI_Status	*DRIP_Stat)
{
int	I_fits_return_status=0;
long	I_Num_Out;
char	CP_Keyname[FLEN_KEYWORD];
char    CP_Comment[FLEN_COMMENT];
char    CP_Keyvalue[FLEN_VALUE];

if(DRIP_Stat->I_status) return;

/* Write the keyword values */

sprintf(CP_Keyname, "%s", "SIMPLE");
sprintf(CP_Comment, "%s", "STANDARD FITS FORMAT");
I_Num_Out = 1;	
fits_update_key(ffp_FITS,
		TLOGICAL,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);


sprintf(CP_Keyname, "%s", "BITPIX  ");
sprintf(CP_Comment, "%s", "FOUR-BYTE SINGLE PRECISION FLOATING POINT");
I_Num_Out = -8*sizeof(float);	
fits_update_key(ffp_FITS,
		TLONG,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);


sprintf(CP_Keyname, "%s", "NAXIS1");
sprintf(CP_Comment, "%s", "STANDARD FITS FORMAT");
I_Num_Out = (long) DRIP_FITS->I_Length_X;	
fits_update_key(ffp_FITS,
		TLONG,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);

sprintf(CP_Keyname, "%s", "NAXIS2");
sprintf(CP_Comment, "%s", "STANDARD FITS FORMAT");
I_Num_Out = (long) DRIP_FITS->I_Length_Y;	
fits_update_key(ffp_FITS,
		TLONG,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);

if(I_fits_return_status)
DRIP_Stat->I_status = STD_KEYWORDS|FITS_MSG_MASK|I_fits_return_status;

}






