/* $Id: darkest_defs.h,v 1.6 2002/09/04 19:58:49 fan Exp $ */


/***********************************************
darkest_defs.h

Purpose

Define structures.

Definitions of Variables

Filenames
      contains the various filenames.  Filenames are fairly
      self explanatory.

Status
      contains the flag to run in the verbose mode and
      the status flag used to store error messages


Dims
      contains the X and Y dimensions of the images


Constants
      contains various contant parameters for program

***********************************************/

typedef struct {

char	CP_Filename_Namelist[MAX_FILENAME_LENGTH];
char	CP_Filename_FITSlist_In[MAX_FILENAME_LENGTH];
char    CP_Filename_Varslist_In[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Image[MAX_INPUT_IMAGES][MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_Image[MAX_INPUT_IMAGES][MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Dmask[MAX_INPUT_IMAGES][MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Out[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_Out[MAX_FILENAME_LENGTH];
char	CP_Filename_Pmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Dmasklist[MAX_FILENAME_LENGTH];
char	CP_Filename_Cmask_In[MAX_FILENAME_LENGTH];
char    CP_Filename_Cmask_Out[MAX_FILENAME_LENGTH];

} Filenames;


typedef struct {

int	I_status;
int	I_Verbose;

} Status;


typedef struct {

int	I_NX;
int	I_NY;
int	I_NZ;

} Dims;

typedef struct {

/*
short  PmaskFatal;
short  DmaskFatal;
short  CmaskFatal;
*/
int     PmaskFatal[MAX_FATAL_BITS];
int     DmaskFatal[MAX_FATAL_BITS];
int     CmaskFatal[MAX_FATAL_BITS];
int     PmaskNFatal;
int     DmaskNFatal;
int     CmaskNFatal;
int     Num_FITSfile;
int     Noisy_Blocks;
int     Cube_Abn[MAX_INPUT_IMAGES];
int     Layer_Abn[MAX_PLANE];
int     Num_Cube_Abn;
int     Num_Layer_Abn;
int     Goodfile_Index;
int     QAheader;
float   Trim_Frac;
float   Trim_STD_Frac;
float   Asym_Trim;
float   Med_Fac;
float   Read_Noise;
float   Dksavgof;
float   Dksavgol;
char    Bunit[FITS_VAL_LEN];

} Constants;
