/* $Id: darkest_exit.c,v 1.6 2002/09/04 19:58:50 fan Exp $ */


/*********************************************** 
darkest_exit.c

Purpose

Cleanly exit the program.

Overview
Deallocate memory and print any diagnostics.

Definitions of Variables
see main function darkest_exec.

***********************************************/

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "darkest.h"
#include "darkest_errcodes.h"
#include "darkest_defs.h"


darkest_exit(	
            float      *FPP_Data_In,
	    float      *FPP_Vars_In,
            float      *FPP_Data_Out,
            float      *FPP_Vars_Out,
            float      *DP_Data_In,
            short      *DD_Data_In,
            Dims       *Dim_In,
            Status     *Stat,
            short      *SPP_pmask,
            short      *SPP_dmask,
            short      *SPP_cmask_in,
	    short      *SPP_cmask_out) {

/* Allocated in darkest_read_data, darkest_compute */

if (FPP_Data_In != NULL) free(FPP_Data_In);
if (FPP_Vars_In != NULL) free(FPP_Vars_In);
if (FPP_Data_Out != NULL) free(FPP_Data_Out);
if (FPP_Vars_Out != NULL) free(FPP_Vars_Out);
if (DP_Data_In != NULL) free(DP_Data_In);
if (DD_Data_In != NULL) free(DD_Data_In);
if (SPP_pmask != NULL) free(SPP_pmask);
if (SPP_dmask != NULL) free(SPP_dmask);
if (SPP_cmask_in != NULL) free(SPP_cmask_in);
if (SPP_cmask_out != NULL) free(SPP_cmask_out);

/* Set up exit status for Opus pipeline.
   For now any non zero status will be output
   as a failure.  There are no warnings.
*/

if(Stat->I_status)
  {
  Stat->I_status = 64;
  }

if(Stat->I_Verbose)
printf("darkest_exit: Memory Deallocated.\n");
}
