/* $Id: darkest_find_median.c,v 1.6 2002/09/04 19:58:51 fan Exp $ */


/***************************************
darkest_find_median.c

Purpose
find the median value in a given list
using heapsort on the list

****************************************/

#include <stdlib.h>
#include <math.h>
#include "darkest.h"
#include "darkest_errcodes.h"
#include "darkest_defs.h"

darkest_find_median(double  *array,
	            long    dim,
                    double  *median,
		    double  *absdev,
                    Status  *Stat) {

long i, ir, j, l;
double rra;
long k;
double sum;

l = 0;
ir = dim-1;

if (dim < 2) return;
l=dim>>1;
ir=dim-1;
while(1) {
    if (l > 0) {
       rra=array[--l];
    } else {
       rra=array[ir];
       array[ir]=array[0];
       if (--ir == 0) {
          array[0]=rra;
          break;
       }
    }
    i=l;
    j=l+l+1;
    while (j <= ir) {
         if (j < ir && array[j] < array[j+1]) j++;
         if (rra < array[j]) {
            array[i]=array[j];
            i=j;
            j = (j<<1) + 1;
         } else j=ir+1;
    }
    array[i]=rra;
}

if(dim%2 != 0)
   *median = array[(dim-1)/2];
else
   *median = (array[dim/2-1] + array[dim/2])/2.0;

sum=0.0;
for (k=0; k<dim; k++)
    sum += abs(array[k] - *median);

*absdev = sum/dim;

}
