/* $Id: darkest_init_const.c,v 1.7 2002/09/04 19:58:51 fan Exp $ */


/*********************************************** 
darkest_init_const.c

Purpose

Set constant values as defined in the header file darkest_defs.h.

Overview


Definitions of Variables

See "main" function darkest_exec.


***********************************************/

#include <stdio.h>
#include "darkest.h"
#include "darkest_errcodes.h"
#include "darkest_defs.h"

darkest_init_const(	
            Filenames	*Fnames,
            Constants   *Const,
            Status  	*Stat)
{

int i;

/* Initialize all status flags */
Stat->I_status = 0;
Stat->I_Verbose = 0;

Const->PmaskNFatal = 1;
Const->DmaskNFatal = 1;
Const->CmaskNFatal = 1;

for (i=0; i<MAX_FATAL_BITS; i++) {
   Const->PmaskFatal[i] = 32767;
   Const->DmaskFatal[i] = 32767;
   Const->CmaskFatal[i] = 32767;
}

Const->Num_FITSfile = 0;
Const->Trim_Frac = 1.0;
Const->Trim_STD_Frac = 1.0;
Const->Asym_Trim = 0.00;
Const->Med_Fac = 5.0;
Const->Read_Noise = 0.0;
Const->Noisy_Blocks = 0;
Const->Num_Cube_Abn = 0;
Const->Num_Layer_Abn = 0;
Const->Goodfile_Index = 0;
Const->Dksavgof = 0.0;
Const->Dksavgol = 0.0;
Const->QAheader = 0;

sprintf(Fnames->CP_Filename_Pmask, "%s", "");
sprintf(Fnames->CP_Filename_Dmasklist, "%s", "");
sprintf(Fnames->CP_Filename_Cmask_In, "%s", "");
sprintf(Fnames->CP_Filename_Cmask_Out, "%s", "");
sprintf(Fnames->CP_Filename_FITSlist_In, "%s", "");
sprintf(Fnames->CP_Filename_Varslist_In, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Out, "%s", "");
sprintf(Fnames->CP_Filename_Vars_Out, "%s", "");
sprintf(Fnames->CP_Filename_Namelist, "%s", "");
sprintf(Const->Bunit, "%s", "");

for(i=0; i<MAX_INPUT_IMAGES; ++i) {
   sprintf(Fnames->CP_Filename_FITS_Image[i], "%s", "");
   sprintf(Fnames->CP_Filename_Vars_Image[i], "%s", "");
   sprintf(Fnames->CP_Filename_FITS_Dmask[i], "%s", "");
   Const->Cube_Abn[i] = -1;
}

for(i=0; i<MAX_PLANE; ++i) {
   Const->Layer_Abn[i] = -1;
}

}
