/* $Id: darkest_usage.c,v 1.7 2002/09/04 22:28:01 fan Exp $ */


/*********************************************** 
darkest_usage.c

Purpose
explain the command-line usage of darkest

Overview

***********************************************/

#include <stdio.h>
#include "darkest.h"
#include "darkest_errcodes.h"
#include "darkest_defs.h"


darkest_usage() {

      printf("Usage:\n\n");
      printf("Required arguments:\n");
      printf("-i1	input image list filename\n");
      printf("-o1	output image filename\n");
      printf("-o2	output uncertainty filename\n");
      printf("Optional arguments:\n");
      printf("-n	namelist filename\n"); 
      printf("-i2	intput uncertainty list filename\n");
      printf("-o3	output cmask filename\n");
      printf("-ac	abnormal file indexes in input list; separated by comma (no space) and increasing\n");
      printf("-ap	abnormal plane indexes with abnormal input file; separated by comma (no space) and increasing\n");
      printf("-t1	fraction for symmetrical trim-average; default 1.0\n");
      printf("-t2	symmetrical trim fraction for standard deviation; default 1.0\n");
      printf("-u	fraction for unsymmetrical trim; default 0.0\n");
      printf("-e	factor of median distance for unsymmetrical trim; default 5.0\n");
      printf("-r	read noise per pixel; default 30.0\n");
      printf("-d	input dmask list filename 'DCE pixel status'\n");
      printf("-p	input pmask filename 'hardware status'\n");
      printf("-c	input cmask filename 'Calibration image status'\n");
      printf("-fp	pmask fatal bit templates; separated by comma (no space)\n");
      printf("-fd	dmask fatal bit templates; separated by comma (no space)\n");
      printf("-fc	cmask fatal bit templates; separated by comma (no space)\n");
      printf("-q	QA FITS header writer on if specified\n");
      printf("-v	verbose mode\n\n");

}
