/* $Id: darkest_variance_check.c,v 1.10 2002/11/15 19:52:56 davidh Exp $ */


/*********************************************** 
darkest_variance_check.c

Purpose

examining the variance output array.

***********************************************/

#include <stdio.h>
#include <math.h>
#include "darkest.h"
#include "darkest_errcodes.h"
#include "darkest_defs.h"

darkest_variance_check(	
            Filenames      *Fnames,
            Constants      *Const,
            Dims           *Dim_In,
            float          **FP_Vars_Out,
            short          **SP_cmask_out,
            Status	   *Stat) {
 int	 j, x, y, z, totalnoisy=0;
 float   sum2by2;

 if(Stat->I_status) return;

 for (j=0; j<Dim_In->I_NX*Dim_In->I_NY*Dim_In->I_NZ; ++j) {

   /* Add parentheses - this is an error but we let it slide - TYB 6/1/09 */

       if( ((j % Dim_In->I_NX)*Dim_In->I_NY) < (Dim_In->I_NX*(Dim_In->I_NY-1)-1) ) {
	//      if( (j % (Dim_In->I_NX*Dim_In->I_NY)) < (Dim_In->I_NX*(Dim_In->I_NY-1)-1) ) {
       //     if((j%Dim_In->I_NX*Dim_In->I_NY) < (Dim_In->I_NX*(Dim_In->I_NY-1)-1)) {

        sum2by2 = *(*FP_Vars_Out+j) + *(*FP_Vars_Out+j+Dim_In->I_NX) + *(*FP_Vars_Out+j+1) + *(*FP_Vars_Out+j+1+Dim_In->I_NX);
        if(sum2by2 > Const->Read_Noise*Const->Read_Noise) {
           *(*SP_cmask_out + j) = 2048;
           totalnoisy++;
           z = (int)(j/(float)(Dim_In->I_NX*Dim_In->I_NY))+1;
           y = (int)((j - (z-1)*Dim_In->I_NX*Dim_In->I_NY)/(float)(Dim_In->I_NX)) + 1;
           x = (j - (z-1)*Dim_In->I_NX*Dim_In->I_NY)%Dim_In->I_NX + 1;
/*           printf("darkest_variance_check: noisy 2x2 pixel block found at smaller (x, y) corner of (%d, %d), layer %d\n\n", x, y, z);
*/
        }
     }

 }

 Const->Noisy_Blocks = totalnoisy;
/*
 printf("darkest_variance_check: total %d noisy blocks found.\n\n", totalnoisy);
*/

}
