/* $Id: dntoflux_exit.c,v 1.4 2003/04/21 19:51:39 laher Exp $ */


/*********************************************** 
dntoflux_exit.c

Purpose

Cleanly exit the program.

***********************************************/

#include <time.h>
#include <stdio.h>
#include "dntoflux_errcodes.h"
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "dntoflux.h"
#include "dntoflux_defs.h"


dntoflux_exit(  double			**DPP_Data_Image1,
                double			**DPP_Data_Image2,
                double			**DPP_Data_Image3,
                double			**DPP_Data_Image4,
		DNT_Computation		*DNTP_Comp,
		DNT_FITSinfo		*DNTP_FITS,
		DNT_Filenames	        *DNTP_Fnames,
		DNT_Status		*DNTP_Stat)
{

   if (DNTP_Stat->I_status) return;

   if(DNTP_Stat->I_Debug)
      printf("dntoflux_exit: DPP_Data_Image1 0x%x \n",
         *DPP_Data_Image1);
   if(DNTP_Stat->I_Debug)
      printf("dntoflux_exit: DPP_Data_Image2 0x%x \n",
         *DPP_Data_Image2);
   if(DNTP_Stat->I_Debug)
      printf("dntoflux_exit: DPP_Data_Image3 0x%x \n",
         *DPP_Data_Image3);
   if(DNTP_Stat->I_Debug)
      printf("dntoflux_exit: DPP_Data_Image4 0x%x \n",
         *DPP_Data_Image4);


   /* Allocated in dntoflux_read_data or its subfunctions */

   free(*DPP_Data_Image1);
   free(*DPP_Data_Image2);
   free(*DPP_Data_Image3);
   free(*DPP_Data_Image4);


   /* Allocated in dntoflux_compute_results or its subfunctions */

   free(DNTP_Comp->DP_Output_Array);

   if ((strcmp(DNTP_Fnames->CP_Filename_FITS_Image2,"") != 0) ||
       (strcmp(DNTP_Fnames->CP_Filename_FITS_Image3,"") != 0)) 
      free(DNTP_Comp->DP_Output_Array2);

   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image4,"") != 0) 
      free(DNTP_Comp->DP_Output_Array4);

   free(DNTP_Comp->NumberBadPixels);

   if(DNTP_Stat->I_Verbose)
      printf("dntoflux_exit: Memory Deallocated.\n");

}
