/* $Id: dntoflux_expand_envvar.c,v 1.5 2003/04/21 19:51:39 laher Exp $ */


/*********************************************** 
dntoflux_expand_envvar.c

Purpose
If environmental variables were used in the filename specifications from the
namelist or command line, expand them to string values and rewrite the entry in
the filenames structure.

***********************************************/

#include <stdio.h>
#include "dntoflux_errcodes.h"
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include "dntoflux.h"
#include "dntoflux_defs.h"


dntoflux_expand_envvar(	DNT_Filenames	*DNTP_Fnames,
			DNT_Status	*DNTP_Stat)
{

if (DNTP_Stat->I_status) return;

if (strcmp(DNTP_Fnames->CP_Filename_Namelist,"")) {
   expand_envvar_string(DNTP_Fnames->CP_Filename_Namelist);
   if(DNTP_Stat->I_Verbose)	
      printf("dntoflux_expand_envvar: %s\n", 
      DNTP_Fnames->CP_Filename_Namelist);
}
if (strcmp(DNTP_Fnames->CP_Filename_FITS_Out,"")) {
   expand_envvar_string(DNTP_Fnames->CP_Filename_FITS_Out);
   if(DNTP_Stat->I_Verbose)	
      printf("dntoflux_expand_envvar: %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Out);
}
if (strcmp(DNTP_Fnames->CP_Filename_FITS_Out2,"")) {
   expand_envvar_string(DNTP_Fnames->CP_Filename_FITS_Out2);
   if(DNTP_Stat->I_Verbose)	
      printf("dntoflux_expand_envvar: %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Out2);
}

expand_envvar_string(DNTP_Fnames->CP_Filename_FITS_Image1);
expand_envvar_string(DNTP_Fnames->CP_Filename_Log);

if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image2,"")) {
   expand_envvar_string(DNTP_Fnames->CP_Filename_FITS_Image2);
   if(DNTP_Stat->I_Verbose)	
      printf("dntoflux_expand_envvar: %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Image2);
}

if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image3,"")) {
   expand_envvar_string(DNTP_Fnames->CP_Filename_FITS_Image3);
   if(DNTP_Stat->I_Verbose)	
      printf("dntoflux_expand_envvar: %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Image3);
}

if(DNTP_Stat->I_Verbose)	{
printf("dntoflux_expand_envvar: %s\n", 
   DNTP_Fnames->CP_Filename_FITS_Image1);
printf("dntoflux_expand_envvar: %s\n", 
   DNTP_Fnames->CP_Filename_Log);   
}

}
  
int	expand_envvar_string(char *CP_In)
  {

  char  CP_Copy[STRING_BUFFER_SIZE];
  char  CP_Path[STRING_BUFFER_SIZE];
  char  CP_Expanded[STRING_BUFFER_SIZE];
  char  CP_Ent[STRING_BUFFER_SIZE];
  char  *CPP_TokSlash[STRING_BUFFER_SIZE];
  char  *CPP_TokDollar[STRING_BUFFER_SIZE];
  char	*CP_Slash, *CP_Dollar;
  
  int	i, j, k, l, I_numchars;
  
  
                /* printf("-->CP_In = %s\n",CP_In); */
                j = 1;
                for(i = 0; i < STRING_BUFFER_SIZE; i++)    {
                   if (CP_In[i] == '$') j = 0;
                   if (CP_In[i] == '\0') break;
                }
                if (j) return;
		/* printf("Found dollar sign!   j=%d",j); */
 
		strcpy(CP_Copy, CP_In);
		strcpy(CP_Path, CP_In);
		
		/* strtok clobbers a leading "/" */
		if(strncmp(CP_Path, "/", 1))
		strcpy(CP_Expanded, "");
		else
		strcpy(CP_Expanded, "/");	
		
		/* Replace the "/" token with nulls */
		i=0;
		CPP_TokSlash[i++] = strtok(CP_Path, "/");
		while (CPP_TokSlash[i++] = strtok(NULL, "/"));
		
		for(j=0; j<i-1; j++)	{
		
		/* For each string between the "/"'s put a null at any "$" */
		k=0;
		CPP_TokDollar[k++] = strtok(CPP_TokSlash[j], "$");
		while (CPP_TokDollar[k++] = strtok(NULL, "$"));

		/* Read the resulting parsed strings */ 	
		for(l=0; l<k-1; l++)	{
		sscanf(CPP_TokDollar[l], "%s", CP_Ent);
		/* Expand as an environmental variable if there was a "$" */			
		if(CPP_TokDollar[l]==CPP_TokSlash[j])
		strcat(CP_Expanded, CP_Ent);		
		else
		strcat(CP_Expanded, getenv(CP_Ent));
		}
		if(j<i-2) strcat(CP_Expanded, "/");
		}

		/* strtok clobbers a trailing "/" */
		I_numchars = strlen(CP_Copy);
		if(!strncmp(&CP_Copy[I_numchars-1], "/", 1))
		strcat(CP_Expanded, "/");
				
		strcpy(CP_In, CP_Expanded);
		
  }
  



