/* $Id: dntoflux_init_constants.c,v 1.5 2004/08/27 18:29:37 laher Exp $ */


/*********************************************** 
dntoflux_init_constants.c

Purpose

Set constant values as defined in the header files.

***********************************************/

#include <stdio.h>
#include "dntoflux_errcodes.h"
#include "dntoflux.h"
#include "dntoflux_defs.h"

dntoflux_init_constants(	DNT_Constants	*DNTP_Const,
			DNT_Filenames	*DNTP_Fnames,
			DNT_Pathnames	*DNTP_Paths,
			DNT_FITSinfo	*DNTP_FITS,
			DNT_Computation	*DNTP_Comp,
			DNT_Status	*DNTP_Stat)
{

/* Initialize all status flags. */

   DNTP_Stat->I_status = 0;
   DNTP_Stat->I_NaNFlag = 0;
   DNTP_Stat->I_Debug = 0;
   DNTP_Stat->I_Verbose = 0;
   DNTP_Stat->I_SuperVerbose = 0;
   DNTP_Stat->I_NaNCount = 0;


   /* Set the default conversion type. */

   DNTP_Const->I_Operation = 0;


   /* Set the default conversion factors and associated uncertainties. */

   DNTP_Const->D_ConversionFactor = -999999.0;
   DNTP_Const->D_ConversionFactor1 = -999999.0;
   DNTP_Const->D_ConversionFactor2 = -999999.0;
   DNTP_Const->D_ConversionFactor3 = -999999.0;
   DNTP_Const->D_ConversionFactor4 = -999999.0;

   DNTP_Const->D_ConversionFactorUnc = -999999.0;
   DNTP_Const->D_ConversionFactorUnc1 = -999999.0;
   DNTP_Const->D_ConversionFactorUnc2 = -999999.0;
   DNTP_Const->D_ConversionFactorUnc3 = -999999.0;
   DNTP_Const->D_ConversionFactorUnc4 = -999999.0;


   /* Set the default normalization mode. */

   DNTP_Const->I_NormalizeByExpTimeFlag = 0;
   DNTP_FITS->ExpTime = 1.0;

   /* Set mask thresholds for blanking image pixels. */

   DNTP_Const->I_PMaskThreshold = 65535;
   DNTP_Const->I_DMaskThreshold = 65535;


/* Set array pointers to NULL in case calloc is never called. */

   DNTP_Comp->DP_Output_Array = NULL;
   DNTP_Comp->DP_Output_Array2 = NULL;


/* Put in stdio defaults in case filenames are not given later. */

   sprintf(DNTP_Fnames->CP_Filename_Namelist, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Image1, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Image2, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Image3, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Image4, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Out, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Out2, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_FITS_Out4, "%s", "");
   sprintf(DNTP_Fnames->CP_Filename_Log, "%s", "stdout");


/* Put in stdio defaults in case pathnames are not given later. */

   sprintf(DNTP_Paths->CP_Ancillary_File_Path, "%s", ".");


/* Default is compute median for all planes in data cube of FITS file. */

   DNTP_FITS->I_Data_Plane = 1;


/* Default BUNIT setting for output images. */

   sprintf(DNTP_Const->Bunit_String, "%s", "");

}





