/* $Id: dntoflux_log_writer.c,v 1.5 2003/04/21 19:51:39 laher Exp $ */


/*********************************************** 
dntoflux_log_writer.c

Purpose

Decode error messages and report.

***********************************************/

#include <time.h>
#include <stdio.h>
#include "dntoflux_errcodes.h"
#include "dntoflux.h"
#include "dntoflux_defs.h"


dntoflux_log_writer(	DNT_Constants	*DNTP_Const,
			DNT_FITSinfo	*DNTP_FITS,
			DNT_Status	*DNTP_Stat,
			DNT_Filenames	*DNTP_Fnames,
			DNT_Pathnames	*DNTP_Paths)
{
int	I_Time;
int	I_dntoflux_message;
int	I_dntoflux_root;
int	I_cfitsio_message=0;

char	CP_Message[I_MESSAGE_LENGTH];
char	CP_Function[I_FCNNAME_LENGTH];

FILE	*fp_Logfile;

time_t  currenttime;
char    *datetime;

if(strcmp(DNTP_Fnames->CP_Filename_Log, "stdout") == 0)	{
   if (DNTP_Stat->I_Verbose)
      fprintf(stdout, "dntoflux_log_writer: Printing Log output to stdout\n");
fp_Logfile = stdout;
}
else	{
fp_Logfile = fopen(DNTP_Fnames->CP_Filename_Log, "a");

if(fp_Logfile==NULL)	{
fprintf(stdout, "dntoflux_log_writer: Could not open Log File, using stdout\n");
fp_Logfile = stdout;
}
}


   fprintf(fp_Logfile,"\nProgram %s, Version %2.1f\n", 
      PROGRAM, DNTVERSN);

   if (strcmp(DNTP_Fnames->CP_Filename_Namelist,"")) {
      fprintf(fp_Logfile, "Namelist File  = %s\n", 
      DNTP_Fnames->CP_Filename_Namelist);
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image1,"")) {
      fprintf(fp_Logfile, "Input Image = %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Image1);
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image2,"")) {
      fprintf(fp_Logfile, "Input PMask = %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Image2);
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image3,"")) {
      fprintf(fp_Logfile, "Input DMask = %s\n", 
      DNTP_Fnames->CP_Filename_FITS_Image3);
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Out,"")) {
      fprintf(fp_Logfile, "Output File 1 = %s\n", 
      &(DNTP_Fnames->CP_Filename_FITS_Out[1]));
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Out2,"")) {
      fprintf(fp_Logfile, "Output File 2 = %s\n", 
      &(DNTP_Fnames->CP_Filename_FITS_Out2[1]));
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Out4,"")) {
      fprintf(fp_Logfile, "Output Uncertainty Image = %s\n", 
      &(DNTP_Fnames->CP_Filename_FITS_Out4[1]));
   }

   fprintf(fp_Logfile, "Operation flag = %d\n", 
      DNTP_Const->I_Operation);
   if (DNTP_Const->I_Operation == 0) {
      fprintf(fp_Logfile, "Conversion factor = %f\n", 
         DNTP_Const->D_ConversionFactor);
   } else {
      fprintf(fp_Logfile, "Readout-channel-1 conversion factor = %f\n", 
         DNTP_Const->D_ConversionFactor1);
      fprintf(fp_Logfile, "Readout-channel-2 conversion factor = %f\n", 
         DNTP_Const->D_ConversionFactor2);
      fprintf(fp_Logfile, "Readout-channel-3 conversion factor = %f\n", 
         DNTP_Const->D_ConversionFactor3);
      fprintf(fp_Logfile, "Readout-channel-4 conversion factor = %f\n", 
         DNTP_Const->D_ConversionFactor4);
   }
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Out4,"")) {
      if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image4,"")) {
         fprintf(fp_Logfile, "Input Uncertainty Image = %s\n", 
         DNTP_Fnames->CP_Filename_FITS_Image4);
      }
      if (DNTP_Const->I_Operation == 0) {
         fprintf(fp_Logfile, "Conversion-factor uncertainty = %f\n", 
            DNTP_Const->D_ConversionFactorUnc);
      } else {
         fprintf(fp_Logfile, 
            "Readout-channel-1 conversion-factor uncertainty = %f\n", 
            DNTP_Const->D_ConversionFactorUnc1);
         fprintf(fp_Logfile, 
            "Readout-channel-2 conversion-factor uncertainty = %f\n", 
            DNTP_Const->D_ConversionFactorUnc2);
         fprintf(fp_Logfile, 
            "Readout-channel-3 conversion-factor uncertainty = %f\n", 
            DNTP_Const->D_ConversionFactorUnc3);
         fprintf(fp_Logfile, 
            "Readout-channel-4 conversion-factor uncertainty = %f\n", 
            DNTP_Const->D_ConversionFactorUnc4);
      }
   }
   fprintf(fp_Logfile, "Output BUNIT setting = %s\n", 
      DNTP_Const->Bunit_String);
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image2,""))
      fprintf(fp_Logfile, "PMask blanking threshold = %d\n", 
         DNTP_Const->I_PMaskThreshold);
   if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image3,""))
      fprintf(fp_Logfile, "DMask blanking threshold = %d\n", 
         DNTP_Const->I_DMaskThreshold);
   fprintf(fp_Logfile, "Normalize-by-EXPTIME Flag = %d\n", 
      DNTP_Const->I_NormalizeByExpTimeFlag);
   if (DNTP_Const->I_NormalizeByExpTimeFlag == 1) {
      fprintf(fp_Logfile, "EXPTIME = %f\n", DNTP_FITS->ExpTime);
   }
   fprintf(fp_Logfile, "Data-Plane Flag = %d\n", 
      DNTP_FITS->I_Data_Plane);
   fprintf(fp_Logfile, "Ancillary Data-File Path = %s\n", 
      DNTP_Paths->CP_Ancillary_File_Path);
   fprintf(fp_Logfile, "Verbose flag = %d\n", 
      DNTP_Stat->I_Verbose);
   fprintf(fp_Logfile, "Super-verbose flag = %d\n", 
      DNTP_Stat->I_SuperVerbose);
   fprintf(fp_Logfile, "Debug flag = %d\n", 
      DNTP_Stat->I_Debug);

   fprintf(fp_Logfile, "%s\n", "Terminating data-units-conversion program.");


I_dntoflux_message = RIGHT_MASK&(DNTP_Stat->I_status);
I_dntoflux_root = (LEFT_MASK&(DNTP_Stat->I_status))>>16;

if(I_dntoflux_message&FITS_MSG_MASK)	{
I_dntoflux_message -= FITS_MSG_MASK;
ffrprt(fp_Logfile, I_dntoflux_message);
}

if (DNTP_Stat->I_Verbose)
   printf("Decoding messages...\n");

decode_message(I_dntoflux_message, I_dntoflux_root,
               CP_Message, CP_Function, DNTP_Paths, DNTP_Stat);

I_dntoflux_message = RIGHT_MASK&(DNTP_Stat->I_status);
I_dntoflux_root = (LEFT_MASK&(DNTP_Stat->I_status))>>16;
if(I_dntoflux_message&FITS_MSG_MASK)   
   I_dntoflux_message -= FITS_MSG_MASK;

if (I_dntoflux_message != 0) {
fprintf(fp_Logfile, "%s 0x%04x\n%s from Function 0x%04x: %s\n",
   "dntoflux Status Message:",
   I_dntoflux_message, CP_Message,  I_dntoflux_root, CP_Function);
} else {
fprintf(fp_Logfile, "%s 0x%04x\n%s from Function 0x%04x: %s\n",
   "dntoflux Status Message:",
   I_dntoflux_message, "Normal exit",  I_dntoflux_root, CP_Function);
}

/* According to John Fowler (8/3/99), there is no need to write anything
   to stderr.

if (I_dntoflux_message != 0) {
   fprintf(stderr, 
     ")-: dntoflux Status Message      0x%04x: %s from Function 0x%04x: %s.\n",
     I_dntoflux_message, CP_Message,  I_dntoflux_root, CP_Function);
}

*/

if(DNTP_Stat->I_NaNFlag)
fprintf(fp_Logfile,
"dntoflux Probs Warning: NaN's were produced in the results.\n");
fprintf(fp_Logfile,
"A total of %8d   NaN's were produced in the results.\n",
DNTP_Stat->I_NaNCount);

I_Time = clock();
fprintf(fp_Logfile, "Processing time: %f seconds\n", (float)I_Time/CLOCKS_PER_SEC);

time(&currenttime);
datetime = ctime(&currenttime);
fprintf(fp_Logfile,"Current date/time: %s",datetime);
fprintf(fp_Logfile,"Program %s, version %2.1f, terminated.\n", 
   PROGRAM, DNTVERSN);


if(fp_Logfile != stdout) fclose(fp_Logfile);


if(DNTP_Stat->I_Verbose)
printf("dntoflux_log_writer: Log Writer finished.\n");


}



decode_message(	int         I_message, 
                int         I_root,
		char	    *CP_Message,
		char	    *CP_Function,
		DNT_Pathnames	*DNTP_Paths,
		DNT_Status	*DNTP_Stat)
{

char codefile[2*MAX_FILENAME_LENGTH],line[80],mess[80],numstr[80],*rem;
int ifun=0, imess=0;
unsigned long num, nums;

FILE *GETCODEBOOK, *fopen();

   sprintf(CP_Function, "%s", "Unspecified function.");
   sprintf(CP_Message, "%s", "Unknown error");
   strcpy(codefile, DNTP_Paths->CP_Ancillary_File_Path);
   strcat(codefile, "/dntoflux_errcodes.h");

   if(DNTP_Stat->I_Verbose) 
      printf("Message-code file = %s\n",codefile);

   if ((GETCODEBOOK = fopen(codefile, "r")) == NULL) {

      printf("*** DNT_log_writer: Could not open dntoflux_errcodes.h\n");

      DNTP_Stat->I_status = LOG_WRITER|LOG_WRITER;
      sprintf(CP_Message,"%s","ERRCODE_FILE_NOT_FOUND");
      sprintf(CP_Function,"%s","LOG_WRITER");

      return;

   } else {

     while (!feof(GETCODEBOOK)) {
        fscanf(GETCODEBOOK, "%s",line);
	if (line[0]== '#') {
           fscanf(GETCODEBOOK, "%s",mess);
           fscanf(GETCODEBOOK, "%s",numstr);
           num = strtoul(numstr,&rem,16);
           nums = (LEFT_MASK & num) >> 16;

           if ((nums == I_root) && (ifun == 0)) {
	     /* printf("%s %X %s\n",mess,nums,rem); */
              sprintf(CP_Function, "%s", mess);
              ifun = 1;
           }

           if ((num == I_message) && (ifun == 1)) {
	     /* printf("%s %X %s\n",mess,num,rem); */
              sprintf(CP_Message, "%s", mess);
	      imess = 1;
              break;
           }
        }
     }
    
     fclose(GETCODEBOOK);

   }

   if ((ifun != 1) || (imess != 1)) {
      printf("*** DNT_log_writer: Error in decoding error message.");
   }

   return;

}



