/* $Id: dntoflux_nan.c,v 1.4 2003/04/21 19:51:39 laher Exp $ */


/*********************************************** 
dntoflux_prob_nan.c

Purpose

If there was an error in the computation, replace the result by
an NaN which has diagnostic information encoded in it. 

Overview
Write ones in the most significant bits to make an NaN. Write the code
for the error in the least significant byte. Write the code for the
function in which the error occured in the second least signigicant
byte.

***********************************************/

#include <stdio.h>
#include "dntoflux_errcodes.h"
#include "dntoflux.h"
#include "dntoflux_defs.h"


dntoflux_nan(	double*		DP_Result,
		DNT_Status	*DNTP_Stat)
{
unsigned char	CP_Prob_dntoflux[8];

int	I_dntoflux_message;
int	I_dntoflux_root;

DNTP_Stat->I_NaNFlag = 1;

/* Update the NaN count */
DNTP_Stat->I_NaNCount++;

I_dntoflux_message = RIGHT_MASK&(DNTP_Stat->I_status);
I_dntoflux_root = (LEFT_MASK&(DNTP_Stat->I_status))>>16;

CP_Prob_dntoflux[0] = 0x7f;
CP_Prob_dntoflux[1] = 0xf0;
CP_Prob_dntoflux[2] = I_dntoflux_root;
CP_Prob_dntoflux[3] = I_dntoflux_message;
CP_Prob_dntoflux[4] = 0x0;
CP_Prob_dntoflux[5] = 0x0;
CP_Prob_dntoflux[6] = 0x0;
CP_Prob_dntoflux[7] = 0x0;

*DP_Result = *((double *) CP_Prob_dntoflux);


if(DNTP_Stat->I_SuperVerbose)	{
printf("dntoflux_prob_nan: D_Prob_dntoflux[0] 0x%02x",
		((unsigned char *) DP_Result)[0]);
printf("%02x", ((unsigned char *) DP_Result)[1]);
printf("%02x", ((unsigned char *) DP_Result)[2]);
printf("%02x", ((unsigned char *) DP_Result)[3]);
printf("%02x", ((unsigned char *) DP_Result)[4]);
printf("%02x", ((unsigned char *) DP_Result)[5]);
printf("%02x", ((unsigned char *) DP_Result)[6]);
printf("%02x\n", ((unsigned char *) DP_Result)[7]);						
}
}





