/* $Id: dntoflux_output_stdkeywords.c,v 1.7 2004/08/23 17:14:12 laher Exp $ */


/*********************************************** 
dntoflux_output_stdkeywords.c

Purpose

Write the standard keyword values to the open fits output file.

***********************************************/

#include <stdio.h>
#include "dntoflux_errcodes.h"
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "dntoflux.h"
#include "dntoflux_defs.h"


dntoflux_output_stdkeywords(	fitsfile	*ffp_FITS,
				DNT_Filenames	*DNTP_Fnames,
				DNT_FITSinfo	*DNTP_FITS,
				DNT_Constants	*DNTP_Const,
                                DNT_Status	*DNTP_Stat)
{
int	I_fits_return_status=0;
long	I_Num_Out;
char	CP_Keyname[FLEN_KEYWORD];
char    CP_Comment[FLEN_COMMENT];
char    CP_Keyvalue[FLEN_VALUE];

if(DNTP_Stat->I_status) return;

/* Write the keyword values */
sprintf(CP_Keyname, "%s", "SIMPLE");
sprintf(CP_Comment, "%s", "STANDARD FITS FORMAT");
I_Num_Out = 1;	
fits_update_key(ffp_FITS,
		TLOGICAL,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);


sprintf(CP_Keyname, "%s", "BITPIX  ");
sprintf(CP_Comment, "%s", "FOUR-BYTE SINGLE PRECISION FLOATING POINT");
I_Num_Out = -8*sizeof(float);	
fits_update_key(ffp_FITS,
		TLONG,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);


sprintf(CP_Keyname, "%s", "NAXIS1");
sprintf(CP_Comment, "%s", "STANDARD FITS FORMAT");
I_Num_Out = (long) DNTP_FITS->I_Length_Y;	
fits_update_key(ffp_FITS,
		TLONG,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);

sprintf(CP_Keyname, "%s", "NAXIS2");
sprintf(CP_Comment, "%s", "STANDARD FITS FORMAT");
I_Num_Out = (long) DNTP_FITS->I_Length_X;	
fits_update_key(ffp_FITS,
		TLONG,
		CP_Keyname,
		&I_Num_Out,
		CP_Comment,
		&I_fits_return_status);

sprintf(CP_Keyname, "%s", "BUNIT");
sprintf(CP_Keyvalue, "%s", DNTP_Const->Bunit_String);
sprintf(CP_Comment, "%s", "Units of image data");
fits_update_key(ffp_FITS,
		TSTRING,
		CP_Keyname,
		CP_Keyvalue,
		CP_Comment,
		&I_fits_return_status);

fits_flush_file(ffp_FITS,
		&I_fits_return_status);

if (DNTP_Stat->I_Verbose)
   printf("DNT_output_stdkeywords:  I_fits_return_status = %d\n",
      I_fits_return_status);



   if (I_fits_return_status)
      DNTP_Stat->I_status = STD_KEYWORDS|FITS_MSG_MASK|I_fits_return_status;

}












