/* $Id: dntoflux_read_data.c,v 1.4 2003/04/21 19:51:40 laher Exp $ */


/*********************************************** 
dntoflux_read_data.c

Purpose

Read the image data from a FITS file and save into an array.

***********************************************/

#include <time.h>
#include <stdio.h>
#include "dntoflux_errcodes.h"
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "dntoflux.h"
#include "dntoflux_defs.h"


dntoflux_read_data(	DNT_Filenames	*DNTP_Fnames,
			DNT_FITSinfo	*DNTP_FITS,
                        DNT_Constants	*DNTP_Const,
			double	**DPP_Data_Image1,
			double	**DPP_Data_Image2,
			double	**DPP_Data_Image3,
			double	**DPP_Data_Image4,
			DNT_Status	*DNTP_Stat)
{
int	i, j, k;
int	I_fits_return_status=0, I_ndims_found, I_anynull;
long	LP_naxes[3];
double	D_nullval=0;


if(DNTP_Stat->I_status) return;

/* Get the data and keyword values from the input image1 file */
dntoflux_read_image1( DNTP_Fnames, DNTP_FITS, DNTP_Const, DPP_Data_Image1, 
   DNTP_Stat);

if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image2,"") != 0)
   dntoflux_read_image2( DNTP_Fnames, DNTP_FITS, DPP_Data_Image2, DNTP_Stat);

if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image3,"") != 0)
   dntoflux_read_image3( DNTP_Fnames, DNTP_FITS, DPP_Data_Image3, DNTP_Stat);

if (strcmp(DNTP_Fnames->CP_Filename_FITS_Image4,"") != 0)
   dntoflux_read_image4( DNTP_Fnames, DNTP_FITS, DPP_Data_Image4, DNTP_Stat);


}

