/* $Id: droopop_decode_message.c,v 1.10 2002/09/04 19:54:11 fan Exp $ */


/*********************************************** 
droopop_decode_message.c

Purpose

Given an error code, write the appropriate error message
into a string.

Overview
Use a switch statement on the error code.

Definitions of Variables

Input:
I_droopop_message = Code for error message.


Output:
CP_Message = Error message string.

Internal:


***********************************************/

#include <stdio.h>
#include "droopop.h"
#include "droopop_errcodes.h"
#include "droopop_defs.h"


droopop_decode_message(
            int        I_droopop_message,
            char       *CP_Message)
{

switch(I_droopop_message)	{
	case 0:
	sprintf(CP_Message, "%s", "No Exceptions"); break;
	case NOT_A_NUMBER:
	sprintf(CP_Message, "%s", "NOT_A_NUMBER"); break;
	case MEM_INSUFF:
	sprintf(CP_Message, "%s", "MEM_INSUFF"); break;
	case MAT_SINGULAR:
	sprintf(CP_Message, "%s", "MAT_SINGULAR"); break;
	case POS_EXPECTED:
	sprintf(CP_Message, "%s", "POS_EXPECTED"); break;
	case DIVIDE_ZERO:
	sprintf(CP_Message, "%s", "DIVIDE_ZERO"); break;
	case NNEG_EXPECTED:
	sprintf(CP_Message, "%s", "NNEG_EXPECTED"); break;
	case LOG_NEG:
	sprintf(CP_Message, "%s", "LOG_NEG"); break;
	case ROOT_NEG:
	sprintf(CP_Message, "%s", "ROOT_NEG"); break;
	case FOPEN_FAILED:
	sprintf(CP_Message, "%s", "FOPEN_FAILED"); break;
	case COULDNOTREAD:
	sprintf(CP_Message, "%s", "COULDNOTREAD"); break;
	case INCRT_ARRAY_MODE:
	sprintf(CP_Message, "%s", "INCRT_ARRAY_MODE"); break;
	case INCRT_ARRAY:
	sprintf(CP_Message, "%s", "INCRT_ARRAY"); break;
	case CL_ARGS_INCRT:
	sprintf(CP_Message, "%s", "CL_ARGS_INCRT"); break;
	case INCRT_PARAMS:
	sprintf(CP_Message, "%s", "INCRT_PARAMS"); break;
	case NL_INCRT:
	sprintf(CP_Message, "%s", "NL_INCRT"); break;
        case NO_ARGS:
        sprintf(CP_Message, "%s", "NO_ARGS"); break;
        case REQ_ARGS_INCOMP:
        sprintf(CP_Message, "%s", "REQ_ARGS_INCOMP"); break;
        case BIT_ERROR:
        sprintf(CP_Message, "%s", "BIT_ERROR"); break;
        case DIM_INCONSIS:
        sprintf(CP_Message, "%s", "DIM_INCONSIS"); break;
        case MALLOC_FAILED:
        sprintf(CP_Message, "%s", "MALLOC_FAILED"); break;
	default:
	sprintf(CP_Message, "%s", "Unknown error");
}	

}
