/* $Id: droopop_error_handler.c,v 1.10 2002/09/04 19:54:12 fan Exp $ */


/*********************************************** 
droopop_error_handler.c

Purpose

Decode error messages and report.

Overview
Append Error Messages to log file.

Definitions of Variables

Input:
IP_status = Return status of droopop functions.
CP_Filename_FITS_In = In Data File Name.
CP_Filename_FITS_Out = Output Probabilities File Name.


Output:


Internal:
I_droopop_message = Code of error that occurred.
I_droopop_root = Code of function in which error occurred.
I_cfitsio_message = Code of cfitsio error returned.

***********************************************/

#include <time.h>
#include <stdio.h>
#include "droopop.h"
#include "droopop_errcodes.h"
#include "droopop_defs.h"


droopop_error_handler(
            Status        *Stat,
            Filenames     *Fnames)
{
int	I_Time;
int	I_droopop_message;
int	I_droopop_root;
int	I_cfitsio_message=0;

char	CP_Message[I_MESSAGE_LENGTH];
char	CP_Function[I_FCNNAME_LENGTH];


I_droopop_message = RIGHT_MASK&(Stat->I_status);
I_droopop_root = (LEFT_MASK&(Stat->I_status))>>16;

if(I_droopop_message&FITS_MSG_MASK)	{
I_droopop_message -= FITS_MSG_MASK;
}

droopop_decode_message(I_droopop_message, CP_Message);
droopop_decode_fcnname(I_droopop_root, CP_Function);

if (Stat->I_status)
{
printf("droopop Error Message      0x%04x: %s.\n", I_droopop_message, CP_Message);
printf("droopop Error in Function  0x%04x: %s.\n", I_droopop_root, CP_Function);
}


I_Time = clock();
printf("Processor Time = %5.3f seconds\n", (float)I_Time/CLOCKS_PER_SEC);

if(Stat->I_Verbose)
printf("droopop_error_handler: Exception Handler finished.\n");

}
