/* $Id: droopop_exec.c,v 1.11 2004/05/13 18:46:18 fan Exp $ */


/*********************************************** 
droopop_exec.c

Calls the initialization functions and main loop of program. Saves
output to a file.

Definitions of Variables in droopop_defs.h
 
***********************************************/

#include <time.h>         /* time() may need this */
#include <sys/types.h>    /* time() may need this */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "fitsio.h"
#include "droopop.h"
#include "droopop_errcodes.h"
#include "droopop_defs.h"

int main(int argc, char **argv) {			
float	*FP_Data_In=0;
float   *FP_Vars_In=0;
float   *FP_Refs_In=0;
float   *FP_Vars_Refs_In=0;
float   *Drp_Unc=0;
short   *SP_pmask=0;
short   *SP_dmask=0;
short   *SP_bmask=0;
short   *SP_cmask=0;
float  mainvalue;
int     i,j;

Filenames	Fnames;
Constants       Const;
Status		Stat;
Dims            Dim_In;
struct tm       *tmp_time;
time_t          L_time;

/* null filename pointers */

clock();

printf("Pipeline Module DROOPOP Version %2.1f\n", VERSN);

/* Calculate and print to standard out time
   Keep tmp_time and module time for time
   time stamping all output
*/
L_time = time(NULL);
tmp_time = localtime(&L_time);
printf("Processing time ");
printf(asctime(tmp_time));
printf("\n");

/* Set constant default values */
droopop_init_const( &Fnames, &Const, &Stat);

/* Parse the namelist file */
droopop_parse_namelist( argc, argv, &Const, &Fnames, &Stat);

/* Parse the command line, replacing values if specified */
droopop_parse_args( argc, argv, &Const, &Fnames, &Stat);

/* Get the data and keyword values from the input file */
droopop_read_data( &Fnames, &Dim_In, &FP_Data_In, &FP_Vars_In,
&FP_Refs_In, &FP_Vars_Refs_In, &Stat, &SP_pmask, &SP_dmask,
&SP_bmask, &SP_cmask);

/* Perform numerical computations on the data */
droopop_compute( &Fnames, &Const, &Dim_In, FP_Data_In, FP_Vars_In,
FP_Refs_In, FP_Vars_Refs_In, &Drp_Unc, &Stat, SP_pmask, SP_dmask, SP_bmask, SP_cmask);

/* Save the results as fits files. */			
droopop_output( &Fnames, &Const, &Dim_In, &Stat, tmp_time, SP_dmask,
FP_Data_In, FP_Vars_In, Drp_Unc );

/* Print filename, error message and timing data */
droopop_error_handler( &Stat, &Fnames);

/* Deallocate memory */			
droopop_exit( FP_Data_In, FP_Vars_In, FP_Refs_In, FP_Vars_Refs_In,
Drp_Unc, &Dim_In, &Stat, SP_pmask, SP_dmask, SP_bmask, SP_cmask);

printf("exit code %d\n", Stat.I_status);

/* Send return value */
exit(Stat.I_status);

}
