/* $Id: droopres_decode_fcnname.c,v 1.8 2002/09/04 22:07:33 fan Exp $ */


/*********************************************** 
droopres_decode_fcnname.c

Purpose

Given an function name code, write the appropriate
function name into a string.

Overview
Use a switch statement on the function name code.

Definitions of Variables

Input:
I_droopres_root = Code for function name.

Output:
CP_Function = Name of function.

Internal:


***********************************************/

#include <stdio.h>
#include "droopres.h"
#include "droopres_errcodes.h"
#include "droopres_defs.h"


droopres_decode_fcnname(	
            int       I_droopres_root,
            char      *CP_Function)
{

switch(I_droopres_root)	{
	case 0:
	sprintf(CP_Function, "%s", "No function"); break;
	case (LEFT_MASK&EXEC)>>16:
	sprintf(CP_Function, "%s", "EXEC"); break;
	case (LEFT_MASK&INIT_CONSTANTS)>>16:
	sprintf(CP_Function, "%s", "INIT_CONSTANTS"); break;
	case (LEFT_MASK&INIT)>>16:
	sprintf(CP_Function, "%s", "INIT"); break;
	case (LEFT_MASK&MKBASIS)>>16:
	sprintf(CP_Function, "%s", "MKBASIS"); break;
	case (LEFT_MASK&TRANSPMULT)>>16:
	sprintf(CP_Function, "%s", "TRANSPMULT"); break;
	case (LEFT_MASK&DETCOMP)>>16:
	sprintf(CP_Function, "%s", "DETCOMP"); break;
	case (LEFT_MASK&PSEUDOCOMP)>>16:
	sprintf(CP_Function, "%s", "PSEUDOCOMP"); break;
	case (LEFT_MASK&LOG_LIKELYHOOD)>>16:
	sprintf(CP_Function, "%s", "VEC_MULT"); break;
	case (LEFT_MASK&INNER_PROD)>>16:
	sprintf(CP_Function, "%s", "INNER_PROD"); break;
	case (LEFT_MASK&LL_COMP)>>16:
	sprintf(CP_Function, "%s", "SSORTP"); break;
	case (LEFT_MASK&READ_DATA)>>16:
	sprintf(CP_Function, "%s", "READ_DATA"); break;
	case (LEFT_MASK&OUTPUT_PROBS)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_PROBS"); break;
	case (LEFT_MASK&INIT_ALLOCATE)>>16:
	sprintf(CP_Function, "%s", "INIT_ALLOCATE"); break;
	case (LEFT_MASK&MAT_INVERT)>>16:
	sprintf(CP_Function, "%s", "MAT_INVERT"); break;
	case (LEFT_MASK&KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "KEYWORDS"); break;
	case (LEFT_MASK&STD_KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "STD_KEYWORDS"); break;
	case (LEFT_MASK&CONST_KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "CONST_KEYWORDS"); break;
	case (LEFT_MASK&FILEN_KEYWORDS)>>16:
	sprintf(CP_Function, "%s", "FILEN_KEYWORDS"); break;
	case (LEFT_MASK&NAMELIST)>>16:
	sprintf(CP_Function, "%s", "NAMELIST"); break;
	case (LEFT_MASK&OUTPUT_FLUXES)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_FLUXES"); break;
	case (LEFT_MASK&OUTPUT_MAGS)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_MAGS"); break;
	case (LEFT_MASK&OUTPUT_SAMPS)>>16:
	sprintf(CP_Function, "%s", "OUTPUT_SAMPS"); break;
	case (LEFT_MASK&PARSE_ARGS)>>16:
	sprintf(CP_Function, "%s", "PARSE_ARGS"); break;
        case (LEFT_MASK&COMPUTE)>>16:
        sprintf(CP_Function, "%s", "COMPUTE"); break;
	default: sprintf(CP_Function, "%s", "Unknown function.");
}

}





