/* $Id: droopres_defs.h,v 1.8 2002/09/04 22:07:33 fan Exp $ */


/***********************************************
droopres_defs.h

Purpose

Define structures.

Definitions of Variables

Filenames
      contains the various filenames.  Filenames are fairly
      self explanitory.

Status
      contains the flag to run in the verbose mode and
      the status flag used to store error messages


Dims
      contains the X and Y dimensions of the images

***********************************************/

typedef struct {

char	CP_Filename_Namelist[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_In[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_In[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Out[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_Out[MAX_FILENAME_LENGTH];
char	CP_Filename_Pmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Dmask[MAX_FILENAME_LENGTH];
char    CP_Filename_Cmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Bmask[MAX_FILENAME_LENGTH];
char    CP_Filename_Umask[MAX_FILENAME_LENGTH];

} Filenames;


typedef struct {

int	I_status;
int	I_Verbose;

} Status;


typedef struct {

int	I_NX;
int	I_NY;
int	I_NZ;

} Dims;


typedef struct {

int   Pix_Xmin;
int   Pix_Xmax;
int   Pix_Ymin;
int   Pix_Ymax;
int   PmaskFatal;
int   DmaskFatal;
int   CmaskFatal;
int   BmaskFatal;
int   In_Vars;
float Trim_Frac;
float Trim_STD_Frac;
float Drpres_chan1;
float Drpres_chan2;
float Drpres_chan3;
float Drpres_chan4;
float Drpresunc_chan1;
float Drpresunc_chan2;
float Drpresunc_chan3;
float Drpresunc_chan4;

} Constants;
