/* $Id: droopres_exit.c,v 1.8 2002/09/04 22:07:33 fan Exp $ */


/*********************************************** 
droopres_exit.c

Purpose

Cleanly exit the program.

Overview
Deallocate memory and print any diagnostics.

Definitions of Variables

Input:



Output:


Internal:


***********************************************/

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "fitsio.h"
#include "droopres.h"
#include "droopres_errcodes.h"
#include "droopres_defs.h"


droopres_exit(	
            float      *FPP_Data_In,
            float      *FPP_Vars_In,
            Dims       *Dim_In,
            Status     *Stat,
            short      *SPP_pmask,
            short      *SPP_dmask,
            short      *SPP_cmask,
            short      *SPP_bmask,
            short      *SPP_umask) {

/* Allocated in droopres_read_data */

if (FPP_Data_In != NULL) free(FPP_Data_In);
if (FPP_Vars_In != NULL) free(FPP_Vars_In);
if (SPP_pmask != NULL) free(SPP_pmask);
if (SPP_dmask != NULL) free(SPP_dmask);
if (SPP_cmask != NULL) free(SPP_cmask);
if (SPP_bmask != NULL) free(SPP_bmask);
if (SPP_umask != NULL) free(SPP_umask);

/* Set up exit status for Opus pipeline.
   For now any non zero status will be output
   as a failure.  There are no warnings.
*/

if(Stat->I_status)
  {
  Stat->I_status = 64;
  }

if(Stat->I_Verbose)
printf("droopres_exit: Memory Deallocated.\n");
}
