/* $Id: droopres_init_const.c,v 1.8 2002/09/04 22:07:33 fan Exp $ */


/*********************************************** 
droopres_init_const.c

Purpose

Set constant values as defined in the header file droopres.h.

Overview


Definitions of Variables

See "main" function droopres_exec.


***********************************************/

#include <stdio.h>
#include "droopres.h"
#include "droopres_errcodes.h"
#include "droopres_defs.h"

droopres_init_const(	
            Filenames	*Fnames,
            Constants   *Const,
            Status  	*Stat)
{

/* Initialize all status flags */
Stat->I_status = 0;
Stat->I_Verbose = 0;

Const->Pix_Xmin = 0;
Const->Pix_Xmax = 0;
Const->Pix_Ymin = 0;
Const->Pix_Ymax = 0;
Const->In_Vars = 0;
Const->Trim_Frac = 1.0;
Const->Trim_STD_Frac = 1.0;
Const->Drpres_chan1 = 0.0;
Const->Drpres_chan2 = 0.0;
Const->Drpres_chan3 = 0.0;
Const->Drpres_chan4 = 0.0;
Const->Drpresunc_chan1 = 0.0;
Const->Drpresunc_chan2 = 0.0;
Const->Drpresunc_chan3 = 0.0;
Const->Drpresunc_chan4 = 0.0;
Const->PmaskFatal = 32767;
Const->DmaskFatal = 32767;
Const->CmaskFatal = 32767;
Const->BmaskFatal = 32767;

sprintf(Fnames->CP_Filename_Pmask, "%s", "");
sprintf(Fnames->CP_Filename_Dmask, "%s", "");
sprintf(Fnames->CP_Filename_Cmask, "%s", "");
sprintf(Fnames->CP_Filename_Bmask, "%s", "");
sprintf(Fnames->CP_Filename_Umask, "%s", "");
sprintf(Fnames->CP_Filename_FITS_In, "%s", "");
sprintf(Fnames->CP_Filename_Vars_In, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Out, "%s", "");
sprintf(Fnames->CP_Filename_Vars_Out, "%s", "");
sprintf(Fnames->CP_Filename_Namelist, "%s", "");
}
