/***********************************************
flatap_defs.h

Purpose

Define structures.

Definitions of Variables

Filenames
      contains the various filenames.  Filenames are fairly
      self explanitory.

Status
      contains the flag to run in the verbose mode and
      the status flag used to store error messages


Dims
      contains the X and Y dimensions of the images

***********************************************/
#include "fitsio.h"

typedef struct {
  char	CP_Filename_Namelist[FLEN_FILENAME];
  char	CP_Filename_FITS_In[FLEN_FILENAME];
  char  insigma[FLEN_FILENAME];
  char  outsigma[FLEN_FILENAME];
  char  CP_Filename_FITS_Out[FLEN_FILENAME];
  char	CP_Filename_Pmask[FLEN_FILENAME];
  char	CP_Filename_Dmask[FLEN_FILENAME];
  char	CP_Filename_Cmask[FLEN_FILENAME];
  char	CP_Filename_Cmasktc[FLEN_FILENAME];
  char	CP_Filename_Flat[FLEN_FILENAME];
  char  CP_Filename_Flatsigma[FLEN_FILENAME];
  char	CP_Filename_Transcal[FLEN_FILENAME];
  char	CP_Filename_Log [FLEN_FILENAME];
} Filenames;


typedef struct {
  int   PmaskMask;
  int   DmaskMask;
  int   CmaskMask;
  int	I_status;
  int	I_Verbose;
  int   uncertainty;
} Status;

typedef struct {
  int	I_NX;
  int	I_NY;
  int	I_NZ;
} Dims;
