/*********************************************** 
flatap_init_constants.c

Purpose

Set constant values as defined in the header file flatap.h.

Revision History

  Jan-14-2004  W. Lee:  Added Log file per CR 6107.

Overview


Definitions of Variables

See "main" function flatap_exec.


***********************************************/

#include <stdio.h>
#include "flatap.h"
#include "flatap_defs.h"

int flatap_init_constants(	
            Filenames	*Fnames,
            Status  	*Stat,
	    Dims        *Dim_In)
{
  /* Initialize all status flags */
  
  Stat->I_status = 0;
  Stat->I_Verbose = 0;
  Stat->PmaskMask = 128;    /*  default bit 7 for pmask fatal */
  Stat->DmaskMask = 16384;  /*  default bit 14 for dmask fatal */
  Stat->CmaskMask = 256;    /*  default bit 8 for cmask fatal */   
  Stat->uncertainty = TRUE;

  Dim_In->I_NX = 0;
  Dim_In->I_NY = 0;
  Dim_In->I_NZ = 0;

  sprintf(Fnames->CP_Filename_Pmask, "%s", "");
  sprintf(Fnames->CP_Filename_Dmask, "%s", "");
  sprintf(Fnames->CP_Filename_Cmask, "%s", "");
  sprintf(Fnames->CP_Filename_Cmasktc, "%s", "");
  sprintf(Fnames->CP_Filename_FITS_In, "%s", "");
  sprintf(Fnames->CP_Filename_FITS_Out, "%s", "");
  sprintf(Fnames->CP_Filename_Namelist, "%s", "");
  sprintf(Fnames->CP_Filename_Flat, "%s", "");
  sprintf(Fnames->CP_Filename_Transcal, "%s", "");
  sprintf(Fnames->CP_Filename_Log, "%s", "");
  strcpy(Fnames->insigma, "");
  strcpy(Fnames->outsigma, "");
  
  return(0);
}
