#ifndef  FPGEN_H
#define  FPGEN_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <fitsio.h>


/*
 *  Defined data types and constants.
 */
#define  FAILURE_EXIT           64
#define  SUCCESS_EXIT           0
#define  WARNING_EXIT           32

#define  SUCCESS                1
#define  WARNING               -1
#define  FAILURE                0
#define  NO_ACTION             -2
#define  NO_VALUE              -3

#define  LONG_TEMP_STR_LEN      256
#define  MAX_CMNT_LEN           256
#define  MAX_FNAM_LEN           256
#define  MAX_PATH_LEN           256
#define  MAX_TEMPL_LINE_LEN     255
#define  SHORT_TEMP_STR_LEN     24
#define  MAX_KEYWORD_LEN        8
#define  MAX_KEYWD_CMNT         80
#define  MAX_SODB_LINE_LEN      512
#define  MAX_SODB_TBL_LEN       80
#define  MAX_SODB_VALUE_LEN     256
#define  PROG_VER_STR_LEN       32
#define  TEMP_LOG_SIZE          16384

#define  NO_MASK                0
#define  NOACTION               0
#define  PASSTHRU               1
#define  RENAME                 2
#define  DERIVED                3
#define  DATABASE               4
#define  NUM_ACTIONS            5
#define  NUM_DATA_TYPES         6

#define  BLNK_LINE              1
#define  CMNT_LINE              2
#define  HIST_LINE              3

#define  NOT_SET               -999


/*
 *  Defined data structure(s).
 */
struct  sodb_tbl  {
   char  keyword[MAX_KEYWORD_LEN + 1];
   char  table[MAX_SODB_TBL_LEN];
   char  field[MAX_SODB_TBL_LEN];
   char  type[MAX_SODB_TBL_LEN];
   char  value[MAX_SODB_VALUE_LEN];
};


/*
 *  Function prototypes.
 */
int  print_current_date_and_time();

int  parse_cmdln(int, char**, char*, char*, char*, char*,
                 char*, char*, int*, int*, int*);

void  print_cmdln_info();

int  read_namelist(char*, char*, char*, char*, char*,
                   char*, int*, int*, int*);

struct  sodb_tbl*  read_sodb_entries_file(char*, int*);

int  generate_final_product(char*, char*, char*,
                            struct  sodb_tbl*,
                            int, int, int);

int  parse_template_line(char*, char*, int*, int*, char*, char*, int*);

int  add_origin_and_creator_keywds(fitsfile*);

int  get_sodb_entry(struct  sodb_tbl*, int, int, char*, char*);

int  copy_history(fitsfile*, fitsfile*);

int  check_naxis_keywords(fitsfile*, fitsfile*, int*, char*, char*, long*);

int  copy_temp_to_out_hdr(fitsfile*, fitsfile*, char*);

int  copy_image_data(fitsfile*, fitsfile*, int, long);

size_t  LOCAL_COPY_OF_strlcpy(char*, const char*, size_t);

#endif

