      subroutine FitLin(PixDN,PixPln,PixErr,TopLayr,Slp,Sig,
     +                  SigTL,NPlns,NUse,Z,Weighting,Qmin,
     +                  Infl8,Gain,IzDN,BaseOnly,NSkip,
     +                  ChiSq,DegFrdm,Q,SigMin)
c
c    compute the mean pairwise slope between successive points in a two-
c     pass sigma-edited loop; return the value of the top layer
c
      real*4    PixDN(*), TopLayr, Slope, Sigma, Q, SigMin,
     +          Slp(2), Sig(2), SigTL, Z, PixPln(*), PixErr(*), Qmin,
     +          ChiSq, DegFrdm, GammQ, Gain, VarMin, SigmaU, SlopeU
      real*8    Sum, SumSq, SumWgt, Weight, DiffPln, DiffPix, Diff,
     +          SumSQU, SumSlopU
      integer*4 NPts, M, NSample, NPlns, NUse, NSkip
      logical   Weighting, Infl8, IzDN, BaseOnly(*)
c
c-------------------------------------------------------------------------
c
      If (Weighting) then
        PixErr(1) = (PixErr(1)                     ! Normalize to "per plane"
     +            /(PixPln(1) - Float(NSkip)))**2  !  and go to variance
        VarMin = 0.1*PixErr(1)
        If (NUse .gt. 1) then
          Do 100 NSample = 2, NUse
            If (IzDN) then
              PixErr(NSample) = (PixErr(NSample))**2
     +                        -  PixDN(NSample-1)/Gain
            Else
              PixErr(NSample) = (PixErr(NSample))**2
     +                        -  PixDN(NSample-1)
            End If
            PixErr(NSample) = PixErr(NSample)
     +                      /(PixPln(NSample) - PixPln(NSample-1))**2
            If (PixErr(NSample) .lt. VarMin)   ! Clip low results,
     +      PixErr(NSample) = VarMin           !  prevent negative var.
100       Continue
        End If
      End If
c
      Do 300 M = 1, 2
        Sum      = 0.0d0
        SumSq    = 0.0d0
        SumWgt   = 0.0d0
        SumSlopU = 0.0d0
        SumSQU   = 0.0d0
        NPts     = 0
c
        Do 200 NSample = 1, NUse
          If (BaseOnly(NSample)) go to 200 ! skip base-only sample
          If (NSample .gt. 1) then
            DiffPix = (PixDN(NSample) - PixDN(NSample-1))
            DiffPln = PixPln(NSample) - PixPln(NSample-1)
          Else
            DiffPix = PixDN(1)
            DiffPln = PixPln(1) - Float(NSkip)
          End If
          Diff = DiffPix/DiffPln
          If (M .gt. 1) Then
            If (Abs(Diff - SlopeU) .gt. Z*SigmaU) Go to 200
          End If
          NPts = NPts + 1
          SumSlopU = SumSLopU + Diff
          SumSQU = SumSQU + Dble(Diff*Diff)
          If (Weighting) then
            Weight = 1.0d0/PixErr(NSample)
            Sum    = Sum + Weight*Diff
            SumWgt = SumWgt + Weight
            SumSq = SumSq + Dble(Diff*Diff*Weight)
          Else
            Sum = Sum + Diff
            SumSq = SumSq + Dble(Diff*Diff)
          End If
200     Continue
c
        If (Weighting) then
          Slope = Sum/SumWgt
        Else
          Slope = Sum/DFloat(NPts)
        End If
        If (M .eq. 1) then
          SlopeU = SumSlopU/DFloat(NPts)
          SigmaU = sqrt(SumSQU/DFloat(NPts) - SlopeU**2)
        end if
c
        If (NPts .gt. 1) then
          If (Weighting) then
            Sigma = Sqrt(Abs(SumSq/SumWgt - Dble(Slope*Slope)))
          Else
            Sigma = Sqrt(Abs(SumSq/DFloat(NPts) - Dble(Slope*Slope)))
          End If
        Else
          If (Weighting) then
            Sigma = Sqrt(Abs(1.0/SumWgt))
          Else
            Sigma = Abs(Slope)                    ! 100% uncertainty
            If (Sigma .lt. SigMin) Sigma = SigMin ! (for now, at least)
          End If
        End If
        Slp(M) = Slope
        Sig(M) = Sigma
c
300   Continue
c
      TopLayr = Slope*Float(NPlns)              ! bias is said to be zero
c
      If (Weighting) then
        SigTL = Float(NPlns)/DSqrt(SumWgt)      ! usual reduced variance
      Else                                      !  scaled by NPlns
        if (NPts .gt. 1)                        ! convert to sigma of mean
     +      Sigma = Sigma/Sqrt(Float(NPts-1))   !  from est. pop. sigma
        SigTL = Float(NPlns)*Sigma              ! 100% correlated error in
      End If                                    !  scaling by NPlns
c
      If (Weighting) then
        If (NUse .gt. 1) then
          DegFrdm = - 1.0
          ChiSq   = 0.0
          Do 400 NSample = 1, NUse
            If (BaseOnly(NSample)) go to 400 ! skip base-only sample
            If (NSample .gt. 1) then
              DiffPix = (PixDN(NSample) - PixDN(NSample-1))
              DiffPln = PixPln(NSample) - PixPln(NSample-1)
            Else
              DiffPix = PixDN(1)
              DiffPln = PixPln(1) - Float(NSkip)
            End If
            Diff = DiffPix/DiffPln
            If (Abs(Diff - SlopeU) .gt. Z*SigmaU) Go to 400
            Weight = 1.0d0/PixErr(NSample)
            DegFrdm = DegFrdm + 1.0
            ChiSq = ChiSq + Weight*(Diff - Slope)**2
400       Continue
          If (DegFrdm .gt. 0.5) then  !  i.e., if DegFrdm > 0
            Q = Gammq(0.5*DegFrdm,0.5*ChiSq)
            If (Q .lt. Qmin) then
              SigTL = SigTL*sqrt(ChiSq/DegFrdm)
              Infl8 = .True.
            Else
              Infl8 = .False.
            End If
          Else      ! DegFrdm = 0 after all
            Infl8 = .False.
            Q = 0.0
          End If
        Else      ! NPts = 1
          Infl8 = .False.
          DegFrdm = 0.0
          ChiSq = 0.0
          Q = 0.0
        End If
      Else
        DegFrdm = NPts - 1
      End If
c
      return
c
      end
c
c=======================================================================
c
      FUNCTION gammq(a,x)
      REAL*4   a,gammq,x
CU    USES gcf,gser
      REAL gammcf,gamser,gln
      if((x .lt. 0.0) .or. (a .le. 0.0)) then
        print *,'ERROR: bad arguments in gammq'
        print *,'       x = ',x
        print *,'       a = ',a
        call exit(64)
      end if
      if(x.lt.a+1.)then
        call gser(gamser,a,x,gln)
        gammq=1.-gamser
      else
        call gcf(gammcf,a,x,gln)
        gammq=gammcf
      endif
      return
      END
c-----------------------------------------------------------------------
      SUBROUTINE gser(gamser,a,x,gln)
      INTEGER ITMAX
      REAL a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.e-7)
CU    USES gammln
      INTEGER n
      REAL ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
c       if(x.lt.0.)pause 'x < 0 in gser'
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      print *,'WARNING: a too large, ITMAX too small in gser'
      print *,'         a = ',a
      print *,'     ITMAX = ',ITMAX
1     gamser=sum*exp(-x+a*log(x)-gln)
      return
      END
c-----------------------------------------------------------------------
      SUBROUTINE gcf(gammcf,a,x,gln)
      INTEGER ITMAX
      REAL a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.e-7,FPMIN=1.e-30)
CU    USES gammln
      INTEGER i
      REAL an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      print *,'WARNING: a too large, ITMAX too small in gcf'
      print *,'         a = ',a
      print *,'     ITMAX = ',ITMAX
1     gammcf=exp(-x+a*log(x)-gln)*h
      return
      END
c-----------------------------------------------------------------------
      FUNCTION gammln(xx)
      REAL gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END
