      subroutine NonLin(DNonLin,DNLin,I,J,NLModel,NCols,NRows,
     +                  NPlanes,Satd,N,ModTyp,SigDNlin,
     +                  CMask,DMask,PMask,MaskC,MaskD,MaskP)
c
c -  convert input nonlinear DN "DNonLin" to linear output DN "DNLin"
c     for pixel (I,J)
c -  this version uses an IRAC-specific nonlinearity model, not
c     a polynomial (ModTyp = 1), and a quadratic model (ModTyp = 2)
c
      Integer*4 I,J,NPNL,NRows,NCols,NPlanes,FileID,N,
     +          IStat,ImClose,ImRPixR,ModTyp
      Integer*2 CMask(NCols,NRows),DMask(NCols,NRows,NPlanes),
     +          PMask(NCols,NRows),MaskC,MaskD,MaskP
      Logical   Satd,BitSet,LinProb
      Real*8    NLModel(NCols,NRows,*),DNonLin,DNLin,Model,SatLim,
     +          SigDNlin,SigMod2,SigMod3
c
c=======================================================================
c
      Satd = .False.
c
      If ((And(CMask(I,J),  MaskC) .ne. 0)  .or.
     +    (And(PMask(I,J),  MaskP) .ne. 0)  .or.
     +    (And(DMask(I,J,N),MaskD) .ne. 0)) Then
        DNLin = DNonLin
        Call SetBit(DMask(I,J,N),12)
        SigDNlin = DNlin  ! 100% uncertainty
        return
      End If
c
      If (ModTyp .eq. 1) then
        DNLin = Model(NLModel(I,J,1),NLModel(I,J,2),NLModel(I,J,3),
     +                DNonlin,1,LinProb)
        SatLim = NLModel(I,J,4)
        SigDNlin = 0.03*DNlin    !  hard-wired 3% for now
      Else If (ModTyp .eq. 2) then
        DNLin = Model(NLModel(I,J,1),NLModel(I,J,1),NLModel(I,J,1),
     +                DNonlin,2,LinProb)
        SatLim = NLModel(I,J,2)
        SigDNlin = SigMod2(NLModel(I,J,1),NLModel(I,J,3),DNlin)
      Else     ! ModTyp = 3
        DNLin = Model(NLModel(I,J,1),NLModel(I,J,2),NLModel(I,J,3),
     +                DNonlin,3,LinProb)
        SatLim = NLModel(I,J,4)
        SigDNlin = SigMod3(NLModel(I,J,1),DNlin)
      End If
c
c     Call SetBit(DMask(I,J,N),10)   ! removed 10/12/01
c
      If (LinProb) Call SetBit(DMask(I,J,N),12)
c
      If (DNonLin .ge. SatLim) Then
        If (DNLin .lt. DNonLin) DNLin = DNonLin     ! Don't permit turnover
        Call SetBit(DMask(I,J,N),13)
        If (N .eq. 1) then
          Satd = .True.
        Else
          Satd = .not.BitSet(DMask(I,J,N-1),13)
        End If
      End If
c
      Return
c
c-----------------------------------------------------------------------
c
      Entry NonLin0(NLModel,NCols,NRows,NPNL,FileID)
c
2100  IStat = ImRPixD(FileID,NLModel,NRows*NCols*NPNL)
      If (IStat .ne. NRows*NCols*NPNL) then
        print *,'ERROR: could not read nonlinearity model'
        print *,'       ImRPixD returned error code ',IStat
        call exit(64)
      end if
c
      IStat = ImClose(FileID)
      return
c
      end
c
c=======================================================================
c
      Logical Function BitSet(I2Var,NBit)
C-----------------------------------------------------------------------
C     Returns .TRUE. iff Bit no. "NBit" in "I2Var" is set (turned on)
C     LSB = bit no. 0, MSB = bit no. 14, Sign Bit = bit no. 15
C-----------------------------------------------------------------------
      Integer*4 NBit,NWarns
      Integer*2 I2Var,Power(16)
      Data NWarns/0/
C
C  Try these 2 changes - TYB 4/8/09
C
      Parameter (hexbit15 = Z'8000')
C
      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     + 16384,hexbit15/
C
C      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
C     + 16384,Z8000/
C-----------------------------------------------------------------------
C
      If ((NBit .lt. 0) .or. (NBit .gt. 15)) Then
        NWarns = NWarns + 1
        If (NWarns .le. 10) Write(6, 6000) NBit
        If (NWarns .eq. 10) Write(6, 6001)
        BitSet = .False.
        Return
      End If
C
C  Try this change - TYB 4/8/09
C
      BitSet = iand(I2Var, Power(NBit+1)) .ne. 0
C
C      BitSet = (I2Var .and. Power(NBit+1)) .ne. 0
C
      Return
C-----------------------------------------------------------------------
6000  Format(' BitSet: Warning! bit number outside range (0 - 15), ',
     + I21)
6001  Format('         This is the last warning that will be printed')
C-----------------------------------------------------------------------
      End
c
c=======================================================================
c
      Subroutine SetBit(I2Var,NBit)
C-----------------------------------------------------------------------
C     Set Bit no. "NBit" in "I2Var"
C     LSB = bit no. 0, MSB = bit no. 14, Sign Bit = bit no. 15
C-----------------------------------------------------------------------
      Integer*4 NBit,NWarns
      Integer*2 Power(16),I2Var
      Data NWarns/0/
C
C  Try these 2 changes - TYB 4/8/09
C
      Parameter (hexbit15 = Z'8000')
C
      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     + 16384,hexbit15/
C
C      Data Power/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
C     + 16384,Z8000/
C-----------------------------------------------------------------------
C
      If ((NBit .lt. 0) .or. (NBit .gt. 15)) Then
        NWarns = NWarns + 1
        If (NWarns .le. 10) Write(6, 6000) NBit
        If (NWarns .eq. 10) Write(6, 6001)
        Return
      End If
C
C  Try this change - TYB 4/8/09
C
      I2Var = ior(I2Var, Power(NBit+1))
C
C      I2Var = I2Var .or. Power(NBit+1)
C
      Return
C-----------------------------------------------------------------------
6000  Format(' SetBit: Warning! bit number outside range (0 - 15), ',
     + I21)
6001  Format('         This is the last warning that will be printed')
C-----------------------------------------------------------------------
      End
c
C=======================================================================
c
      Function Model(A,B,C,X,ITyp,LinProb)
c
      Real*8 A,B,C,F,Fp,Yn,Ynp1,X,Model,Arg
      Integer*4 ITyp, NWarn, J
      Logical LinProb
      Data NWarn/0/
c
      LinProb = .False.
      If (ITyp .eq. 1) then
        Arg = B - X
        If (X .ge. B) then
          LinProb = .True.
          Arg = 1.0
        End If
        Model = X*(C + A/dsqrt(Arg))
      Else If (ITyp .eq. 2) then
        Arg = 1.0 + 4.0*A*X
        If (Arg .lt. 0.0) then
          NWarn = NWarn + 1
          If (NWarn .le. 10) print *,'LINEARIZ/LINMODEL/MODEL WARNING:',
     +     ' negative argument of sqrt; abs used'
          If (NWarn .eq. 10) print *,
     +     '    Last warning for this failure mode'
          Arg = 0.0
          LinProb = .True.
        End If
        Model = 2.0*X/(1.0 + dsqrt(Arg))
      Else      ! ITyp = 3; Newton-Raphson inversion
        Yn = X/C   ! start with first guess = DNobs/C or ~ST
        Do 10 J = 1, 100
          F    = B*Yn*Yn*Yn + A*Yn*Yn + C*Yn - X
          Fp   = 3.0*B*Yn*Yn + 2.0*A*Yn + C
          Ynp1 = Yn - F/Fp
          If (dabs((Yn-Ynp1)/Yn) .lt. 1.0e-8) Go to 20
          Yn   = Ynp1
10      Continue
        LinProb = .True.
20      Model = C*Ynp1
      End If
c
      Return
      End
c
C=======================================================================
c                                              ! Note: this is the
      Function SigMod2(Alpha,SigAlpha,DNlin)   ! "Alpha" form of the
c                                              ! error model, no A,C
c
      Real*8 Alpha,SigAlpha,DNLin,SigMod2,Slope,SigW
c
      SigW = SigAlpha*DNlin**2
      Slope = 2.0*Alpha*DNlin + 1.0
      If (Slope .ne. 0.0) then
        SigMod2 = SigW/Slope
      Else
        SigMod2 = 99999.9
      End If
c
      Return
      End
c
C=======================================================================
c
      Function SigMod3(Array,DNlin)
c
      Real*8 DNLin,SigMod3,U,VarW,SigW,Slope,Array(10)
c
      If (Array(3) .eq. 0.0) then
        SigMod3 = 0.0
        Return
      Else
        U = DNLin/Array(3)
      End If
c
      VarW = Array(6)*Array(6)*U*U*U*U*U*U
     +     + 2.0*Array(8)*dabs(Array(8))*U*U*U*U*U
     +     + (Array(5)*Array(5) + 2.0*Array(10)*dabs(Array(10)))*U*U*U*U
     +     + 2.0*Array(9)*dabs(Array(9))*U*U*U + Array(7)*Array(7)*U*U
      SigW = dsqrt(dabs(VarW))
      If (VarW .lt. 0.0) SigW = -SigW    ! Should never happen, but flag
      Slope = (3.0*Array(2)*U*U + 2.0*Array(1)*U)/Array(3) + 1.0
      If (Slope .ne. 0.0) then
        SigMod3 = SigW/Slope
      Else
        SigMod3 = 99999.9
      End If
c
      Return
      End
