/*********************************************** 
allocate.cpp

Purpose

Allocate space for the variables.

Overview
Since allocate will be called multiple times for M_Initialize,
the allocation for M_Computation is split off as a separate function.

Definitions of Variables

External:
See radhit.h

Internal:


***********************************************/

#include <iostream>
#include <stdlib.h>

#include "more_includes.h"

int M_Initialize::allocate(	int		I_Num_Frames,
				M_Status	*GP_Stat)
{

if(GP_Stat->I_status) return(GP_Stat->I_status);

DP_Det_G = (double *) calloc(I_Num_Frames, sizeof(double));
FP_Mat_G = (float *) calloc(I_Num_Frames*I_Num_Frames*I_Num_Frames, sizeof(float));

if( DP_Det_G==NULL || FP_Mat_G==NULL )
GP_Stat->I_status = INIT_ALLOCATE|MALLOC_FAILED;

else if(GP_Stat->I_Debug)
printf("allocate: Memory Allocations succeeded for M_Initialize %d.\n", I_Num_Frames);

return(GP_Stat->I_status);
}


int M_Computation::allocate( M_Status	*GP_Stat)
{
if(GP_Stat->I_status) return(GP_Stat->I_status);

SP_MaskVector = (short *) calloc(I_Num_Frames, sizeof(short));
SP_SegmentVector = (short *) calloc(I_Num_Frames, sizeof(short));

IP_Declared_Position = (int *) calloc(I_Length_X*I_Length_Y, sizeof(int));
DP_Measured_Flux = (double *) calloc(I_Length_X*I_Length_Y, sizeof(double));
DP_Measured_Charge_Add = (double *) calloc(I_Length_X*I_Length_Y, sizeof(double));
DP_Probability_Radhit = (double *) calloc(I_Length_X*I_Length_Y, sizeof(double));

DP_Data_Vec_Charge = (double *) calloc(I_Num_Frames, sizeof(double));
DP_LLikelyhood = (double *) calloc(I_Num_Frames, sizeof(double));
DP_Fit_Vec_Charge = (double *) calloc(I_Num_Frames, sizeof(double));

data1 = (double *) calloc(I_Num_Frames*I_Length_X*I_Length_Y, sizeof(double));
data2 = (double *) calloc(I_Length_X*I_Length_Y, sizeof(double));
data3 = (double *) calloc(I_Length_X*I_Length_Y, sizeof(double));
data4 = (double *) calloc(I_Num_Frames*I_Length_X*I_Length_Y, sizeof(double));
data5 = (double *) calloc(I_Num_Frames*I_Length_X*I_Length_Y, sizeof(double));

//printf("allocate: %d\t0x%x\n", 10, data1);
//if(data1!=NULL) free(data1);
//printf("allocate: %d\t0x%x\n", 10, data1);
//data1 = NULL;

if(	SP_MaskVector==NULL		||
	SP_SegmentVector==NULL		||
	IP_Declared_Position==NULL	||
	DP_Measured_Flux==NULL		||
	DP_Measured_Charge_Add==NULL	||
	DP_Probability_Radhit==NULL	||
	DP_Data_Vec_Charge==NULL	||
	DP_LLikelyhood==NULL		||
	DP_Fit_Vec_Charge==NULL		||
	data1==NULL			||
	data2==NULL			||
	data3==NULL			||
	data4==NULL			||
	data5==NULL			)
GP_Stat->I_status = INIT_ALLOCATE|MALLOC_FAILED;
else if(GP_Stat->I_Verbose)
printf("allocate: Memory Allocations succeeded for M_Computation.\n");

  return(GP_Stat->I_status);
}





