/*********************************************** 
endpoints.c

Purpose

For ambiguous cases, examine the endpoints for radiation hits.

Overview
For the  endpoints, use the extreme two points to find the charge jump. 
Replace the values of the input added charge estimate, the flux, and the
maximum likelyhood position if the endpoint additional charge jump is greater
than the charge jump at the previous maximum likelyhood position.

Definitions of Variables

External:
See radhit.h

Internal:


***********************************************/

#include <iostream>

#include "more_includes.h"

	
int M_Computation::endpoints(	M_Status	*GP_Stat)
{
if(GP_Stat->I_status) return(GP_Stat->I_status);

if(	I_Max_LLikely_Position == I_NumSamples - 2 ||
	I_Max_LLikely_Position == 2) {

I_BestMaxLLPos = I_Max_LLikely_Position;
D_BestFlux = D_Meas_Flux;
D_BestChargeAdd = D_Meas_Charge_Add;
		
/* Check the far endpoint if ambiguity exists */
if(I_Max_LLikely_Position == I_NumSamples - 2)
endpoint_far( GP_Stat);
			
/* Check the near endpoint if ambiguity exists */
if(I_Max_LLikely_Position == 2)
endpoint_near( GP_Stat);

I_Max_LLikely_Position = I_BestMaxLLPos;
D_Meas_Flux = D_BestFlux;
D_Meas_Charge_Add = D_BestChargeAdd;
}

  return(GP_Stat->I_status);
}
