/*********************************************** 
maxll_findmax.c

Purpose

Find the index of the maximum likelyhood.

Overview
Run through the likelyhoods, keeping track of
the index of the highest value.

Definitions of Variables

External:
See radhit.h

Internal:
LP_Sorted_Indices = Array to hold sorted indices.
FP_LLikelyhood = Array of Likelyhoods.


***********************************************/

#include <iostream>
#include "mathc90.h"
#include <stdlib.h>

#include "more_includes.h"

extern "C" void ssortp(float*, int, int, long*); 

int M_Computation::maxll_findmax(	M_Initialize	*GP_Init,
					M_Status	*GP_Stat)
{
int	m;
//long	*LP_Sorted_Indices;
//float	*FP_LLikelyhood;
double  D_Max;

if(GP_Stat->I_status) return(GP_Stat->I_status);

/* Allocate memory for storing likelyhoods as single precision floats */
//FP_LLikelyhood = (float *) calloc(I_NumSamples, sizeof(float));

/* Set status if malloc failed */
//if(FP_LLikelyhood==NULL)
//{GP_Stat->I_status = MAXLL_FINDMAX|MALLOC_FAILED; return(GP_Stat->I_status);}

/* Sort function works with single-precision numbers */
//for(m=0;m<I_NumSamples;m++) FP_LLikelyhood[m] =(float) DP_LLikelyhood[m];

//if(GP_Stat->I_SuperVerbose)
//for(m=0;m<I_NumSamples;m++) 
//printf("maxll_findmax: DP_LLikelyhood[%d] = %e\n", m, DP_LLikelyhood[m]);

D_Max = DP_LLikelyhood[0];
for(m=1;m<I_NumSamples;m++)
if(DP_LLikelyhood[m] > D_Max)	{
D_Max = DP_LLikelyhood[m];
I_Max_LLikely_Position = m;
}

/* Allocate memory for sorted indices */
//LP_Sorted_Indices = (long *) calloc(I_NumSamples, sizeof(long));

/* Set status if malloc failed */
//if(LP_Sorted_Indices==NULL)
//{GP_Stat->I_status = MAXLL_FINDMAX|MALLOC_FAILED; return(GP_Stat->I_status);}

//ssortp(	FP_LLikelyhood,
//	3,
//	I_NumSamples-1,
//	LP_Sorted_Indices);

//if(GP_Stat->I_SuperVerbose)
//for(m=0;m<I_NumSamples;m++) 
//printf("maxll_findmax: LP_Sorted_Indices[%d] = %d\n", m, LP_Sorted_Indices[m]);

//I_Max_LLikely_Position = LP_Sorted_Indices[I_NumSamples-2] - 1;

if(GP_Stat->I_Debug)
printf("maxll_findmax: I_Max_LLikely_Position = %d\n", I_Max_LLikely_Position);

//free(FP_LLikelyhood);
//free(LP_Sorted_Indices);

//printf("maxll_findmax end.\n");

  return(GP_Stat->I_status);
}





