/**** ps_skyplot  plot a postscript file in skyview */

/***********
UPDATES

000306 Bob added iub=90
000306 Bob added exit(0) at very end
************/

main(argc, argv)
int argc;
char **argv;
{
   int i, j, iub, stat, nparms, orderno_old=0, orderno;
   char psfile[256], *tablename;

   float x[256], y[256];

   iub=90;

   if (argc != 3)
   {
      printf("Usage: ps_skyplot sampletable output.ps\n");
      exit(1);
   }

   tablename = argv[1];
   topenr(iub, tablename, &nparms);

   if (itstat() != 0)
   {
      printf("Error open file '%s'\n", tablename);
      exit(0);
   }

   *psfile = '\0';
   strcpy(psfile, argv[2]);

   ps_init();

   stat = ps_open("Contour Plot", psfile);
   if(stat < 0)
   {
       printf("ps_skyplot: '%s' -- invalid PostScript file path\n", psfile);
       exit(1);
   }
   
   ps_wind(0., 128., 0., 128.);

   i = 0;
   while(1)
   {
      tblread(iub);

      if (itstat() < 0) break;
      if (itstat() > 0)
      {
	 printf("Table I/O Error\n");
	 exit(1);
      }
      
      tgeti(iub, 0, &orderno);
      if (orderno != orderno_old)
      {
	 ps_polyline(i,x,y);
	 i=0;
      }
      
      orderno_old = orderno;
      tgetr(iub, 6, &x[i]);
      tgetr(iub, 7, &y[i]);
      i++;
   }

   ps_polyline(i, x, y);
   ps_close();

   exit(0);
}
