

/***********************************************
rowdroop_defs.h

Purpose

Define structures.

Definitions of Variables

Filenames
      contains the various filenames.  Filenames are fairly
      self explanitory.

Status
      contains the flag to run in the verbose mode and
      the status flag used to store error messages


Dims
      contains the X and Y Z dimensions of the images

***********************************************/

typedef struct {

char	CP_Filename_Namelist[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_In_AD[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_Unc_In_AD[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_In[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_Unc_In[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Out[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Unc_Out[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Rd_Unc_Out[MAX_FILENAME_LENGTH];
char	CP_Filename_Pmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Dmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Bmask[MAX_FILENAME_LENGTH];
char    CP_Filename_Cmask[MAX_FILENAME_LENGTH];

} Filenames;


typedef struct {

int	I_status;
int	I_Verbose;

} Status;


typedef struct {

int	I_NX;
int	I_NY;
int	I_NZ;

} Dims;


typedef struct {

int    Rd_Unc_Fits;
int    DmaskFatal;
int    BmaskFatal;
int    CmaskFatal;
int    PmaskFatal;
float  rowdroop[4];
float  rowdroop_unc[4];

} Constants;
