

/*********************************************** 
rowdroop_init_const.c

Purpose

Set constant values as defined in the header file rowdroop.h.

Overview


Definitions of Variables

See "main" function rowdroop_exec.


***********************************************/

#include <stdio.h>
#include "rowdroop.h"
#include "rowdroop_errcodes.h"
#include "rowdroop_defs.h"

rowdroop_init_const(	
            Filenames	*Fnames,
            Constants   *Const,
            Status  	*Stat)
{

int i;

/* Initialize all status flags */
Stat->I_status = 0;
Stat->I_Verbose = 0;

Const->PmaskFatal = 0;
Const->DmaskFatal = 0;
Const->CmaskFatal = 0;
Const->Rd_Unc_Fits = 0;
for (i=0; i<4; i++) Const->rowdroop[i] =  0.0;
for (i=0; i<4; i++) Const->rowdroop_unc[i] =  0.0;

sprintf(Fnames->CP_Filename_Pmask, "%s", "");
sprintf(Fnames->CP_Filename_Dmask, "%s", "");
sprintf(Fnames->CP_Filename_Bmask, "%s", "");
sprintf(Fnames->CP_Filename_Cmask, "%s", "");

sprintf(Fnames->CP_Filename_FITS_In_AD, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Unc_In_AD, "%s", "");
sprintf(Fnames->CP_Filename_FITS_In, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Out, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Unc_In, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Unc_Out, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Rd_Unc_Out, "%s", "");
sprintf(Fnames->CP_Filename_Namelist, "%s", "");

}
