

/*********************************************** 
rowdroop_usage.c

Purpose
explain the command-line usage of rowdroop

Overview

***********************************************/

#include <stdio.h>
#include "rowdroop.h"
#include "rowdroop_errcodes.h"
#include "rowdroop_defs.h"


rowdroop_usage() {

      printf("Usage:\n\n");
      printf("Required arguments:\n");
      printf("-id	input filename where corrections will be applied (droop corrected image)\n");
      printf("-md	input filename used for computing the magnitude of the correction \n	(A-to-D saturation corrected image) \n");
      printf("-od	output image filename\n");
      printf("-r1	row droop coupling constant for channel 1\n");
      printf("-r2	row droop coupling constant for channel 2\n");
      printf("-r3	row droop coupling constant for channel 3\n");
      printf("-r4	row droop coupling constant for channel 4\n");
      printf("Optional arguments:\n");
      printf("-n	namelist filename\n"); 
      printf("-iu	input filename for uncertainty for droop corrected image\n");
      printf("-mu	input filename for uncertainty for A-to-D saturation corrected image\n");
      printf("-ou	output uncertainty image filename\n");
      printf("-ru	rowdroop unc output filename\n");
      printf("-u1	row droop coupling constant uncertainty for channel 1\n");
      printf("-u2	row droop coupling constant uncertainty for channel 2\n");
      printf("-u3	row droop coupling constant uncertainty for channel 3\n");
      printf("-u4	row droop coupling constant uncertainty for channel 4\n");
      printf("-b	bmask filename 'DCE pixel status'\n");
      printf("-d	dmask filename 'DCE pixel status'\n");
      printf("-p	pmask filename 'hardware status'\n");
      printf("-c	cmask filename 'calibration image status'\n");
      printf("-fb	bmask fatal bit template\n");
      printf("-fd	dmask fatal bit template\n");
      printf("-fp	pmask fatal bit template\n");
      printf("-fc	cmask fatal bit template\n");
      printf("-v	puts the code in verbose mode\n\n");

}
