/* $Id: slremov_defs.h,v 1.8 2005/02/01 18:01:52 fan Exp $ */


/***********************************************
slremov_defs.h

Purpose

Define structures.

Definitions of Variables

Filenames
      contains the various filenames.  Filenames are fairly
      self explanitory.

Status
      contains the flag to run in the verbose mode and
      the status flag used to store error messages


Dims
      contains the X and Y dimensions of the images

***********************************************/

typedef struct {

char	CP_Filename_Namelist[MAX_FILENAME_LENGTH];
char	CP_Filename_FITS_In[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_In[MAX_FILENAME_LENGTH];
char    CP_Filename_Const_In[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Out1[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_Out1[MAX_FILENAME_LENGTH];
char    CP_Filename_FITS_Out2[MAX_FILENAME_LENGTH];
char    CP_Filename_Vars_Out2[MAX_FILENAME_LENGTH];
char	CP_Filename_Pmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Dmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Bmask[MAX_FILENAME_LENGTH];
char    CP_Filename_Cmask[MAX_FILENAME_LENGTH];
char	CP_Filename_Lmask[MAX_FILENAME_LENGTH];

} Filenames;


typedef struct {

int	I_status;
int	I_Verbose;

} Status;

typedef struct {

int	I_NX;
int	I_NY;
int	I_NZ;

int     E_NX;
int     E_NY;
int     E_NZ;

int     L_NX;
int     L_NY;
int     L_NZ;

} Dims;


typedef struct {

int    PmaskFatal;
int    DmaskFatal;
int    CmaskFatal;
int    BmaskFatal;
int    In_Vars;
int    Hx_Center;
double SNR;
double Decay_Alpha[MAXROW];
double Decay_Eta[MAXROW];
double B0[MAXROW];
double B1[MAXROW];
double Stddev_B0[MAXROW];
double Stddev_B1[MAXROW];
double ScaleMedian[MAXLAYER];
double Slxslp[MAXLAYER];
double Slxicpt[MAXLAYER];
double Slyslp[MAXLAYER];
double Slyicpt[MAXLAYER];
int    Column_Cut;
int    Slruncor;
int    Slchinsq;
int    Noped;

} Constants;

