/* $Id: slremov_fitline.c,v 1.6 2004/05/13 19:26:39 fan Exp $ */


/*********************************************** 
slremov_fitline.c

Purpose

fit a line to input data.

***********************************************/

#include <stdio.h>
#include <math.h>
#include "slremov.h"
#include "slremov_defs.h"



slremov_fitline(	
            double          *FP_Col,
            double          *Row,
            double          *FP_Sig,
            int             dim,
            double          *slope,
            double          *intercept,
            double          *xsq,
            Constants       *Const,
            Status 	    *Stat)
{
int	i;
int     I_fits_return_status=0;
double  s, sx, sy, sxx, sxy, delta;
double  c_term, x2;

if(Stat->I_status) return;

s = 0.0;
sy = 0.0;
sx = 0.0;
sxx = 0.0;
sxy = 0.0;
for (i=0; i<dim; ++i) {
   s += 1.0/((*(FP_Sig + i))*(*(FP_Sig + i)));
   sy += (*(FP_Col + i))/((*(FP_Sig + i))*(*(FP_Sig + i)));
   sx += (*(Row + i))/((*(FP_Sig + i))*(*(FP_Sig + i)));
   sxx += (*(Row + i))*(*(Row + i))/((*(FP_Sig + i))*(*(FP_Sig + i)));
   sxy += (*(Row + i))*(*(FP_Col + i))/((*(FP_Sig + i))*(*(FP_Sig + i)));
}

delta = s*sxx - sx*sx;

if(delta == 0.0) {
   printf("slremov_fitline: error minimizing linear model\n");
   Stat->I_status = COMPUTE|MIN_ERROR;
   return;
}

*slope = (s*sxy - sx*sy)/delta;
*intercept = (sxx*sy - sx*sxy)/delta;

x2 = 0.0;
for (i=0; i<dim; ++i)
   x2 += (*(FP_Col + i) - *intercept - (*slope)*(*(Row + i)))*
         (*(FP_Col + i) - *intercept - (*slope)*(*(Row + i)))/
         ((*(FP_Sig + i))*(*(FP_Sig + i)));

*xsq = x2;

if(Stat->I_Verbose)
printf("slremov_fitline: linear fit completed.\n");

}
