/* $Id: slremov_init_constants.c,v 1.8 2005/02/01 18:01:52 fan Exp $ */


/*********************************************** 
slremov_init_constants.c

Purpose

Set constant values as defined in the header file slremov.h.

Overview


Definitions of Variables

See "main" function slremov_exec.


***********************************************/

#include <stdio.h>
#include "slremov.h"
#include "slremov_defs.h"

slremov_init_constants(	
            Filenames	*Fnames,
	    Constants   *Const,
            Status  	*Stat)
{

int i, j;

/* Initialize all status flags */
Stat->I_status = 0;
Stat->I_Verbose = 0;

sprintf(Fnames->CP_Filename_Pmask, "%s", "");
sprintf(Fnames->CP_Filename_Dmask, "%s", "");
sprintf(Fnames->CP_Filename_Bmask, "%s", "");
sprintf(Fnames->CP_Filename_Cmask, "%s", "");
sprintf(Fnames->CP_Filename_Lmask, "%s", "");
sprintf(Fnames->CP_Filename_FITS_In, "%s", "");
sprintf(Fnames->CP_Filename_Vars_In, "%s", "");
sprintf(Fnames->CP_Filename_Const_In, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Out1, "%s", "");
sprintf(Fnames->CP_Filename_Vars_Out1, "%s", "");
sprintf(Fnames->CP_Filename_FITS_Out2, "%s", "");
sprintf(Fnames->CP_Filename_Vars_Out2, "%s", "");
sprintf(Fnames->CP_Filename_Namelist, "%s", "");

Const->PmaskFatal = 32767;
Const->DmaskFatal = 32767;
Const->CmaskFatal = 32767;
Const->BmaskFatal = 32767;

Const->In_Vars = 0;
Const->Column_Cut = 84;
Const->SNR = 2.0;
Const->Hx_Center = 60;
Const->Slruncor = 0;
Const->Slchinsq = 0;
Const->Noped = 0;

for (i=0; i<MAXROW; ++i) {
   Const->Decay_Alpha[i] = 0.0;
   Const->Decay_Eta[i] = 1.0;
   Const->B0[i] = 0.0;
   Const->B1[i] = 0.0;
   Const->Stddev_B0[i] = 0.0;
   Const->Stddev_B1[i] = 0.0;
}

for (j=0; j<MAXLAYER; ++j) {
   Const->ScaleMedian[j] = 999999.9;
   Const->Slxslp[j] = 999999.9;
   Const->Slxicpt[j] = 999999.9;
   Const->Slyslp[j] = 999999.9;
   Const->Slyicpt[j] = 999999.9;
}

}
