# BKSUB pipeline wrapper

#==================================================================
# initialize
use strict;
require "$ENV{'CUPID'}/wrappers/wrapper_subs.pm"; # standard subroutines
initialize();

#==================================================================
# Run imsubtract to subtract the images
#STEP IMSUBTRACT Create background subtracted image
run_module("IMSUBTRACT imsubtract
IN  -i1      <INFILE1>  # Input FLUX1 datafile
IN  -i1_unc  <INFILE2>  # Input UNC1 datafile
IN  -i1_mask <INFILE3>  # Input MASK1 datafile
IN  -i2      <INFILE4>  # Input FLUX2 datafile
IN  -i2_unc  <INFILE5>  # Input UNC2 datafile
IN  -i2_mask <INFILE6>  # Input MASK2 datafile
OUT  -o      bksub.fits # Output FLUX datafile
OUT  -o_unc  bkunc.fits # Output UNC datafile
OUT  -o_mask bkmsk.fits # Output MASK datafile
");

#==================================================================
# print END message, update STATUS file,  and exit the program
terminate();
