# COADD pipeline wrapper

#==================================================================
# initialize
use strict;
require "$ENV{'CUPID'}/wrappers/wrapper_subs.pm"; # standard subroutines
initialize();
my $dir_include      = "$ENV{'CUPID'}/include"; # ancillary directory

#==================================================================
# Run coadd2d to coadd the bcd images
#STEP COADD2D Create coadded image
run_module("COADD2D coadd2d
CDF -n coadd2d.nl     # namelist file
IN  -di <INFILE2>     # list of input FLUX datafiles
OUT -do coa2d.fits    # Output FLUX datafile
OUT -so c2unc.fits    # Output UNC datafile
OUT -am c2msk.fits    # Output AMASK datafile
V   -h1 -             # copy header of first input file as header of output files
IN  -si <INFILE3>     # list of input UNC datafiles
IN  -bm <INFILE4>     # list of input BMASK datafiles
");

#==================================================================
# print END message, update STATUS file,  and exit the program
terminate();
