# CUTOUT pipeline wrapper

#=======================================================================
# initialize
use strict;
require "$ENV{'CUPID'}/wrappers/wrapper_subs.pm"; # standard subroutines
my $band = initialize();
terminate() if ($band != 0); # only for Short Low images
my $dir_include      = "$ENV{'CUPID'}/include"; # ancillary directory

#=======================================================================
#STEP BLUE do BLUE cutput
run_module("BLUE:CROP1 cropfits2
CDF -n  cropfits2_b.nl # namelist file
IN  -i <INFILE1> # Input FLUX datafile
OUT -o cropfits_b.fits # Output blue flux cutout
");
run_module("BLUE:CROP2 cropfits2
CDF -n  cropfits2_b.nl # namelist file
IN  -i <INFILE3> # Input BMASK datafile
OUT -o mskb.fits # Output BLUE bmask cutout
");
run_module("BLUE:CROP3 cropfits2
CDF -n  cropfits2_b.nl # namelist file
IN  -i <INFILE2> # Input UNC datafile
OUT -o cropfits_unc_b.fits # Output BLUE unc cutout
");
run_module("BLUE dntoflux
CDF -n  dntoflux_b.nl # namelist file
IN  -i cropfits_b.fits # Input BLUE flux cutout
OUT -o1 bcdb.fits # Output BLUE flux (calibrated) cutout
IN  -iu cropfits_unc_b.fits #  Input BLUE unc cutout
OUT -ou uncb.fits # Output BLUE unc (calibrated) cutout
IN  -id mskb.fits # Input BLUE bmask cutout
V   -a  $dir_include # location of ancillary directory
");

#=======================================================================
#STEP RED do RED cutput
run_module("RED:CROP1 cropfits2
CDF -n  cropfits2_r.nl # namelist file
IN  -i <INFILE1> # Input FLUX datafile
OUT -o cropfits_r.fits # Output RED flux cutout
");
run_module("RED:CROP2 cropfits2
CDF -n  cropfits2_r.nl # namelist file
IN  -i <INFILE3> # Input bmask datafile
OUT -o mskr.fits # Output RED bmask cutout
");
run_module("RED:CROP3 cropfits2
CDF -n  cropfits2_r.nl # namelist file
IN  -i <INFILE2> # Input UNC datafile
OUT -o cropfits_unc_r.fits # Output RED unc cutout
");
run_module("RED dntoflux
CDF -n  dntoflux_r.nl # namelist file
IN  -i cropfits_r.fits # Input RED flux cutout
OUT -o1 bcdr.fits # Output RED flux (calibrated) cutout
IN  -iu cropfits_unc_r.fits # Input RED unc cutout
OUT -ou uncr.fits # Output RED unc (calibrated) cutout
IN  -id mskr.fits # Input RED bmask cutout
V   -a  $dir_include # location of ancillary directory
");

#=======================================================================
# print END message, update STATUS file,  and exit the program
terminate();
